--
-- PostgreSQL database dump
--

-- Dumped from database version 9.3.4
-- Dumped by pg_dump version 9.3.4
-- Started on 2014-11-01 14:12:27

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 7 (class 2615 OID 106540)
-- Name: pm; Type: SCHEMA; Schema: -; Owner: PerlMongers
--

CREATE SCHEMA pm;


ALTER SCHEMA pm OWNER TO "PerlMongers";

SET search_path = pm, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 174 (class 1259 OID 106553)
-- Name: OHLCData; Type: TABLE; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE TABLE "OHLCData" (
    ohlc_id integer NOT NULL,
    "OHLCDataSetID" integer NOT NULL,
    "Date" character(20) NOT NULL,
    "EpochTime" integer NOT NULL,
    "Open" double precision NOT NULL,
    "High" double precision NOT NULL,
    "Low" double precision NOT NULL,
    "Close" double precision NOT NULL
);


ALTER TABLE pm."OHLCData" OWNER TO "PerlMongers";

--
-- TOC entry 172 (class 1259 OID 106543)
-- Name: OHLCDataSets; Type: TABLE; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE TABLE "OHLCDataSets" (
    "OHLCDataSetID" integer NOT NULL,
    "Name" character varying(50) NOT NULL,
    "Pair" character(6) NOT NULL,
    period smallint NOT NULL
);


ALTER TABLE pm."OHLCDataSets" OWNER TO "PerlMongers";

--
-- TOC entry 171 (class 1259 OID 106541)
-- Name: OHLCDataSets_OHLCDataSetID_seq; Type: SEQUENCE; Schema: pm; Owner: PerlMongers
--

CREATE SEQUENCE "OHLCDataSets_OHLCDataSetID_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pm."OHLCDataSets_OHLCDataSetID_seq" OWNER TO "PerlMongers";

--
-- TOC entry 1961 (class 0 OID 0)
-- Dependencies: 171
-- Name: OHLCDataSets_OHLCDataSetID_seq; Type: SEQUENCE OWNED BY; Schema: pm; Owner: PerlMongers
--

ALTER SEQUENCE "OHLCDataSets_OHLCDataSetID_seq" OWNED BY "OHLCDataSets"."OHLCDataSetID";


--
-- TOC entry 173 (class 1259 OID 106551)
-- Name: OHLCData_ohlc_id_seq; Type: SEQUENCE; Schema: pm; Owner: PerlMongers
--

CREATE SEQUENCE "OHLCData_ohlc_id_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pm."OHLCData_ohlc_id_seq" OWNER TO "PerlMongers";

--
-- TOC entry 1962 (class 0 OID 0)
-- Dependencies: 173
-- Name: OHLCData_ohlc_id_seq; Type: SEQUENCE OWNED BY; Schema: pm; Owner: PerlMongers
--

ALTER SEQUENCE "OHLCData_ohlc_id_seq" OWNED BY "OHLCData".ohlc_id;


--
-- TOC entry 1831 (class 2604 OID 106556)
-- Name: ohlc_id; Type: DEFAULT; Schema: pm; Owner: PerlMongers
--

ALTER TABLE ONLY "OHLCData" ALTER COLUMN ohlc_id SET DEFAULT nextval('"OHLCData_ohlc_id_seq"'::regclass);


--
-- TOC entry 1830 (class 2604 OID 106546)
-- Name: OHLCDataSetID; Type: DEFAULT; Schema: pm; Owner: PerlMongers
--

ALTER TABLE ONLY "OHLCDataSets" ALTER COLUMN "OHLCDataSetID" SET DEFAULT nextval('"OHLCDataSets_OHLCDataSetID_seq"'::regclass);


--
-- TOC entry 1953 (class 0 OID 106553)
-- Dependencies: 174
-- Data for Name: OHLCData; Type: TABLE DATA; Schema: pm; Owner: PerlMongers
--

INSERT INTO "OHLCData" VALUES (1, 37, '2010-01-03 17:02:00 ', 1262559720, 1.5914999999999999, 1.5958000000000001, 1.5900000000000001, 1.5929);
INSERT INTO "OHLCData" VALUES (2, 37, '2010-01-04 00:00:00 ', 1262584800, 1.5928, 1.5934999999999999, 1.5753999999999999, 1.5794999999999999);
INSERT INTO "OHLCData" VALUES (3, 37, '2010-01-05 00:00:00 ', 1262671200, 1.5795999999999999, 1.5832999999999999, 1.5701000000000001, 1.5708);
INSERT INTO "OHLCData" VALUES (4, 37, '2010-01-06 00:00:00 ', 1262757600, 1.5707, 1.5732999999999999, 1.5583, 1.5608);
INSERT INTO "OHLCData" VALUES (5, 37, '2010-01-07 00:00:00 ', 1262844000, 1.5607, 1.5643, 1.5577000000000001, 1.5631999999999999);
INSERT INTO "OHLCData" VALUES (6, 37, '2010-01-08 00:00:00 ', 1262930400, 1.5631999999999999, 1.5665, 1.556, 1.5566);
INSERT INTO "OHLCData" VALUES (7, 37, '2010-01-10 17:01:00 ', 1263164460, 1.5526, 1.5595000000000001, 1.5516000000000001, 1.5571999999999999);
INSERT INTO "OHLCData" VALUES (8, 37, '2010-01-11 00:00:00 ', 1263189600, 1.5570999999999999, 1.5650999999999999, 1.5568, 1.5618000000000001);
INSERT INTO "OHLCData" VALUES (9, 37, '2010-01-12 00:00:00 ', 1263276000, 1.5618000000000001, 1.5791999999999999, 1.5584, 1.5681);
INSERT INTO "OHLCData" VALUES (10, 37, '2010-01-13 00:00:00 ', 1263362400, 1.5680000000000001, 1.5766, 1.5622, 1.5631999999999999);
INSERT INTO "OHLCData" VALUES (11, 37, '2010-01-14 00:00:00 ', 1263448800, 1.5630999999999999, 1.5649, 1.5533999999999999, 1.5547);
INSERT INTO "OHLCData" VALUES (12, 37, '2010-01-15 00:00:00 ', 1263535200, 1.5548, 1.5593999999999999, 1.5522, 1.5584);
INSERT INTO "OHLCData" VALUES (13, 37, '2010-01-17 17:03:00 ', 1263769380, 1.5585, 1.5624, 1.5566, 1.5580000000000001);
INSERT INTO "OHLCData" VALUES (14, 37, '2010-01-18 00:00:00 ', 1263794400, 1.5581, 1.5606, 1.5503, 1.5580000000000001);
INSERT INTO "OHLCData" VALUES (15, 37, '2010-01-19 00:00:00 ', 1263880800, 1.5579000000000001, 1.5590999999999999, 1.5427, 1.5488999999999999);
INSERT INTO "OHLCData" VALUES (16, 37, '2010-01-20 00:00:00 ', 1263967200, 1.5489999999999999, 1.5543, 1.5426, 1.5427);
INSERT INTO "OHLCData" VALUES (17, 37, '2010-01-21 00:00:00 ', 1264053600, 1.5427999999999999, 1.5693999999999999, 1.5416000000000001, 1.5641);
INSERT INTO "OHLCData" VALUES (18, 37, '2010-01-22 00:00:00 ', 1264140000, 1.5641, 1.5706, 1.556, 1.5694999999999999);
INSERT INTO "OHLCData" VALUES (19, 37, '2010-01-24 17:01:00 ', 1264374060, 1.5666, 1.5694999999999999, 1.5607, 1.5621);
INSERT INTO "OHLCData" VALUES (20, 37, '2010-01-25 00:00:00 ', 1264399200, 1.5620000000000001, 1.5697000000000001, 1.5601, 1.5687);
INSERT INTO "OHLCData" VALUES (21, 37, '2010-01-26 00:00:00 ', 1264485600, 1.5687, 1.5747, 1.5570999999999999, 1.5602);
INSERT INTO "OHLCData" VALUES (22, 37, '2010-01-27 00:00:00 ', 1264572000, 1.5602, 1.5713999999999999, 1.5528, 1.5548999999999999);
INSERT INTO "OHLCData" VALUES (23, 37, '2010-01-28 00:00:00 ', 1264658400, 1.5548999999999999, 1.5669999999999999, 1.5495000000000001, 1.5633999999999999);
INSERT INTO "OHLCData" VALUES (24, 37, '2010-01-29 00:00:00 ', 1264744800, 1.5634999999999999, 1.569, 1.5573999999999999, 1.5681);
INSERT INTO "OHLCData" VALUES (25, 37, '2010-01-31 17:01:00 ', 1264978860, 1.5746, 1.5751999999999999, 1.5642, 1.5714999999999999);
INSERT INTO "OHLCData" VALUES (26, 37, '2010-02-01 00:00:00 ', 1265004000, 1.5714999999999999, 1.5821000000000001, 1.5587, 1.5805);
INSERT INTO "OHLCData" VALUES (27, 37, '2010-02-02 00:00:00 ', 1265090400, 1.5805, 1.5861000000000001, 1.5726, 1.5769);
INSERT INTO "OHLCData" VALUES (28, 37, '2010-02-03 00:00:00 ', 1265176800, 1.5767, 1.5819000000000001, 1.5712999999999999, 1.5769);
INSERT INTO "OHLCData" VALUES (29, 37, '2010-02-04 00:00:00 ', 1265263200, 1.5769, 1.595, 1.571, 1.5806);
INSERT INTO "OHLCData" VALUES (30, 37, '2010-02-05 00:00:00 ', 1265349600, 1.5803, 1.5863, 1.5730999999999999, 1.5745);
INSERT INTO "OHLCData" VALUES (31, 37, '2010-02-07 17:01:00 ', 1265583660, 1.5743, 1.5768, 1.5713999999999999, 1.5750999999999999);
INSERT INTO "OHLCData" VALUES (32, 37, '2010-02-08 00:00:00 ', 1265608800, 1.575, 1.5834999999999999, 1.5727, 1.5774999999999999);
INSERT INTO "OHLCData" VALUES (33, 37, '2010-02-09 00:00:00 ', 1265695200, 1.5773999999999999, 1.5782, 1.5670999999999999, 1.5713999999999999);
INSERT INTO "OHLCData" VALUES (34, 37, '2010-02-10 00:00:00 ', 1265781600, 1.5712999999999999, 1.5738000000000001, 1.5498000000000001, 1.5516000000000001);
INSERT INTO "OHLCData" VALUES (35, 37, '2010-02-11 00:00:00 ', 1265868000, 1.5517000000000001, 1.5528, 1.5335000000000001, 1.5375000000000001);
INSERT INTO "OHLCData" VALUES (36, 37, '2010-02-12 00:00:00 ', 1265954400, 1.5375000000000001, 1.5449999999999999, 1.5268999999999999, 1.5351999999999999);
INSERT INTO "OHLCData" VALUES (37, 37, '2010-02-14 17:01:00 ', 1266188460, 1.5331999999999999, 1.5361, 1.5318000000000001, 1.5330999999999999);
INSERT INTO "OHLCData" VALUES (38, 37, '2010-02-15 00:00:00 ', 1266213600, 1.5331999999999999, 1.5353000000000001, 1.5255000000000001, 1.5265);
INSERT INTO "OHLCData" VALUES (39, 37, '2010-02-16 00:00:00 ', 1266300000, 1.5265, 1.5290999999999999, 1.5194000000000001, 1.528);
INSERT INTO "OHLCData" VALUES (40, 37, '2010-02-17 00:00:00 ', 1266386400, 1.5279, 1.5284, 1.5113000000000001, 1.5150999999999999);
INSERT INTO "OHLCData" VALUES (41, 37, '2010-02-18 00:00:00 ', 1266472800, 1.5149999999999999, 1.5161, 1.5063, 1.5130999999999999);
INSERT INTO "OHLCData" VALUES (42, 37, '2010-02-19 00:00:00 ', 1266559200, 1.5130999999999999, 1.5168999999999999, 1.5095000000000001, 1.5141);
INSERT INTO "OHLCData" VALUES (43, 37, '2010-02-21 17:00:00 ', 1266793200, 1.5124, 1.5142, 1.5108999999999999, 1.5132000000000001);
INSERT INTO "OHLCData" VALUES (44, 37, '2010-02-22 00:00:00 ', 1266818400, 1.5132000000000001, 1.5156000000000001, 1.5087999999999999, 1.5119);
INSERT INTO "OHLCData" VALUES (45, 37, '2010-02-23 00:00:00 ', 1266904800, 1.5117, 1.522, 1.504, 1.5159);
INSERT INTO "OHLCData" VALUES (46, 37, '2010-02-24 00:00:00 ', 1266991200, 1.5159, 1.5266, 1.5111000000000001, 1.5164);
INSERT INTO "OHLCData" VALUES (47, 37, '2010-02-25 00:00:00 ', 1267077600, 1.5162, 1.5323, 1.5144, 1.5265);
INSERT INTO "OHLCData" VALUES (48, 37, '2010-02-26 00:00:00 ', 1267164000, 1.5264, 1.5291999999999999, 1.5178, 1.5222);
INSERT INTO "OHLCData" VALUES (49, 37, '2010-02-28 17:00:00 ', 1267398000, 1.5198, 1.5204, 1.5142, 1.5156000000000001);
INSERT INTO "OHLCData" VALUES (50, 37, '2010-03-01 00:00:00 ', 1267423200, 1.5156000000000001, 1.5174000000000001, 1.4988999999999999, 1.5054000000000001);
INSERT INTO "OHLCData" VALUES (51, 37, '2010-03-02 00:00:00 ', 1267509600, 1.5053000000000001, 1.5097, 1.4964999999999999, 1.5065999999999999);
INSERT INTO "OHLCData" VALUES (52, 37, '2010-03-03 00:00:00 ', 1267596000, 1.5065999999999999, 1.5168999999999999, 1.5048999999999999, 1.5163);
INSERT INTO "OHLCData" VALUES (53, 37, '2010-03-04 00:00:00 ', 1267682400, 1.5162, 1.5201, 1.5063, 1.5087999999999999);
INSERT INTO "OHLCData" VALUES (54, 37, '2010-03-05 00:00:00 ', 1267768800, 1.5088999999999999, 1.5092000000000001, 1.4943, 1.5004);
INSERT INTO "OHLCData" VALUES (55, 37, '2010-03-07 17:01:00 ', 1268002860, 1.5003, 1.5033000000000001, 1.4981, 1.5007999999999999);
INSERT INTO "OHLCData" VALUES (56, 37, '2010-03-08 00:00:00 ', 1268028000, 1.5006999999999999, 1.5018, 1.4964, 1.4972000000000001);
INSERT INTO "OHLCData" VALUES (57, 37, '2010-03-09 00:00:00 ', 1268114400, 1.4974000000000001, 1.498, 1.484, 1.4847999999999999);
INSERT INTO "OHLCData" VALUES (58, 37, '2010-03-10 00:00:00 ', 1268200800, 1.4849000000000001, 1.4959, 1.4804999999999999, 1.4916);
INSERT INTO "OHLCData" VALUES (59, 37, '2010-03-11 00:00:00 ', 1268287200, 1.4915, 1.4973000000000001, 1.4883999999999999, 1.4950000000000001);
INSERT INTO "OHLCData" VALUES (60, 37, '2010-03-12 00:00:00 ', 1268373600, 1.4951000000000001, 1.5044999999999999, 1.4930000000000001, 1.5042);
INSERT INTO "OHLCData" VALUES (61, 37, '2010-03-14 17:00:00 ', 1268604000, 1.4999, 1.5041, 1.4992000000000001, 1.5024999999999999);
INSERT INTO "OHLCData" VALUES (62, 37, '2010-03-15 00:00:00 ', 1268629200, 1.5025999999999999, 1.5034000000000001, 1.4944999999999999, 1.4962);
INSERT INTO "OHLCData" VALUES (63, 37, '2010-03-16 00:00:00 ', 1268715600, 1.4963, 1.5054000000000001, 1.4928999999999999, 1.4995000000000001);
INSERT INTO "OHLCData" VALUES (64, 37, '2010-03-17 00:00:00 ', 1268802000, 1.4995000000000001, 1.5013000000000001, 1.4859, 1.4867999999999999);
INSERT INTO "OHLCData" VALUES (65, 37, '2010-03-18 00:00:00 ', 1268888400, 1.4866999999999999, 1.4876, 1.4759, 1.478);
INSERT INTO "OHLCData" VALUES (66, 37, '2010-03-19 00:00:00 ', 1268974800, 1.4779, 1.4796, 1.4716, 1.4775);
INSERT INTO "OHLCData" VALUES (67, 37, '2010-03-21 17:01:00 ', 1269208860, 1.4782, 1.4801, 1.4764999999999999, 1.4785999999999999);
INSERT INTO "OHLCData" VALUES (68, 37, '2010-03-22 00:00:00 ', 1269234000, 1.4786999999999999, 1.4850000000000001, 1.4751000000000001, 1.4777);
INSERT INTO "OHLCData" VALUES (69, 37, '2010-03-23 00:00:00 ', 1269320400, 1.4778, 1.478, 1.4659, 1.4669000000000001);
INSERT INTO "OHLCData" VALUES (70, 37, '2010-03-24 00:00:00 ', 1269406800, 1.4669000000000001, 1.4695, 1.4605999999999999, 1.4630000000000001);
INSERT INTO "OHLCData" VALUES (71, 37, '2010-03-25 00:00:00 ', 1269493200, 1.4629000000000001, 1.4673, 1.4598, 1.4661);
INSERT INTO "OHLCData" VALUES (72, 37, '2010-03-26 00:00:00 ', 1269579600, 1.4661999999999999, 1.4867999999999999, 1.4634, 1.4829000000000001);
INSERT INTO "OHLCData" VALUES (73, 37, '2010-03-28 17:02:00 ', 1269813720, 1.4881, 1.4910000000000001, 1.4793000000000001, 1.4796);
INSERT INTO "OHLCData" VALUES (74, 37, '2010-03-29 00:00:00 ', 1269838800, 1.4795, 1.4799, 1.4669000000000001, 1.4676);
INSERT INTO "OHLCData" VALUES (75, 37, '2010-03-30 00:00:00 ', 1269925200, 1.4677, 1.4704999999999999, 1.4577, 1.4641999999999999);
INSERT INTO "OHLCData" VALUES (76, 37, '2010-03-31 00:00:00 ', 1270011600, 1.4641999999999999, 1.4769000000000001, 1.4635, 1.4733000000000001);
INSERT INTO "OHLCData" VALUES (77, 37, '2010-04-01 00:00:00 ', 1270098000, 1.4734, 1.4770000000000001, 1.4673, 1.4754);
INSERT INTO "OHLCData" VALUES (78, 37, '2010-04-02 00:00:00 ', 1270184400, 1.4754, 1.4775, 1.4659, 1.4686999999999999);
INSERT INTO "OHLCData" VALUES (79, 37, '2010-04-04 17:00:00 ', 1270418400, 1.4663999999999999, 1.4691000000000001, 1.4645999999999999, 1.4678);
INSERT INTO "OHLCData" VALUES (80, 37, '2010-04-05 00:01:00 ', 1270443660, 1.4679, 1.4682999999999999, 1.4603999999999999, 1.4631000000000001);
INSERT INTO "OHLCData" VALUES (81, 37, '2010-04-06 00:00:00 ', 1270530000, 1.4631000000000001, 1.4650000000000001, 1.4403999999999999, 1.4432);
INSERT INTO "OHLCData" VALUES (82, 37, '2010-04-07 00:00:00 ', 1270616400, 1.4432, 1.4461999999999999, 1.4345000000000001, 1.4368000000000001);
INSERT INTO "OHLCData" VALUES (83, 37, '2010-04-08 00:01:00 ', 1270702860, 1.4367000000000001, 1.4422999999999999, 1.4359, 1.4396);
INSERT INTO "OHLCData" VALUES (84, 37, '2010-04-09 00:00:00 ', 1270789200, 1.4397, 1.4464999999999999, 1.4365000000000001, 1.4455);
INSERT INTO "OHLCData" VALUES (85, 37, '2010-04-11 17:03:00 ', 1271023380, 1.4547000000000001, 1.4622999999999999, 1.4517, 1.4618);
INSERT INTO "OHLCData" VALUES (86, 37, '2010-04-12 00:00:00 ', 1271048400, 1.462, 1.4704999999999999, 1.4609000000000001, 1.4702999999999999);
INSERT INTO "OHLCData" VALUES (87, 37, '2010-04-13 00:00:00 ', 1271134800, 1.4702, 1.4718, 1.4624999999999999, 1.466);
INSERT INTO "OHLCData" VALUES (88, 37, '2010-04-14 00:00:00 ', 1271221200, 1.4661, 1.4662999999999999, 1.4559, 1.4602999999999999);
INSERT INTO "OHLCData" VALUES (89, 37, '2010-04-15 00:00:00 ', 1271307600, 1.4602999999999999, 1.4607000000000001, 1.45, 1.4567000000000001);
INSERT INTO "OHLCData" VALUES (90, 37, '2010-04-16 00:00:00 ', 1271394000, 1.4568000000000001, 1.4616, 1.4496, 1.4601999999999999);
INSERT INTO "OHLCData" VALUES (91, 37, '2010-04-18 17:03:00 ', 1271628180, 1.4616, 1.4648000000000001, 1.4582999999999999, 1.4641999999999999);
INSERT INTO "OHLCData" VALUES (92, 37, '2010-04-19 00:00:00 ', 1271653200, 1.4641999999999999, 1.4686999999999999, 1.4527000000000001, 1.4529000000000001);
INSERT INTO "OHLCData" VALUES (93, 37, '2010-04-20 00:00:00 ', 1271739600, 1.4529000000000001, 1.4532, 1.4393, 1.4396);
INSERT INTO "OHLCData" VALUES (94, 37, '2010-04-21 00:00:00 ', 1271826000, 1.4396, 1.4467000000000001, 1.4365000000000001, 1.4442999999999999);
INSERT INTO "OHLCData" VALUES (95, 37, '2010-04-22 00:00:00 ', 1271912400, 1.4443999999999999, 1.4454, 1.4278999999999999, 1.4345000000000001);
INSERT INTO "OHLCData" VALUES (96, 37, '2010-04-23 00:00:00 ', 1271998800, 1.4343999999999999, 1.4513, 1.4343999999999999, 1.4421999999999999);
INSERT INTO "OHLCData" VALUES (97, 37, '2010-04-25 17:02:00 ', 1272232920, 1.4411, 1.4440999999999999, 1.4396, 1.4399999999999999);
INSERT INTO "OHLCData" VALUES (98, 37, '2010-04-26 00:00:00 ', 1272258000, 1.4400999999999999, 1.4477, 1.4319, 1.4449000000000001);
INSERT INTO "OHLCData" VALUES (99, 37, '2010-04-27 00:00:00 ', 1272344400, 1.4449000000000001, 1.4480999999999999, 1.4311, 1.4326000000000001);
INSERT INTO "OHLCData" VALUES (100, 37, '2010-04-28 00:00:00 ', 1272430800, 1.4327000000000001, 1.4375, 1.4218999999999999, 1.4294);
INSERT INTO "OHLCData" VALUES (101, 37, '2010-04-29 00:00:00 ', 1272517200, 1.4293, 1.431, 1.4221999999999999, 1.4235);
INSERT INTO "OHLCData" VALUES (102, 37, '2010-04-30 00:00:00 ', 1272603600, 1.4236, 1.4414, 1.4231, 1.4377);
INSERT INTO "OHLCData" VALUES (103, 37, '2010-05-02 17:02:00 ', 1272837720, 1.4456, 1.4459, 1.4281999999999999, 1.4298999999999999);
INSERT INTO "OHLCData" VALUES (104, 37, '2010-05-03 00:00:00 ', 1272862800, 1.4298999999999999, 1.4317, 1.423, 1.4266000000000001);
INSERT INTO "OHLCData" VALUES (105, 37, '2010-05-04 00:00:00 ', 1272949200, 1.4266000000000001, 1.4345000000000001, 1.4220999999999999, 1.4259999999999999);
INSERT INTO "OHLCData" VALUES (106, 37, '2010-05-05 00:00:00 ', 1273035600, 1.4258, 1.4277, 1.4114, 1.4149);
INSERT INTO "OHLCData" VALUES (107, 37, '2010-05-06 00:00:00 ', 1273122000, 1.4148000000000001, 1.4363999999999999, 1.4055, 1.4241999999999999);
INSERT INTO "OHLCData" VALUES (108, 37, '2010-05-07 00:00:00 ', 1273208400, 1.4242999999999999, 1.4377, 1.4229000000000001, 1.4361999999999999);
INSERT INTO "OHLCData" VALUES (109, 37, '2010-05-09 17:02:00 ', 1273442520, 1.4333, 1.4406000000000001, 1.4266000000000001, 1.4329000000000001);
INSERT INTO "OHLCData" VALUES (110, 37, '2010-05-10 00:00:00 ', 1273467600, 1.4328000000000001, 1.4436, 1.4112, 1.4159999999999999);
INSERT INTO "OHLCData" VALUES (111, 37, '2010-05-11 00:00:00 ', 1273554000, 1.4158999999999999, 1.4220999999999999, 1.4093, 1.4135);
INSERT INTO "OHLCData" VALUES (112, 37, '2010-05-12 00:00:00 ', 1273640400, 1.4134, 1.4208000000000001, 1.4064000000000001, 1.407);
INSERT INTO "OHLCData" VALUES (113, 37, '2010-05-13 00:00:00 ', 1273726800, 1.4069, 1.4075, 1.3928, 1.3982000000000001);
INSERT INTO "OHLCData" VALUES (114, 37, '2010-05-14 00:00:00 ', 1273813200, 1.3980999999999999, 1.4034, 1.3926000000000001, 1.3944000000000001);
INSERT INTO "OHLCData" VALUES (115, 37, '2010-05-16 17:01:00 ', 1274047260, 1.3940999999999999, 1.4054, 1.3937999999999999, 1.4049);
INSERT INTO "OHLCData" VALUES (116, 37, '2010-05-17 00:00:00 ', 1274072400, 1.4049, 1.4188000000000001, 1.3980999999999999, 1.4139999999999999);
INSERT INTO "OHLCData" VALUES (117, 37, '2010-05-18 00:00:00 ', 1274158800, 1.4140999999999999, 1.4274, 1.4084000000000001, 1.4239999999999999);
INSERT INTO "OHLCData" VALUES (118, 37, '2010-05-19 00:00:00 ', 1274245200, 1.4240999999999999, 1.4722999999999999, 1.4201999999999999, 1.4662999999999999);
INSERT INTO "OHLCData" VALUES (119, 37, '2010-05-20 00:00:00 ', 1274331600, 1.4663999999999999, 1.5457000000000001, 1.4643999999999999, 1.5206999999999999);
INSERT INTO "OHLCData" VALUES (120, 37, '2010-05-21 00:00:00 ', 1274418000, 1.5206, 1.5303, 1.5044999999999999, 1.5093000000000001);
INSERT INTO "OHLCData" VALUES (121, 37, '2010-05-23 17:01:00 ', 1274652060, 1.5065, 1.5251999999999999, 1.5044, 1.5103);
INSERT INTO "OHLCData" VALUES (122, 37, '2010-05-24 00:00:00 ', 1274677200, 1.5102, 1.5121, 1.4857, 1.5018);
INSERT INTO "OHLCData" VALUES (123, 37, '2010-05-25 00:00:00 ', 1274763600, 1.5019, 1.5142, 1.4887999999999999, 1.4892000000000001);
INSERT INTO "OHLCData" VALUES (124, 37, '2010-05-26 00:00:00 ', 1274850000, 1.4893000000000001, 1.494, 1.4598, 1.4782999999999999);
INSERT INTO "OHLCData" VALUES (125, 37, '2010-05-27 00:00:00 ', 1274936400, 1.4784999999999999, 1.4785999999999999, 1.4433, 1.4460999999999999);
INSERT INTO "OHLCData" VALUES (126, 37, '2010-05-28 00:00:00 ', 1275022800, 1.446, 1.4607000000000001, 1.4448000000000001, 1.4478);
INSERT INTO "OHLCData" VALUES (127, 37, '2010-05-30 17:02:00 ', 1275256920, 1.4499, 1.4564999999999999, 1.4492, 1.4503999999999999);
INSERT INTO "OHLCData" VALUES (128, 37, '2010-05-31 00:00:00 ', 1275282000, 1.4503999999999999, 1.4665999999999999, 1.4471000000000001, 1.4656);
INSERT INTO "OHLCData" VALUES (129, 37, '2010-06-01 00:00:00 ', 1275368400, 1.4657, 1.4734, 1.4568000000000001, 1.4677);
INSERT INTO "OHLCData" VALUES (130, 37, '2010-06-02 00:00:00 ', 1275454800, 1.4678, 1.4731000000000001, 1.4492, 1.4508000000000001);
INSERT INTO "OHLCData" VALUES (131, 37, '2010-06-03 00:00:00 ', 1275541200, 1.4505999999999999, 1.4537, 1.4380999999999999, 1.4430000000000001);
INSERT INTO "OHLCData" VALUES (132, 37, '2010-06-04 00:00:00 ', 1275627600, 1.4431, 1.4574, 1.4345000000000001, 1.4529000000000001);
INSERT INTO "OHLCData" VALUES (133, 37, '2010-06-06 17:02:00 ', 1275861720, 1.4538, 1.4686999999999999, 1.4512, 1.4631000000000001);
INSERT INTO "OHLCData" VALUES (134, 37, '2010-06-07 00:00:00 ', 1275886800, 1.4631000000000001, 1.4738, 1.4567000000000001, 1.4601);
INSERT INTO "OHLCData" VALUES (135, 37, '2010-06-08 00:00:00 ', 1275973200, 1.4601, 1.4655, 1.4420999999999999, 1.454);
INSERT INTO "OHLCData" VALUES (136, 37, '2010-06-09 00:00:00 ', 1276059600, 1.4539, 1.4561999999999999, 1.4322999999999999, 1.4347000000000001);
INSERT INTO "OHLCData" VALUES (137, 37, '2010-06-10 00:00:00 ', 1276146000, 1.4348000000000001, 1.4400999999999999, 1.4240999999999999, 1.4291);
INSERT INTO "OHLCData" VALUES (138, 37, '2010-06-11 00:00:00 ', 1276232400, 1.4291, 1.4357, 1.4206000000000001, 1.4238999999999999);
INSERT INTO "OHLCData" VALUES (139, 37, '2010-06-13 17:02:00 ', 1276466520, 1.4213, 1.4275, 1.421, 1.4225000000000001);
INSERT INTO "OHLCData" VALUES (140, 37, '2010-06-14 00:00:00 ', 1276491600, 1.4226000000000001, 1.4274, 1.4151, 1.4246000000000001);
INSERT INTO "OHLCData" VALUES (141, 37, '2010-06-15 00:00:00 ', 1276578000, 1.4245000000000001, 1.4330000000000001, 1.4229000000000001, 1.4242999999999999);
INSERT INTO "OHLCData" VALUES (142, 37, '2010-06-16 00:00:00 ', 1276664400, 1.4244000000000001, 1.4297, 1.4212, 1.4272);
INSERT INTO "OHLCData" VALUES (143, 37, '2010-06-17 00:00:00 ', 1276750800, 1.4272, 1.4363999999999999, 1.4240999999999999, 1.4246000000000001);
INSERT INTO "OHLCData" VALUES (144, 37, '2010-06-18 00:00:00 ', 1276837200, 1.4247000000000001, 1.4298, 1.4182999999999999, 1.4202999999999999);
INSERT INTO "OHLCData" VALUES (145, 37, '2010-06-20 17:04:00 ', 1277071440, 1.4112, 1.4155, 1.4074, 1.4099999999999999);
INSERT INTO "OHLCData" VALUES (146, 37, '2010-06-21 00:00:00 ', 1277096400, 1.4098999999999999, 1.4119999999999999, 1.3987000000000001, 1.4007000000000001);
INSERT INTO "OHLCData" VALUES (147, 37, '2010-06-22 00:00:00 ', 1277182800, 1.4008, 1.4105000000000001, 1.3960999999999999, 1.4066000000000001);
INSERT INTO "OHLCData" VALUES (148, 37, '2010-06-23 00:00:00 ', 1277269200, 1.4064000000000001, 1.4134, 1.3999999999999999, 1.4100999999999999);
INSERT INTO "OHLCData" VALUES (149, 37, '2010-06-24 00:00:00 ', 1277355600, 1.4101999999999999, 1.4279999999999999, 1.4091, 1.4279999999999999);
INSERT INTO "OHLCData" VALUES (150, 37, '2010-06-25 00:00:00 ', 1277442000, 1.4279999999999999, 1.4318, 1.4133, 1.4148000000000001);
INSERT INTO "OHLCData" VALUES (151, 37, '2010-06-27 17:02:00 ', 1277676120, 1.4157999999999999, 1.4191, 1.4117, 1.4137);
INSERT INTO "OHLCData" VALUES (152, 37, '2010-06-28 00:00:00 ', 1277701200, 1.4137999999999999, 1.4179999999999999, 1.4056, 1.4144000000000001);
INSERT INTO "OHLCData" VALUES (153, 37, '2010-06-29 00:00:00 ', 1277787600, 1.4145000000000001, 1.4392, 1.4128000000000001, 1.4351);
INSERT INTO "OHLCData" VALUES (154, 37, '2010-06-30 00:00:00 ', 1277874000, 1.4350000000000001, 1.4673, 1.4285000000000001, 1.4651000000000001);
INSERT INTO "OHLCData" VALUES (155, 37, '2010-07-01 00:00:00 ', 1277960400, 1.4650000000000001, 1.4927999999999999, 1.4576, 1.4757);
INSERT INTO "OHLCData" VALUES (156, 37, '2010-07-02 00:00:00 ', 1278046800, 1.4756, 1.4943, 1.4733000000000001, 1.4923999999999999);
INSERT INTO "OHLCData" VALUES (157, 37, '2010-07-04 17:01:00 ', 1278280860, 1.4913000000000001, 1.4974000000000001, 1.4838, 1.4869000000000001);
INSERT INTO "OHLCData" VALUES (158, 37, '2010-07-05 00:00:00 ', 1278306000, 1.4870000000000001, 1.5013000000000001, 1.4809000000000001, 1.4965999999999999);
INSERT INTO "OHLCData" VALUES (159, 37, '2010-07-06 00:00:00 ', 1278392400, 1.4965999999999999, 1.4982, 1.4737, 1.4839);
INSERT INTO "OHLCData" VALUES (160, 37, '2010-07-07 00:00:00 ', 1278478800, 1.4839, 1.4870000000000001, 1.4477, 1.4489000000000001);
INSERT INTO "OHLCData" VALUES (161, 37, '2010-07-08 00:00:00 ', 1278565200, 1.4489000000000001, 1.4557, 1.4438, 1.446);
INSERT INTO "OHLCData" VALUES (162, 37, '2010-07-09 00:00:00 ', 1278651600, 1.4460999999999999, 1.4516, 1.4383999999999999, 1.4399);
INSERT INTO "OHLCData" VALUES (163, 37, '2010-07-11 17:01:00 ', 1278885660, 1.4395, 1.4447000000000001, 1.4378, 1.4381999999999999);
INSERT INTO "OHLCData" VALUES (164, 37, '2010-07-12 00:00:00 ', 1278910800, 1.4380999999999999, 1.4449000000000001, 1.4342999999999999, 1.4421999999999999);
INSERT INTO "OHLCData" VALUES (165, 37, '2010-07-13 00:00:00 ', 1278997200, 1.4421999999999999, 1.4457, 1.4329000000000001, 1.4419);
INSERT INTO "OHLCData" VALUES (166, 37, '2010-07-14 00:00:00 ', 1279083600, 1.4419999999999999, 1.4487000000000001, 1.4373, 1.4452);
INSERT INTO "OHLCData" VALUES (167, 37, '2010-07-15 00:00:00 ', 1279170000, 1.4453, 1.4739, 1.4449000000000001, 1.4723999999999999);
INSERT INTO "OHLCData" VALUES (168, 37, '2010-07-16 00:00:00 ', 1279256400, 1.4723999999999999, 1.4898, 1.4699, 1.4875);
INSERT INTO "OHLCData" VALUES (169, 37, '2010-07-18 17:01:00 ', 1279490460, 1.4894000000000001, 1.4933000000000001, 1.4861, 1.4877);
INSERT INTO "OHLCData" VALUES (170, 37, '2010-07-19 00:00:00 ', 1279515600, 1.4877, 1.4970000000000001, 1.4755, 1.4777);
INSERT INTO "OHLCData" VALUES (171, 37, '2010-07-20 00:00:00 ', 1279602000, 1.4776, 1.4797, 1.4559, 1.4613);
INSERT INTO "OHLCData" VALUES (172, 37, '2010-07-21 00:00:00 ', 1279688400, 1.4614, 1.4623999999999999, 1.4458, 1.4596);
INSERT INTO "OHLCData" VALUES (173, 37, '2010-07-22 00:00:00 ', 1279774800, 1.4596, 1.4601999999999999, 1.4411, 1.4454);
INSERT INTO "OHLCData" VALUES (174, 37, '2010-07-23 00:00:00 ', 1279861200, 1.4454, 1.4500999999999999, 1.4331, 1.4409000000000001);
INSERT INTO "OHLCData" VALUES (175, 37, '2010-07-25 17:01:00 ', 1280095260, 1.4383999999999999, 1.4450000000000001, 1.4383999999999999, 1.4442999999999999);
INSERT INTO "OHLCData" VALUES (176, 37, '2010-07-26 00:00:00 ', 1280120400, 1.4441999999999999, 1.4449000000000001, 1.4365000000000001, 1.4419999999999999);
INSERT INTO "OHLCData" VALUES (177, 37, '2010-07-27 00:00:00 ', 1280206800, 1.4419999999999999, 1.4547000000000001, 1.4338, 1.4545999999999999);
INSERT INTO "OHLCData" VALUES (178, 37, '2010-07-28 00:00:00 ', 1280293200, 1.4544999999999999, 1.4599, 1.4500999999999999, 1.4511000000000001);
INSERT INTO "OHLCData" VALUES (179, 37, '2010-07-29 00:00:00 ', 1280379600, 1.4511000000000001, 1.4562999999999999, 1.4453, 1.4529000000000001);
INSERT INTO "OHLCData" VALUES (180, 37, '2010-07-30 00:00:00 ', 1280466000, 1.4528000000000001, 1.4538, 1.4377, 1.4424999999999999);
INSERT INTO "OHLCData" VALUES (181, 37, '2010-08-01 17:00:00 ', 1280700000, 1.4422999999999999, 1.4434, 1.4359999999999999, 1.4381999999999999);
INSERT INTO "OHLCData" VALUES (182, 37, '2010-08-02 00:00:00 ', 1280725200, 1.4380999999999999, 1.4481999999999999, 1.4303999999999999, 1.4472);
INSERT INTO "OHLCData" VALUES (183, 37, '2010-08-03 00:00:00 ', 1280811600, 1.4471000000000001, 1.4541999999999999, 1.4434, 1.4468000000000001);
INSERT INTO "OHLCData" VALUES (184, 37, '2010-08-04 00:00:00 ', 1280898000, 1.4468000000000001, 1.4515, 1.4336, 1.4365000000000001);
INSERT INTO "OHLCData" VALUES (185, 37, '2010-08-05 00:00:00 ', 1280984400, 1.4363999999999999, 1.4463999999999999, 1.4347000000000001, 1.4410000000000001);
INSERT INTO "OHLCData" VALUES (186, 37, '2010-08-06 00:00:00 ', 1281070800, 1.4410000000000001, 1.4530000000000001, 1.4345000000000001, 1.4459);
INSERT INTO "OHLCData" VALUES (187, 37, '2010-08-08 17:01:00 ', 1281304860, 1.4455, 1.4483999999999999, 1.4449000000000001, 1.4469000000000001);
INSERT INTO "OHLCData" VALUES (188, 37, '2010-08-09 00:00:00 ', 1281330000, 1.4469000000000001, 1.4474, 1.4394, 1.4408000000000001);
INSERT INTO "OHLCData" VALUES (189, 37, '2010-08-10 00:00:00 ', 1281416400, 1.4407000000000001, 1.4480999999999999, 1.4384999999999999, 1.4436);
INSERT INTO "OHLCData" VALUES (190, 37, '2010-08-11 00:00:00 ', 1281502800, 1.4437, 1.4468000000000001, 1.4293, 1.4391);
INSERT INTO "OHLCData" VALUES (191, 37, '2010-08-12 00:00:00 ', 1281589200, 1.4392, 1.4413, 1.4266000000000001, 1.4272);
INSERT INTO "OHLCData" VALUES (192, 37, '2010-08-13 00:00:00 ', 1281675600, 1.4271, 1.4297, 1.4215, 1.4278999999999999);
INSERT INTO "OHLCData" VALUES (193, 37, '2010-08-15 17:00:00 ', 1281909600, 1.4283999999999999, 1.4381999999999999, 1.4272, 1.4362999999999999);
INSERT INTO "OHLCData" VALUES (194, 37, '2010-08-16 00:00:00 ', 1281934800, 1.4362999999999999, 1.4407000000000001, 1.4254, 1.4258999999999999);
INSERT INTO "OHLCData" VALUES (195, 37, '2010-08-17 00:00:00 ', 1282021200, 1.4258, 1.429, 1.4179999999999999, 1.4238);
INSERT INTO "OHLCData" VALUES (196, 37, '2010-08-18 00:00:00 ', 1282107600, 1.4237, 1.4323999999999999, 1.4224000000000001, 1.4289000000000001);
INSERT INTO "OHLCData" VALUES (197, 37, '2010-08-19 00:00:00 ', 1282194000, 1.429, 1.4404999999999999, 1.4220999999999999, 1.4373);
INSERT INTO "OHLCData" VALUES (198, 37, '2010-08-20 00:00:00 ', 1282280400, 1.4372, 1.4413, 1.4211, 1.4216);
INSERT INTO "OHLCData" VALUES (199, 37, '2010-08-22 17:03:00 ', 1282514580, 1.4328000000000001, 1.4336, 1.4260999999999999, 1.4260999999999999);
INSERT INTO "OHLCData" VALUES (200, 37, '2010-08-23 00:00:00 ', 1282539600, 1.4261999999999999, 1.4278999999999999, 1.4139999999999999, 1.4217);
INSERT INTO "OHLCData" VALUES (201, 37, '2010-08-24 00:00:00 ', 1282626000, 1.4217, 1.4358, 1.4208000000000001, 1.4301999999999999);
INSERT INTO "OHLCData" VALUES (202, 37, '2010-08-25 00:00:00 ', 1282712400, 1.4302999999999999, 1.444, 1.4273, 1.4332);
INSERT INTO "OHLCData" VALUES (203, 37, '2010-08-26 00:00:00 ', 1282798800, 1.4332, 1.4362999999999999, 1.4262999999999999, 1.4342999999999999);
INSERT INTO "OHLCData" VALUES (204, 37, '2010-08-27 00:00:00 ', 1282885200, 1.4343999999999999, 1.4353, 1.4152, 1.4191);
INSERT INTO "OHLCData" VALUES (205, 37, '2010-08-29 17:01:00 ', 1283119260, 1.4144000000000001, 1.4177999999999999, 1.4112, 1.4172);
INSERT INTO "OHLCData" VALUES (206, 37, '2010-08-30 00:00:00 ', 1283144400, 1.4173, 1.4206000000000001, 1.4128000000000001, 1.4152);
INSERT INTO "OHLCData" VALUES (207, 37, '2010-08-31 00:00:00 ', 1283230800, 1.4154, 1.4331, 1.4088000000000001, 1.4129);
INSERT INTO "OHLCData" VALUES (208, 37, '2010-09-01 00:00:00 ', 1283317200, 1.4129, 1.4182999999999999, 1.4047000000000001, 1.4112);
INSERT INTO "OHLCData" VALUES (209, 37, '2010-09-02 00:00:00 ', 1283403600, 1.4112, 1.4128000000000001, 1.4049, 1.4118999999999999);
INSERT INTO "OHLCData" VALUES (210, 37, '2010-09-03 00:00:00 ', 1283490000, 1.4118999999999999, 1.4136, 1.3996, 1.4065000000000001);
INSERT INTO "OHLCData" VALUES (211, 37, '2010-09-05 17:00:00 ', 1283724000, 1.4077, 1.4092, 1.4051, 1.4056);
INSERT INTO "OHLCData" VALUES (212, 37, '2010-09-06 00:00:00 ', 1283749200, 1.4056999999999999, 1.4088000000000001, 1.3953, 1.3978999999999999);
INSERT INTO "OHLCData" VALUES (213, 37, '2010-09-07 00:00:00 ', 1283835600, 1.3977999999999999, 1.403, 1.3895, 1.3923000000000001);
INSERT INTO "OHLCData" VALUES (214, 37, '2010-09-08 00:00:00 ', 1283922000, 1.3922000000000001, 1.3934, 1.379, 1.3797999999999999);
INSERT INTO "OHLCData" VALUES (215, 37, '2010-09-09 00:00:00 ', 1284008400, 1.3797999999999999, 1.3803000000000001, 1.3708, 1.3749);
INSERT INTO "OHLCData" VALUES (216, 37, '2010-09-10 00:00:00 ', 1284094800, 1.3751, 1.3798999999999999, 1.3676999999999999, 1.3682000000000001);
INSERT INTO "OHLCData" VALUES (217, 37, '2010-09-12 17:01:00 ', 1284328860, 1.3673, 1.3751, 1.3657999999999999, 1.3741000000000001);
INSERT INTO "OHLCData" VALUES (218, 37, '2010-09-13 00:00:00 ', 1284354000, 1.3740000000000001, 1.3799999999999999, 1.3717999999999999, 1.3794);
INSERT INTO "OHLCData" VALUES (219, 37, '2010-09-14 00:00:00 ', 1284440400, 1.3793, 1.3847, 1.3744000000000001, 1.3845000000000001);
INSERT INTO "OHLCData" VALUES (220, 37, '2010-09-15 00:00:00 ', 1284526800, 1.3844000000000001, 1.3915999999999999, 1.3824000000000001, 1.3883000000000001);
INSERT INTO "OHLCData" VALUES (221, 37, '2010-09-16 00:00:00 ', 1284613200, 1.3882000000000001, 1.4008, 1.3875999999999999, 1.3912);
INSERT INTO "OHLCData" VALUES (222, 37, '2010-09-17 00:00:00 ', 1284699600, 1.3913, 1.3945000000000001, 1.3856999999999999, 1.3933);
INSERT INTO "OHLCData" VALUES (223, 37, '2010-09-19 17:01:00 ', 1284933660, 1.3924000000000001, 1.3932, 1.3851, 1.3858999999999999);
INSERT INTO "OHLCData" VALUES (224, 37, '2010-09-20 00:00:00 ', 1284958800, 1.3857999999999999, 1.3874, 1.3772, 1.3844000000000001);
INSERT INTO "OHLCData" VALUES (225, 37, '2010-09-21 00:00:00 ', 1285045200, 1.3844000000000001, 1.3912, 1.3814, 1.3895999999999999);
INSERT INTO "OHLCData" VALUES (226, 37, '2010-09-22 00:00:00 ', 1285131600, 1.3895999999999999, 1.4055, 1.3892, 1.4013);
INSERT INTO "OHLCData" VALUES (227, 37, '2010-09-23 00:00:00 ', 1285218000, 1.4014, 1.4098999999999999, 1.3974, 1.4025000000000001);
INSERT INTO "OHLCData" VALUES (228, 37, '2010-09-24 00:00:00 ', 1285304400, 1.4025000000000001, 1.4080999999999999, 1.3983000000000001, 1.4059999999999999);
INSERT INTO "OHLCData" VALUES (229, 37, '2010-09-26 17:01:00 ', 1285538460, 1.4027000000000001, 1.4057999999999999, 1.4016999999999999, 1.4052);
INSERT INTO "OHLCData" VALUES (230, 37, '2010-09-27 00:00:00 ', 1285563600, 1.4051, 1.4065000000000001, 1.3973, 1.4014);
INSERT INTO "OHLCData" VALUES (231, 37, '2010-09-28 00:00:00 ', 1285650000, 1.4014, 1.4053, 1.3973, 1.4034);
INSERT INTO "OHLCData" VALUES (232, 37, '2010-09-29 00:00:00 ', 1285736400, 1.4034, 1.4077, 1.3992, 1.4057999999999999);
INSERT INTO "OHLCData" VALUES (233, 37, '2010-09-30 00:00:00 ', 1285822800, 1.4056999999999999, 1.4136, 1.4021999999999999, 1.4101999999999999);
INSERT INTO "OHLCData" VALUES (234, 37, '2010-10-01 00:00:00 ', 1285909200, 1.4101999999999999, 1.4189000000000001, 1.4096, 1.4176);
INSERT INTO "OHLCData" VALUES (235, 37, '2010-10-03 17:00:00 ', 1286143200, 1.4182999999999999, 1.4195, 1.4164000000000001, 1.4192);
INSERT INTO "OHLCData" VALUES (236, 37, '2010-10-04 00:00:00 ', 1286168400, 1.4194, 1.4242999999999999, 1.4106000000000001, 1.4233);
INSERT INTO "OHLCData" VALUES (237, 37, '2010-10-05 00:00:00 ', 1286254800, 1.4234, 1.4368000000000001, 1.4226000000000001, 1.4249000000000001);
INSERT INTO "OHLCData" VALUES (238, 37, '2010-10-06 00:00:00 ', 1286341200, 1.425, 1.4271, 1.4132, 1.4136);
INSERT INTO "OHLCData" VALUES (239, 37, '2010-10-07 00:00:00 ', 1286427600, 1.4137, 1.4202999999999999, 1.4097999999999999, 1.4179999999999999);
INSERT INTO "OHLCData" VALUES (240, 37, '2010-10-08 00:00:00 ', 1286514000, 1.4178999999999999, 1.4279999999999999, 1.4093, 1.4146000000000001);
INSERT INTO "OHLCData" VALUES (241, 37, '2010-10-10 17:03:00 ', 1286748180, 1.4137999999999999, 1.4168000000000001, 1.4118999999999999, 1.4153);
INSERT INTO "OHLCData" VALUES (242, 37, '2010-10-11 00:00:00 ', 1286773200, 1.4154, 1.4180999999999999, 1.4073, 1.417);
INSERT INTO "OHLCData" VALUES (243, 37, '2010-10-12 00:00:00 ', 1286859600, 1.4169, 1.4172, 1.4043000000000001, 1.4147000000000001);
INSERT INTO "OHLCData" VALUES (244, 37, '2010-10-13 00:00:00 ', 1286946000, 1.4148000000000001, 1.4177, 1.4048, 1.4118999999999999);
INSERT INTO "OHLCData" VALUES (245, 37, '2010-10-14 00:00:00 ', 1287032400, 1.4119999999999999, 1.4192, 1.411, 1.4152);
INSERT INTO "OHLCData" VALUES (246, 37, '2010-10-15 00:00:00 ', 1287118800, 1.4153, 1.4187000000000001, 1.4094, 1.4104000000000001);
INSERT INTO "OHLCData" VALUES (247, 37, '2010-10-17 17:02:00 ', 1287352920, 1.4088000000000001, 1.4127000000000001, 1.4081999999999999, 1.4093);
INSERT INTO "OHLCData" VALUES (248, 37, '2010-10-18 00:00:00 ', 1287378000, 1.4094, 1.4114, 1.4046000000000001, 1.4105000000000001);
INSERT INTO "OHLCData" VALUES (249, 37, '2010-10-19 00:00:00 ', 1287464400, 1.4104000000000001, 1.4216, 1.4068000000000001, 1.4123000000000001);
INSERT INTO "OHLCData" VALUES (250, 37, '2010-10-20 00:00:00 ', 1287550800, 1.4121999999999999, 1.4185000000000001, 1.4104000000000001, 1.4149);
INSERT INTO "OHLCData" VALUES (251, 37, '2010-10-21 00:00:00 ', 1287637200, 1.4148000000000001, 1.4268000000000001, 1.4144000000000001, 1.4208000000000001);
INSERT INTO "OHLCData" VALUES (252, 37, '2010-10-22 00:00:00 ', 1287723600, 1.4207000000000001, 1.4226000000000001, 1.4160999999999999, 1.4195);
INSERT INTO "OHLCData" VALUES (253, 37, '2010-10-24 17:01:00 ', 1287957660, 1.4151, 1.4191, 1.4126000000000001, 1.413);
INSERT INTO "OHLCData" VALUES (254, 37, '2010-10-25 00:00:00 ', 1287982800, 1.4131, 1.4132, 1.4045000000000001, 1.4083000000000001);
INSERT INTO "OHLCData" VALUES (255, 37, '2010-10-26 00:00:00 ', 1288069200, 1.4081999999999999, 1.4200999999999999, 1.4039999999999999, 1.4198999999999999);
INSERT INTO "OHLCData" VALUES (256, 37, '2010-10-27 00:00:00 ', 1288155600, 1.4199999999999999, 1.4246000000000001, 1.4145000000000001, 1.4151);
INSERT INTO "OHLCData" VALUES (257, 37, '2010-10-28 00:00:00 ', 1288242000, 1.415, 1.4259999999999999, 1.4135, 1.4234);
INSERT INTO "OHLCData" VALUES (258, 37, '2010-10-29 00:00:00 ', 1288328400, 1.4235, 1.4266000000000001, 1.4154, 1.4176);
INSERT INTO "OHLCData" VALUES (259, 37, '2010-10-31 17:00:00 ', 1288562400, 1.4165000000000001, 1.4196, 1.4121999999999999, 1.4140999999999999);
INSERT INTO "OHLCData" VALUES (260, 37, '2010-11-01 00:00:00 ', 1288587600, 1.4139999999999999, 1.4157999999999999, 1.3936999999999999, 1.3947000000000001);
INSERT INTO "OHLCData" VALUES (261, 37, '2010-11-02 00:00:00 ', 1288674000, 1.3946000000000001, 1.4063000000000001, 1.3923000000000001, 1.4047000000000001);
INSERT INTO "OHLCData" VALUES (262, 37, '2010-11-03 00:00:00 ', 1288760400, 1.4048, 1.4156, 1.4031, 1.4059999999999999);
INSERT INTO "OHLCData" VALUES (263, 37, '2010-11-04 00:00:00 ', 1288846800, 1.4057999999999999, 1.4103000000000001, 1.3969, 1.3984000000000001);
INSERT INTO "OHLCData" VALUES (264, 37, '2010-11-05 00:00:00 ', 1288933200, 1.3983000000000001, 1.3998999999999999, 1.3798999999999999, 1.381);
INSERT INTO "OHLCData" VALUES (265, 37, '2010-11-07 17:00:00 ', 1289170800, 1.3841000000000001, 1.3858999999999999, 1.3765000000000001, 1.3768);
INSERT INTO "OHLCData" VALUES (266, 37, '2010-11-08 00:00:00 ', 1289196000, 1.3767, 1.3801000000000001, 1.3691, 1.3708);
INSERT INTO "OHLCData" VALUES (267, 37, '2010-11-09 00:00:00 ', 1289282400, 1.3709, 1.3758999999999999, 1.3673, 1.3706);
INSERT INTO "OHLCData" VALUES (268, 37, '2010-11-10 00:00:00 ', 1289368800, 1.3705000000000001, 1.3783000000000001, 1.3671, 1.3721000000000001);
INSERT INTO "OHLCData" VALUES (269, 37, '2010-11-11 00:00:00 ', 1289455200, 1.3722000000000001, 1.3732, 1.3641000000000001, 1.3702000000000001);
INSERT INTO "OHLCData" VALUES (270, 37, '2010-11-12 00:00:00 ', 1289541600, 1.3701000000000001, 1.3907, 1.3700000000000001, 1.3895999999999999);
INSERT INTO "OHLCData" VALUES (271, 37, '2010-11-14 17:03:00 ', 1289775780, 1.3859999999999999, 1.3905000000000001, 1.3837999999999999, 1.3879999999999999);
INSERT INTO "OHLCData" VALUES (272, 37, '2010-11-15 00:00:00 ', 1289800800, 1.3878999999999999, 1.3926000000000001, 1.3716999999999999, 1.3801000000000001);
INSERT INTO "OHLCData" VALUES (273, 37, '2010-11-16 00:00:00 ', 1289887200, 1.3802000000000001, 1.3889, 1.3789, 1.3829);
INSERT INTO "OHLCData" VALUES (274, 37, '2010-11-17 00:00:00 ', 1289973600, 1.383, 1.3855, 1.3769, 1.3799999999999999);
INSERT INTO "OHLCData" VALUES (275, 37, '2010-11-18 00:00:00 ', 1290060000, 1.3797999999999999, 1.3826000000000001, 1.3751, 1.3822000000000001);
INSERT INTO "OHLCData" VALUES (276, 37, '2010-11-19 00:00:00 ', 1290146400, 1.3823000000000001, 1.3927, 1.3821000000000001, 1.3854);
INSERT INTO "OHLCData" VALUES (277, 37, '2010-11-21 17:00:00 ', 1290380400, 1.3885000000000001, 1.3895999999999999, 1.3825000000000001, 1.3854);
INSERT INTO "OHLCData" VALUES (278, 37, '2010-11-22 00:00:00 ', 1290405600, 1.3855, 1.3861000000000001, 1.3744000000000001, 1.3776999999999999);
INSERT INTO "OHLCData" VALUES (279, 37, '2010-11-23 00:00:00 ', 1290492000, 1.3777999999999999, 1.3861000000000001, 1.3673999999999999, 1.3687);
INSERT INTO "OHLCData" VALUES (280, 37, '2010-11-24 00:00:00 ', 1290578400, 1.3688, 1.369, 1.3555999999999999, 1.361);
INSERT INTO "OHLCData" VALUES (281, 37, '2010-11-25 00:00:00 ', 1290664800, 1.3611, 1.3684000000000001, 1.3557999999999999, 1.3676999999999999);
INSERT INTO "OHLCData" VALUES (282, 37, '2010-11-26 00:00:00 ', 1290751200, 1.3677999999999999, 1.3752, 1.3667, 1.3723000000000001);
INSERT INTO "OHLCData" VALUES (283, 37, '2010-11-28 17:01:00 ', 1290985260, 1.3716999999999999, 1.3755999999999999, 1.3673, 1.3723000000000001);
INSERT INTO "OHLCData" VALUES (284, 37, '2010-11-29 00:00:00 ', 1291010400, 1.3722000000000001, 1.3732, 1.3588, 1.3606);
INSERT INTO "OHLCData" VALUES (285, 37, '2010-11-30 00:00:00 ', 1291096800, 1.3607, 1.3631, 1.3517999999999999, 1.359);
INSERT INTO "OHLCData" VALUES (286, 37, '2010-12-01 00:00:00 ', 1291183200, 1.3589, 1.3617999999999999, 1.3528, 1.3593);
INSERT INTO "OHLCData" VALUES (287, 37, '2010-12-02 00:00:00 ', 1291269600, 1.3592, 1.3643000000000001, 1.3511, 1.3527);
INSERT INTO "OHLCData" VALUES (288, 37, '2010-12-03 00:00:00 ', 1291356000, 1.3526, 1.3554999999999999, 1.3483000000000001, 1.3502000000000001);
INSERT INTO "OHLCData" VALUES (289, 37, '2010-12-05 17:00:00 ', 1291590000, 1.3507, 1.353, 1.3491, 1.3513999999999999);
INSERT INTO "OHLCData" VALUES (290, 37, '2010-12-06 00:00:00 ', 1291615200, 1.3512999999999999, 1.3516999999999999, 1.3418000000000001, 1.3462000000000001);
INSERT INTO "OHLCData" VALUES (291, 37, '2010-12-07 00:00:00 ', 1291701600, 1.3461000000000001, 1.3508, 1.3412999999999999, 1.3503000000000001);
INSERT INTO "OHLCData" VALUES (292, 37, '2010-12-08 00:00:00 ', 1291788000, 1.3504, 1.3549, 1.3463000000000001, 1.3488);
INSERT INTO "OHLCData" VALUES (293, 37, '2010-12-09 00:00:00 ', 1291874400, 1.3487, 1.3489, 1.3382000000000001, 1.3447);
INSERT INTO "OHLCData" VALUES (294, 37, '2010-12-10 00:00:00 ', 1291960800, 1.3448, 1.3463000000000001, 1.3382000000000001, 1.3415999999999999);
INSERT INTO "OHLCData" VALUES (295, 37, '2010-12-12 17:00:00 ', 1292194800, 1.3407, 1.3422000000000001, 1.3380000000000001, 1.3391);
INSERT INTO "OHLCData" VALUES (296, 37, '2010-12-13 00:00:00 ', 1292220000, 1.339, 1.3468, 1.3364, 1.3452);
INSERT INTO "OHLCData" VALUES (297, 37, '2010-12-14 00:01:00 ', 1292306460, 1.3451, 1.3500000000000001, 1.3380000000000001, 1.3406);
INSERT INTO "OHLCData" VALUES (298, 37, '2010-12-15 00:00:00 ', 1292392800, 1.3405, 1.3451, 1.3379000000000001, 1.339);
INSERT INTO "OHLCData" VALUES (299, 37, '2010-12-16 00:00:00 ', 1292479200, 1.3389, 1.3413999999999999, 1.3363, 1.3407);
INSERT INTO "OHLCData" VALUES (300, 37, '2010-12-17 00:00:00 ', 1292565600, 1.3408, 1.3508, 1.3311999999999999, 1.3342000000000001);
INSERT INTO "OHLCData" VALUES (301, 37, '2010-12-19 17:01:00 ', 1292799660, 1.3331999999999999, 1.335, 1.3281000000000001, 1.3310999999999999);
INSERT INTO "OHLCData" VALUES (302, 37, '2010-12-20 00:00:00 ', 1292824800, 1.3310999999999999, 1.3327, 1.3186, 1.3210999999999999);
INSERT INTO "OHLCData" VALUES (303, 37, '2010-12-21 00:00:00 ', 1292911200, 1.321, 1.3233999999999999, 1.3106, 1.3165);
INSERT INTO "OHLCData" VALUES (304, 37, '2010-12-22 00:00:00 ', 1292997600, 1.3166, 1.3185, 1.3070999999999999, 1.3090999999999999);
INSERT INTO "OHLCData" VALUES (305, 37, '2010-12-23 00:00:00 ', 1293084000, 1.3092999999999999, 1.3110999999999999, 1.3008999999999999, 1.3075000000000001);
INSERT INTO "OHLCData" VALUES (306, 37, '2010-12-24 00:00:00 ', 1293170400, 1.3073999999999999, 1.3090999999999999, 1.3037000000000001, 1.3050999999999999);
INSERT INTO "OHLCData" VALUES (307, 37, '2010-12-26 17:02:00 ', 1293404520, 1.3090999999999999, 1.3106, 1.3065, 1.3078000000000001);
INSERT INTO "OHLCData" VALUES (308, 37, '2010-12-27 00:00:00 ', 1293429600, 1.3077000000000001, 1.3158000000000001, 1.3063, 1.3129999999999999);
INSERT INTO "OHLCData" VALUES (309, 37, '2010-12-28 00:00:00 ', 1293516000, 1.3129, 1.3130999999999999, 1.2952999999999999, 1.2987);
INSERT INTO "OHLCData" VALUES (310, 37, '2010-12-29 00:00:00 ', 1293602400, 1.2986, 1.3012999999999999, 1.2923, 1.3009999999999999);
INSERT INTO "OHLCData" VALUES (311, 37, '2010-12-30 00:00:00 ', 1293688800, 1.3008999999999999, 1.3124, 1.2990999999999999, 1.3072999999999999);
INSERT INTO "OHLCData" VALUES (312, 37, '2010-12-31 00:00:00 ', 1293775200, 1.3071999999999999, 1.3166, 1.3029999999999999, 1.3059000000000001);
INSERT INTO "OHLCData" VALUES (313, 37, '2011-01-02 17:00:00 ', 1294009200, 1.3076000000000001, 1.3081, 1.3012999999999999, 1.3019000000000001);
INSERT INTO "OHLCData" VALUES (314, 37, '2011-01-03 00:00:00 ', 1294034400, 1.302, 1.3225, 1.3, 1.3216000000000001);
INSERT INTO "OHLCData" VALUES (315, 37, '2011-01-04 00:00:00 ', 1294120800, 1.3217000000000001, 1.3322000000000001, 1.3199000000000001, 1.3248);
INSERT INTO "OHLCData" VALUES (316, 37, '2011-01-05 00:00:00 ', 1294207200, 1.3247, 1.3269, 1.3138000000000001, 1.3179000000000001);
INSERT INTO "OHLCData" VALUES (317, 37, '2011-01-06 00:00:00 ', 1294293600, 1.3180000000000001, 1.3183, 1.3049999999999999, 1.3070999999999999);
INSERT INTO "OHLCData" VALUES (318, 37, '2011-01-07 00:00:00 ', 1294380000, 1.3069999999999999, 1.3108, 1.294, 1.2956000000000001);
INSERT INTO "OHLCData" VALUES (319, 37, '2011-01-09 17:00:00 ', 1294614000, 1.2967, 1.2968, 1.2927, 1.2956000000000001);
INSERT INTO "OHLCData" VALUES (320, 37, '2011-01-10 00:00:00 ', 1294639200, 1.2955000000000001, 1.3147, 1.2955000000000001, 1.3143);
INSERT INTO "OHLCData" VALUES (321, 37, '2011-01-11 00:00:00 ', 1294725600, 1.3144, 1.3225, 1.3107, 1.3186);
INSERT INTO "OHLCData" VALUES (322, 37, '2011-01-12 00:00:00 ', 1294812000, 1.3187, 1.3224, 1.3079000000000001, 1.3169999999999999);
INSERT INTO "OHLCData" VALUES (323, 37, '2011-01-13 00:00:00 ', 1294898400, 1.3170999999999999, 1.3405, 1.3157000000000001, 1.3391999999999999);
INSERT INTO "OHLCData" VALUES (324, 37, '2011-01-14 00:00:00 ', 1294984800, 1.3391, 1.3546, 1.3378000000000001, 1.3534999999999999);
INSERT INTO "OHLCData" VALUES (325, 37, '2011-01-16 17:00:00 ', 1295218800, 1.3504, 1.3514999999999999, 1.3479000000000001, 1.3499000000000001);
INSERT INTO "OHLCData" VALUES (326, 37, '2011-01-17 00:00:00 ', 1295244000, 1.3498000000000001, 1.3511, 1.3345, 1.3392999999999999);
INSERT INTO "OHLCData" VALUES (327, 37, '2011-01-18 00:00:00 ', 1295330400, 1.3393999999999999, 1.3469, 1.3366, 1.3398000000000001);
INSERT INTO "OHLCData" VALUES (328, 37, '2011-01-19 00:00:00 ', 1295416800, 1.3396999999999999, 1.3508, 1.3369, 1.3496999999999999);
INSERT INTO "OHLCData" VALUES (329, 37, '2011-01-20 00:00:00 ', 1295503200, 1.3494999999999999, 1.369, 1.3493999999999999, 1.3683000000000001);
INSERT INTO "OHLCData" VALUES (330, 37, '2011-01-21 00:00:00 ', 1295589600, 1.3682000000000001, 1.3767, 1.3652, 1.3756999999999999);
INSERT INTO "OHLCData" VALUES (331, 37, '2011-01-23 17:04:00 ', 1295823840, 1.3796999999999999, 1.3796999999999999, 1.3740000000000001, 1.3753);
INSERT INTO "OHLCData" VALUES (332, 37, '2011-01-24 00:00:00 ', 1295848800, 1.3752, 1.3763000000000001, 1.3635999999999999, 1.3711);
INSERT INTO "OHLCData" VALUES (333, 37, '2011-01-25 00:00:00 ', 1295935200, 1.371, 1.3776999999999999, 1.3644000000000001, 1.3713);
INSERT INTO "OHLCData" VALUES (334, 37, '2011-01-26 00:00:00 ', 1296021600, 1.3712, 1.3774, 1.3685, 1.3749);
INSERT INTO "OHLCData" VALUES (335, 37, '2011-01-27 00:00:00 ', 1296108000, 1.3748, 1.3875, 1.3748, 1.3847);
INSERT INTO "OHLCData" VALUES (336, 37, '2011-01-28 00:00:00 ', 1296194400, 1.3846000000000001, 1.3854, 1.3680000000000001, 1.3689);
INSERT INTO "OHLCData" VALUES (337, 37, '2011-01-30 17:00:00 ', 1296428400, 1.3731, 1.3761000000000001, 1.3694999999999999, 1.3703000000000001);
INSERT INTO "OHLCData" VALUES (338, 37, '2011-01-31 00:00:00 ', 1296453600, 1.3704000000000001, 1.3785000000000001, 1.3672, 1.3674999999999999);
INSERT INTO "OHLCData" VALUES (339, 37, '2011-02-01 00:00:00 ', 1296540000, 1.3673999999999999, 1.3694, 1.361, 1.3676999999999999);
INSERT INTO "OHLCData" VALUES (340, 37, '2011-02-02 00:00:00 ', 1296626400, 1.3677999999999999, 1.3714999999999999, 1.3641000000000001, 1.3648);
INSERT INTO "OHLCData" VALUES (341, 37, '2011-02-03 00:00:00 ', 1296712800, 1.3647, 1.3668, 1.3363, 1.3378000000000001);
INSERT INTO "OHLCData" VALUES (342, 37, '2011-02-04 00:00:00 ', 1296799200, 1.3379000000000001, 1.3440000000000001, 1.3300000000000001, 1.3391999999999999);
INSERT INTO "OHLCData" VALUES (343, 37, '2011-02-06 17:00:00 ', 1297033200, 1.3381000000000001, 1.3436999999999999, 1.337, 1.3424);
INSERT INTO "OHLCData" VALUES (344, 37, '2011-02-07 00:00:00 ', 1297058400, 1.3423, 1.3433999999999999, 1.3314999999999999, 1.3414999999999999);
INSERT INTO "OHLCData" VALUES (345, 37, '2011-02-08 00:00:00 ', 1297144800, 1.3413999999999999, 1.349, 1.3366, 1.3458000000000001);
INSERT INTO "OHLCData" VALUES (346, 37, '2011-02-09 00:00:00 ', 1297231200, 1.3459000000000001, 1.3607, 1.3455999999999999, 1.3597999999999999);
INSERT INTO "OHLCData" VALUES (347, 37, '2011-02-10 00:00:00 ', 1297317600, 1.3596999999999999, 1.3603000000000001, 1.3527, 1.3588);
INSERT INTO "OHLCData" VALUES (348, 37, '2011-02-11 00:00:00 ', 1297404000, 1.3589, 1.3600000000000001, 1.3498000000000001, 1.3525);
INSERT INTO "OHLCData" VALUES (349, 37, '2011-02-13 17:00:00 ', 1297638000, 1.3529, 1.3539000000000001, 1.3453999999999999, 1.3473999999999999);
INSERT INTO "OHLCData" VALUES (350, 37, '2011-02-14 00:00:00 ', 1297663200, 1.3474999999999999, 1.3475999999999999, 1.3409, 1.3447);
INSERT INTO "OHLCData" VALUES (351, 37, '2011-02-15 00:00:00 ', 1297749600, 1.3448, 1.3553999999999999, 1.3445, 1.3528);
INSERT INTO "OHLCData" VALUES (352, 37, '2011-02-16 00:00:00 ', 1297836000, 1.3529, 1.3599000000000001, 1.3488, 1.3529);
INSERT INTO "OHLCData" VALUES (353, 37, '2011-02-17 00:00:00 ', 1297922400, 1.353, 1.3532999999999999, 1.3421000000000001, 1.3432999999999999);
INSERT INTO "OHLCData" VALUES (354, 37, '2011-02-18 00:00:00 ', 1298008800, 1.3433999999999999, 1.3504, 1.3400000000000001, 1.3492999999999999);
INSERT INTO "OHLCData" VALUES (355, 37, '2011-02-20 17:00:00 ', 1298242800, 1.3508, 1.3522000000000001, 1.3479000000000001, 1.3512999999999999);
INSERT INTO "OHLCData" VALUES (356, 37, '2011-02-21 00:00:00 ', 1298268000, 1.3513999999999999, 1.3583000000000001, 1.3500000000000001, 1.3536999999999999);
INSERT INTO "OHLCData" VALUES (357, 37, '2011-02-22 00:00:00 ', 1298354400, 1.3535999999999999, 1.3692, 1.3512, 1.3664000000000001);
INSERT INTO "OHLCData" VALUES (358, 37, '2011-02-23 00:00:00 ', 1298440800, 1.3663000000000001, 1.3782000000000001, 1.3645, 1.3669);
INSERT INTO "OHLCData" VALUES (359, 37, '2011-02-24 00:00:00 ', 1298527200, 1.3668, 1.3727, 1.3619000000000001, 1.3637999999999999);
INSERT INTO "OHLCData" VALUES (360, 37, '2011-02-25 00:00:00 ', 1298613600, 1.3638999999999999, 1.3675999999999999, 1.3500000000000001, 1.351);
INSERT INTO "OHLCData" VALUES (361, 37, '2011-02-27 17:00:00 ', 1298847600, 1.3544, 1.3554999999999999, 1.3523000000000001, 1.3532);
INSERT INTO "OHLCData" VALUES (362, 37, '2011-02-28 00:00:00 ', 1298872800, 1.3531, 1.3649, 1.3512999999999999, 1.359);
INSERT INTO "OHLCData" VALUES (363, 37, '2011-03-01 00:00:00 ', 1298959200, 1.3589, 1.3629, 1.3559000000000001, 1.3621000000000001);
INSERT INTO "OHLCData" VALUES (364, 37, '2011-03-02 00:00:00 ', 1299045600, 1.3620000000000001, 1.3674999999999999, 1.3601000000000001, 1.3643000000000001);
INSERT INTO "OHLCData" VALUES (365, 37, '2011-03-03 00:00:00 ', 1299132000, 1.3642000000000001, 1.3799999999999999, 1.3594999999999999, 1.3759999999999999);
INSERT INTO "OHLCData" VALUES (366, 37, '2011-03-04 00:00:00 ', 1299218400, 1.3758999999999999, 1.3846000000000001, 1.3755999999999999, 1.3791);
INSERT INTO "OHLCData" VALUES (367, 37, '2011-03-06 17:00:00 ', 1299452400, 1.3785000000000001, 1.3803000000000001, 1.3768, 1.3794999999999999);
INSERT INTO "OHLCData" VALUES (368, 37, '2011-03-07 00:00:00 ', 1299477600, 1.3794, 1.3831, 1.3758999999999999, 1.3815);
INSERT INTO "OHLCData" VALUES (369, 37, '2011-03-08 00:00:00 ', 1299564000, 1.3814, 1.3828, 1.3743000000000001, 1.3791);
INSERT INTO "OHLCData" VALUES (370, 37, '2011-03-09 00:00:00 ', 1299650400, 1.379, 1.3815, 1.3715999999999999, 1.3795999999999999);
INSERT INTO "OHLCData" VALUES (371, 37, '2011-03-10 00:00:00 ', 1299736800, 1.3794999999999999, 1.3817999999999999, 1.3756999999999999, 1.3774999999999999);
INSERT INTO "OHLCData" VALUES (372, 37, '2011-03-11 00:00:00 ', 1299823200, 1.3774, 1.3832, 1.3673999999999999, 1.3708);
INSERT INTO "OHLCData" VALUES (373, 37, '2011-03-13 17:00:00 ', 1300053600, 1.3761000000000001, 1.3833, 1.3741000000000001, 1.3807);
INSERT INTO "OHLCData" VALUES (374, 37, '2011-03-14 00:00:00 ', 1300078800, 1.3808, 1.401, 1.3794999999999999, 1.3972);
INSERT INTO "OHLCData" VALUES (375, 37, '2011-03-15 00:00:00 ', 1300165200, 1.3971, 1.4149, 1.3946000000000001, 1.4088000000000001);
INSERT INTO "OHLCData" VALUES (376, 37, '2011-03-16 00:00:00 ', 1300251600, 1.4089, 1.4343999999999999, 1.403, 1.4197);
INSERT INTO "OHLCData" VALUES (377, 37, '2011-03-17 00:00:00 ', 1300338000, 1.4198, 1.4321999999999999, 1.4100999999999999, 1.4149);
INSERT INTO "OHLCData" VALUES (378, 37, '2011-03-18 00:00:00 ', 1300424400, 1.4151, 1.4277, 1.4140999999999999, 1.4236);
INSERT INTO "OHLCData" VALUES (379, 37, '2011-03-20 17:00:00 ', 1300658400, 1.425, 1.4274, 1.4153, 1.4158999999999999);
INSERT INTO "OHLCData" VALUES (380, 37, '2011-03-21 00:00:00 ', 1300683600, 1.4159999999999999, 1.4166000000000001, 1.4063000000000001, 1.4137999999999999);
INSERT INTO "OHLCData" VALUES (381, 37, '2011-03-22 00:00:00 ', 1300770000, 1.4137, 1.4146000000000001, 1.4021999999999999, 1.4035);
INSERT INTO "OHLCData" VALUES (382, 37, '2011-03-23 00:00:00 ', 1300856400, 1.4034, 1.4066000000000001, 1.3889, 1.3894);
INSERT INTO "OHLCData" VALUES (383, 37, '2011-03-24 00:00:00 ', 1300942800, 1.3893, 1.3924000000000001, 1.3857999999999999, 1.3894);
INSERT INTO "OHLCData" VALUES (384, 37, '2011-03-25 00:00:00 ', 1301029200, 1.3893, 1.3893, 1.3705000000000001, 1.3726);
INSERT INTO "OHLCData" VALUES (385, 37, '2011-03-27 17:01:00 ', 1301263260, 1.3711, 1.3725000000000001, 1.3665, 1.369);
INSERT INTO "OHLCData" VALUES (386, 37, '2011-03-28 00:00:00 ', 1301288400, 1.3689, 1.3766, 1.3643000000000001, 1.3748);
INSERT INTO "OHLCData" VALUES (387, 37, '2011-03-29 00:00:00 ', 1301374800, 1.3747, 1.3798999999999999, 1.3656999999999999, 1.3666);
INSERT INTO "OHLCData" VALUES (388, 37, '2011-03-30 00:00:00 ', 1301461200, 1.3665, 1.3696999999999999, 1.3621000000000001, 1.3692);
INSERT INTO "OHLCData" VALUES (389, 37, '2011-03-31 00:00:00 ', 1301547600, 1.3693, 1.3754, 1.3673999999999999, 1.3685);
INSERT INTO "OHLCData" VALUES (390, 37, '2011-04-01 00:00:00 ', 1301634000, 1.3686, 1.3714999999999999, 1.3602000000000001, 1.3702000000000001);
INSERT INTO "OHLCData" VALUES (391, 37, '2011-04-03 17:00:00 ', 1301868000, 1.3678999999999999, 1.3701000000000001, 1.3674999999999999, 1.3688);
INSERT INTO "OHLCData" VALUES (392, 37, '2011-04-04 00:00:00 ', 1301893200, 1.3687, 1.3758999999999999, 1.3675999999999999, 1.3737999999999999);
INSERT INTO "OHLCData" VALUES (393, 37, '2011-04-05 00:00:00 ', 1301979600, 1.3736999999999999, 1.3779999999999999, 1.3712, 1.3749);
INSERT INTO "OHLCData" VALUES (394, 37, '2011-04-06 00:00:00 ', 1302066000, 1.3748, 1.3793, 1.3649, 1.3681000000000001);
INSERT INTO "OHLCData" VALUES (395, 37, '2011-04-07 00:00:00 ', 1302152400, 1.3682000000000001, 1.3711, 1.3587, 1.3687);
INSERT INTO "OHLCData" VALUES (396, 37, '2011-04-08 00:00:00 ', 1302238800, 1.3688, 1.3725000000000001, 1.3654999999999999, 1.3706);
INSERT INTO "OHLCData" VALUES (397, 37, '2011-04-10 17:00:00 ', 1302472800, 1.3692, 1.3704000000000001, 1.3668, 1.3681000000000001);
INSERT INTO "OHLCData" VALUES (398, 37, '2011-04-11 00:00:00 ', 1302498000, 1.3680000000000001, 1.3836999999999999, 1.3666, 1.3801000000000001);
INSERT INTO "OHLCData" VALUES (399, 37, '2011-04-12 00:00:00 ', 1302584400, 1.3799999999999999, 1.3872, 1.3745000000000001, 1.3848);
INSERT INTO "OHLCData" VALUES (400, 37, '2011-04-13 00:00:00 ', 1302670800, 1.3847, 1.3853, 1.3734999999999999, 1.3767);
INSERT INTO "OHLCData" VALUES (401, 37, '2011-04-14 00:00:00 ', 1302757200, 1.3768, 1.3777999999999999, 1.3700000000000001, 1.3729);
INSERT INTO "OHLCData" VALUES (402, 37, '2011-04-15 00:00:00 ', 1302843600, 1.3728, 1.3769, 1.3640000000000001, 1.3648);
INSERT INTO "OHLCData" VALUES (403, 37, '2011-04-17 17:00:00 ', 1303077600, 1.3640000000000001, 1.3673999999999999, 1.3615999999999999, 1.3621000000000001);
INSERT INTO "OHLCData" VALUES (404, 37, '2011-04-18 00:00:00 ', 1303102800, 1.3620000000000001, 1.3628, 1.3524, 1.3589);
INSERT INTO "OHLCData" VALUES (405, 37, '2011-04-19 00:00:00 ', 1303189200, 1.359, 1.3642000000000001, 1.3579000000000001, 1.3596999999999999);
INSERT INTO "OHLCData" VALUES (406, 37, '2011-04-20 00:00:00 ', 1303275600, 1.3595999999999999, 1.3635999999999999, 1.3529, 1.3548);
INSERT INTO "OHLCData" VALUES (407, 37, '2011-04-21 00:00:00 ', 1303362000, 1.3549, 1.3613, 1.3520000000000001, 1.3559000000000001);
INSERT INTO "OHLCData" VALUES (408, 37, '2011-04-22 00:00:00 ', 1303448400, 1.3560000000000001, 1.3577999999999999, 1.353, 1.3560000000000001);
INSERT INTO "OHLCData" VALUES (409, 37, '2011-04-24 17:01:00 ', 1303682460, 1.3549, 1.3569, 1.3522000000000001, 1.3562000000000001);
INSERT INTO "OHLCData" VALUES (410, 37, '2011-04-25 00:00:00 ', 1303707600, 1.3561000000000001, 1.3613, 1.3554999999999999, 1.3592);
INSERT INTO "OHLCData" VALUES (411, 37, '2011-04-26 00:00:00 ', 1303794000, 1.3593, 1.3626, 1.3531, 1.3554999999999999);
INSERT INTO "OHLCData" VALUES (412, 37, '2011-04-27 00:00:00 ', 1303880400, 1.3553999999999999, 1.3613999999999999, 1.3535999999999999, 1.3587);
INSERT INTO "OHLCData" VALUES (413, 37, '2011-04-28 00:00:00 ', 1303966800, 1.3588, 1.3613, 1.3552, 1.3592);
INSERT INTO "OHLCData" VALUES (414, 37, '2011-04-29 00:01:00 ', 1304053260, 1.3593, 1.3614999999999999, 1.3486, 1.3492999999999999);
INSERT INTO "OHLCData" VALUES (415, 37, '2011-05-01 17:01:00 ', 1304287260, 1.351, 1.3528, 1.3478000000000001, 1.3521000000000001);
INSERT INTO "OHLCData" VALUES (416, 37, '2011-05-02 00:00:00 ', 1304312400, 1.3520000000000001, 1.3571, 1.3499000000000001, 1.3561000000000001);
INSERT INTO "OHLCData" VALUES (417, 37, '2011-05-03 00:00:00 ', 1304398800, 1.3560000000000001, 1.3693, 1.3541000000000001, 1.3682000000000001);
INSERT INTO "OHLCData" VALUES (418, 37, '2011-05-04 00:00:00 ', 1304485200, 1.3681000000000001, 1.3871, 1.3645, 1.3851);
INSERT INTO "OHLCData" VALUES (419, 37, '2011-05-05 00:00:00 ', 1304571600, 1.385, 1.3924000000000001, 1.3566, 1.3582000000000001);
INSERT INTO "OHLCData" VALUES (420, 37, '2011-05-06 00:00:00 ', 1304658000, 1.3581000000000001, 1.3648, 1.3360000000000001, 1.3373999999999999);
INSERT INTO "OHLCData" VALUES (421, 37, '2011-05-08 17:02:00 ', 1304892120, 1.3402000000000001, 1.3426, 1.3368, 1.3371999999999999);
INSERT INTO "OHLCData" VALUES (422, 37, '2011-05-09 00:00:00 ', 1304917200, 1.3371, 1.3396999999999999, 1.3268, 1.3301000000000001);
INSERT INTO "OHLCData" VALUES (423, 37, '2011-05-10 00:00:00 ', 1305003600, 1.3300000000000001, 1.3324, 1.3248, 1.3257000000000001);
INSERT INTO "OHLCData" VALUES (424, 37, '2011-05-11 00:00:00 ', 1305090000, 1.3255999999999999, 1.3419000000000001, 1.3224, 1.3364);
INSERT INTO "OHLCData" VALUES (425, 37, '2011-05-12 00:00:00 ', 1305176400, 1.3365, 1.3407, 1.3312999999999999, 1.3352999999999999);
INSERT INTO "OHLCData" VALUES (426, 37, '2011-05-13 00:00:00 ', 1305262800, 1.3353999999999999, 1.3399000000000001, 1.3318000000000001, 1.3349);
INSERT INTO "OHLCData" VALUES (427, 37, '2011-05-15 17:00:00 ', 1305496800, 1.3318000000000001, 1.3357000000000001, 1.3303, 1.3353999999999999);
INSERT INTO "OHLCData" VALUES (428, 37, '2011-05-16 00:00:00 ', 1305522000, 1.3352999999999999, 1.3412999999999999, 1.3329, 1.339);
INSERT INTO "OHLCData" VALUES (429, 37, '2011-05-17 00:00:00 ', 1305608400, 1.3389, 1.3452999999999999, 1.3353999999999999, 1.3393999999999999);
INSERT INTO "OHLCData" VALUES (430, 37, '2011-05-18 00:00:00 ', 1305694800, 1.3394999999999999, 1.3453999999999999, 1.3384, 1.3394999999999999);
INSERT INTO "OHLCData" VALUES (431, 37, '2011-05-19 00:00:00 ', 1305781200, 1.3395999999999999, 1.3453999999999999, 1.3354999999999999, 1.3409);
INSERT INTO "OHLCData" VALUES (432, 37, '2011-05-20 00:00:00 ', 1305867600, 1.3408, 1.3431999999999999, 1.3253999999999999, 1.3280000000000001);
INSERT INTO "OHLCData" VALUES (433, 37, '2011-05-22 17:00:00 ', 1306101600, 1.327, 1.3326, 1.3257000000000001, 1.3324);
INSERT INTO "OHLCData" VALUES (434, 37, '2011-05-23 00:00:00 ', 1306126800, 1.3323, 1.3372999999999999, 1.3266, 1.3325);
INSERT INTO "OHLCData" VALUES (435, 37, '2011-05-24 00:00:00 ', 1306213200, 1.3324, 1.3387, 1.3318000000000001, 1.3382000000000001);
INSERT INTO "OHLCData" VALUES (436, 37, '2011-05-25 00:00:00 ', 1306299600, 1.3383, 1.3425, 1.3348, 1.3368);
INSERT INTO "OHLCData" VALUES (437, 37, '2011-05-26 00:00:00 ', 1306386000, 1.3369, 1.3412999999999999, 1.3272999999999999, 1.3328);
INSERT INTO "OHLCData" VALUES (438, 37, '2011-05-27 00:00:00 ', 1306472400, 1.3327, 1.3383, 1.3304, 1.3367);
INSERT INTO "OHLCData" VALUES (439, 37, '2011-05-29 17:00:00 ', 1306706400, 1.3348, 1.3366, 1.3332999999999999, 1.3351999999999999);
INSERT INTO "OHLCData" VALUES (440, 37, '2011-05-30 00:01:00 ', 1306731660, 1.3351, 1.3421000000000001, 1.3338000000000001, 1.3413999999999999);
INSERT INTO "OHLCData" VALUES (441, 37, '2011-05-31 00:00:00 ', 1306818000, 1.3414999999999999, 1.3512999999999999, 1.3411, 1.3421000000000001);
INSERT INTO "OHLCData" VALUES (442, 37, '2011-06-01 00:00:00 ', 1306904400, 1.3420000000000001, 1.353, 1.3395999999999999, 1.3513999999999999);
INSERT INTO "OHLCData" VALUES (443, 37, '2011-06-02 00:00:00 ', 1306990800, 1.3514999999999999, 1.3603000000000001, 1.3500000000000001, 1.3563000000000001);
INSERT INTO "OHLCData" VALUES (444, 37, '2011-06-03 00:00:00 ', 1307077200, 1.3562000000000001, 1.3671, 1.3549, 1.3653);
INSERT INTO "OHLCData" VALUES (445, 37, '2011-06-05 17:00:00 ', 1307311200, 1.3632, 1.365, 1.3601000000000001, 1.3625);
INSERT INTO "OHLCData" VALUES (446, 37, '2011-06-06 00:00:00 ', 1307336400, 1.3626, 1.3636999999999999, 1.3576999999999999, 1.3585);
INSERT INTO "OHLCData" VALUES (447, 37, '2011-06-07 00:00:00 ', 1307422800, 1.3584000000000001, 1.3763000000000001, 1.3580000000000001, 1.3748);
INSERT INTO "OHLCData" VALUES (448, 37, '2011-06-08 00:00:00 ', 1307509200, 1.3749, 1.3835, 1.3694999999999999, 1.3816999999999999);
INSERT INTO "OHLCData" VALUES (449, 37, '2011-06-09 00:00:00 ', 1307595600, 1.3817999999999999, 1.3828, 1.3626, 1.3675999999999999);
INSERT INTO "OHLCData" VALUES (450, 37, '2011-06-10 00:00:00 ', 1307682000, 1.3674999999999999, 1.3682000000000001, 1.3571, 1.3611);
INSERT INTO "OHLCData" VALUES (451, 37, '2011-06-12 17:01:00 ', 1307916060, 1.3594999999999999, 1.3613, 1.3582000000000001, 1.3599000000000001);
INSERT INTO "OHLCData" VALUES (452, 37, '2011-06-13 00:00:00 ', 1307941200, 1.3597999999999999, 1.3621000000000001, 1.3546, 1.3560000000000001);
INSERT INTO "OHLCData" VALUES (453, 37, '2011-06-14 00:00:00 ', 1308027600, 1.3559000000000001, 1.3605, 1.3454999999999999, 1.3472);
INSERT INTO "OHLCData" VALUES (454, 37, '2011-06-15 00:00:00 ', 1308114000, 1.3471, 1.3473999999999999, 1.337, 1.3415999999999999);
INSERT INTO "OHLCData" VALUES (455, 37, '2011-06-16 00:00:00 ', 1308200400, 1.3416999999999999, 1.3472, 1.3388, 1.3440000000000001);
INSERT INTO "OHLCData" VALUES (456, 37, '2011-06-17 00:00:00 ', 1308286800, 1.3441000000000001, 1.3498000000000001, 1.3424, 1.3464);
INSERT INTO "OHLCData" VALUES (457, 37, '2011-06-19 17:00:00 ', 1308520800, 1.3462000000000001, 1.349, 1.3448, 1.3483000000000001);
INSERT INTO "OHLCData" VALUES (458, 37, '2011-06-20 00:00:00 ', 1308546000, 1.3482000000000001, 1.3593, 1.347, 1.3585);
INSERT INTO "OHLCData" VALUES (459, 37, '2011-06-21 00:00:00 ', 1308632400, 1.3586, 1.3607, 1.3542000000000001, 1.3572);
INSERT INTO "OHLCData" VALUES (460, 37, '2011-06-22 00:00:00 ', 1308718800, 1.3571, 1.3592, 1.3533999999999999, 1.3562000000000001);
INSERT INTO "OHLCData" VALUES (461, 37, '2011-06-23 00:00:00 ', 1308805200, 1.3561000000000001, 1.3563000000000001, 1.3499000000000001, 1.3534999999999999);
INSERT INTO "OHLCData" VALUES (462, 37, '2011-06-24 00:00:00 ', 1308891600, 1.3533999999999999, 1.3542000000000001, 1.3434999999999999, 1.3521000000000001);
INSERT INTO "OHLCData" VALUES (463, 37, '2011-06-26 17:00:00 ', 1309125600, 1.3536999999999999, 1.3545, 1.3514999999999999, 1.3534999999999999);
INSERT INTO "OHLCData" VALUES (464, 37, '2011-06-27 00:00:00 ', 1309150800, 1.3533999999999999, 1.3684000000000001, 1.3529, 1.3666);
INSERT INTO "OHLCData" VALUES (465, 37, '2011-06-28 00:00:00 ', 1309237200, 1.3667, 1.3676999999999999, 1.3593999999999999, 1.3623000000000001);
INSERT INTO "OHLCData" VALUES (466, 37, '2011-06-29 00:00:00 ', 1309323600, 1.3622000000000001, 1.3626, 1.3492999999999999, 1.3507);
INSERT INTO "OHLCData" VALUES (467, 37, '2011-06-30 00:00:00 ', 1309410000, 1.3506, 1.3560000000000001, 1.3466, 1.3544);
INSERT INTO "OHLCData" VALUES (468, 37, '2011-07-01 00:00:00 ', 1309496400, 1.3543000000000001, 1.3554999999999999, 1.3443000000000001, 1.3480000000000001);
INSERT INTO "OHLCData" VALUES (469, 37, '2011-07-03 17:01:00 ', 1309730460, 1.3480000000000001, 1.3559000000000001, 1.3476999999999999, 1.3543000000000001);
INSERT INTO "OHLCData" VALUES (470, 37, '2011-07-04 00:00:00 ', 1309755600, 1.3542000000000001, 1.3553999999999999, 1.3501000000000001, 1.3532);
INSERT INTO "OHLCData" VALUES (471, 37, '2011-07-05 00:00:00 ', 1309842000, 1.3531, 1.3566, 1.3466, 1.3469);
INSERT INTO "OHLCData" VALUES (472, 37, '2011-07-06 00:00:00 ', 1309928400, 1.3468, 1.3478000000000001, 1.3318000000000001, 1.3329);
INSERT INTO "OHLCData" VALUES (473, 37, '2011-07-07 00:00:00 ', 1310014800, 1.3328, 1.3349, 1.3236000000000001, 1.3318000000000001);
INSERT INTO "OHLCData" VALUES (474, 37, '2011-07-08 00:00:00 ', 1310101200, 1.3317000000000001, 1.3363, 1.3226, 1.3260000000000001);
INSERT INTO "OHLCData" VALUES (475, 37, '2011-07-10 17:01:00 ', 1310335260, 1.3255999999999999, 1.3290999999999999, 1.3237000000000001, 1.3240000000000001);
INSERT INTO "OHLCData" VALUES (476, 37, '2011-07-11 00:00:00 ', 1310360400, 1.3241000000000001, 1.3265, 1.3136000000000001, 1.3162);
INSERT INTO "OHLCData" VALUES (477, 37, '2011-07-12 00:00:00 ', 1310446800, 1.3161, 1.3207, 1.3120000000000001, 1.3172999999999999);
INSERT INTO "OHLCData" VALUES (478, 37, '2011-07-13 00:00:00 ', 1310533200, 1.3171999999999999, 1.3243, 1.3101, 1.3225);
INSERT INTO "OHLCData" VALUES (479, 37, '2011-07-14 00:00:00 ', 1310619600, 1.3226, 1.3254999999999999, 1.3170999999999999, 1.3197000000000001);
INSERT INTO "OHLCData" VALUES (480, 37, '2011-07-15 00:00:00 ', 1310706000, 1.3196000000000001, 1.3306, 1.3189, 1.3289);
INSERT INTO "OHLCData" VALUES (481, 37, '2011-07-17 17:00:00 ', 1310940000, 1.3272999999999999, 1.3288, 1.325, 1.3273999999999999);
INSERT INTO "OHLCData" VALUES (482, 37, '2011-07-18 00:00:00 ', 1310965200, 1.3272999999999999, 1.3314999999999999, 1.3213999999999999, 1.3283);
INSERT INTO "OHLCData" VALUES (483, 37, '2011-07-19 00:00:00 ', 1311051600, 1.3284, 1.3302, 1.3161, 1.3200000000000001);
INSERT INTO "OHLCData" VALUES (484, 37, '2011-07-20 00:00:00 ', 1311138000, 1.3199000000000001, 1.3307, 1.3182, 1.3303);
INSERT INTO "OHLCData" VALUES (485, 37, '2011-07-21 00:00:00 ', 1311224400, 1.3304, 1.3314999999999999, 1.3208, 1.3267);
INSERT INTO "OHLCData" VALUES (486, 37, '2011-07-22 00:00:00 ', 1311310800, 1.3266, 1.3314999999999999, 1.3205, 1.323);
INSERT INTO "OHLCData" VALUES (487, 37, '2011-07-24 17:00:00 ', 1311544800, 1.3280000000000001, 1.3297000000000001, 1.3249, 1.3281000000000001);
INSERT INTO "OHLCData" VALUES (488, 37, '2011-07-25 00:00:00 ', 1311570000, 1.3280000000000001, 1.3301000000000001, 1.3203, 1.3270999999999999);
INSERT INTO "OHLCData" VALUES (489, 37, '2011-07-26 00:00:00 ', 1311656400, 1.327, 1.3278000000000001, 1.3116000000000001, 1.3131999999999999);
INSERT INTO "OHLCData" VALUES (490, 37, '2011-07-27 00:00:00 ', 1311742800, 1.3132999999999999, 1.3143, 1.2999000000000001, 1.3007);
INSERT INTO "OHLCData" VALUES (491, 37, '2011-07-28 00:00:00 ', 1311829200, 1.3006, 1.3073999999999999, 1.2924, 1.3057000000000001);
INSERT INTO "OHLCData" VALUES (492, 37, '2011-07-29 00:00:00 ', 1311915600, 1.3056000000000001, 1.3127, 1.3016000000000001, 1.3090999999999999);
INSERT INTO "OHLCData" VALUES (493, 37, '2011-07-31 17:00:00 ', 1312149600, 1.3033999999999999, 1.3064, 1.3001, 1.3017000000000001);
INSERT INTO "OHLCData" VALUES (494, 37, '2011-08-01 00:00:00 ', 1312174800, 1.3018000000000001, 1.3079000000000001, 1.2937000000000001, 1.2979000000000001);
INSERT INTO "OHLCData" VALUES (495, 37, '2011-08-02 00:00:00 ', 1312261200, 1.2978000000000001, 1.3260000000000001, 1.2975000000000001, 1.3217000000000001);
INSERT INTO "OHLCData" VALUES (496, 37, '2011-08-03 00:00:00 ', 1312347600, 1.3218000000000001, 1.3384, 1.3199000000000001, 1.3355999999999999);
INSERT INTO "OHLCData" VALUES (497, 37, '2011-08-04 00:00:00 ', 1312434000, 1.3357000000000001, 1.3496999999999999, 1.3338000000000001, 1.3465);
INSERT INTO "OHLCData" VALUES (498, 37, '2011-08-05 00:00:00 ', 1312520400, 1.3466, 1.3672, 1.3456999999999999, 1.3667);
INSERT INTO "OHLCData" VALUES (499, 37, '2011-08-07 17:00:00 ', 1312754400, 1.3823000000000001, 1.385, 1.3714, 1.3848);
INSERT INTO "OHLCData" VALUES (500, 37, '2011-08-08 00:00:00 ', 1312779600, 1.3849, 1.4258999999999999, 1.3664000000000001, 1.4158999999999999);
INSERT INTO "OHLCData" VALUES (501, 37, '2011-08-09 00:00:00 ', 1312866000, 1.4157999999999999, 1.4176, 1.3806, 1.3885000000000001);
INSERT INTO "OHLCData" VALUES (502, 37, '2011-08-10 00:00:00 ', 1312952400, 1.3886000000000001, 1.4013, 1.3818999999999999, 1.3892);
INSERT INTO "OHLCData" VALUES (503, 37, '2011-08-11 00:00:00 ', 1313038800, 1.3891, 1.3907, 1.3727, 1.3775999999999999);
INSERT INTO "OHLCData" VALUES (504, 37, '2011-08-12 00:00:00 ', 1313125200, 1.3774999999999999, 1.3832, 1.3747, 1.3757999999999999);
INSERT INTO "OHLCData" VALUES (505, 37, '2011-08-14 17:00:00 ', 1313359200, 1.3758999999999999, 1.3768, 1.3692, 1.3741000000000001);
INSERT INTO "OHLCData" VALUES (506, 37, '2011-08-15 00:00:00 ', 1313384400, 1.3740000000000001, 1.3816999999999999, 1.3696999999999999, 1.3766);
INSERT INTO "OHLCData" VALUES (507, 37, '2011-08-16 00:00:00 ', 1313470800, 1.3765000000000001, 1.3814, 1.3714999999999999, 1.3741000000000001);
INSERT INTO "OHLCData" VALUES (508, 37, '2011-08-17 00:00:00 ', 1313557200, 1.3742000000000001, 1.3744000000000001, 1.3644000000000001, 1.3693);
INSERT INTO "OHLCData" VALUES (509, 37, '2011-08-18 00:00:00 ', 1313643600, 1.3694, 1.3868, 1.3691, 1.381);
INSERT INTO "OHLCData" VALUES (510, 37, '2011-08-19 00:00:00 ', 1313730000, 1.3809, 1.3848, 1.3759999999999999, 1.3832);
INSERT INTO "OHLCData" VALUES (511, 37, '2011-08-21 17:01:00 ', 1313964060, 1.3842000000000001, 1.3857999999999999, 1.3773, 1.3812);
INSERT INTO "OHLCData" VALUES (512, 37, '2011-08-22 00:00:00 ', 1313989200, 1.3811, 1.3829, 1.3752, 1.3755999999999999);
INSERT INTO "OHLCData" VALUES (513, 37, '2011-08-23 00:00:00 ', 1314075600, 1.3754999999999999, 1.3797999999999999, 1.3696999999999999, 1.3723000000000001);
INSERT INTO "OHLCData" VALUES (514, 37, '2011-08-24 00:00:00 ', 1314162000, 1.3724000000000001, 1.3794999999999999, 1.3717999999999999, 1.3774);
INSERT INTO "OHLCData" VALUES (515, 37, '2011-08-25 00:00:00 ', 1314248400, 1.3774999999999999, 1.3824000000000001, 1.3711, 1.3745000000000001);
INSERT INTO "OHLCData" VALUES (516, 37, '2011-08-26 00:00:00 ', 1314334800, 1.3746, 1.3771, 1.3606, 1.3704000000000001);
INSERT INTO "OHLCData" VALUES (517, 37, '2011-08-28 17:00:00 ', 1314568800, 1.369, 1.3713, 1.3631, 1.3635999999999999);
INSERT INTO "OHLCData" VALUES (518, 37, '2011-08-29 00:00:00 ', 1314594000, 1.3634999999999999, 1.3705000000000001, 1.3587, 1.361);
INSERT INTO "OHLCData" VALUES (519, 37, '2011-08-30 00:00:00 ', 1314680400, 1.3609, 1.3614999999999999, 1.3475999999999999, 1.3498000000000001);
INSERT INTO "OHLCData" VALUES (520, 37, '2011-08-31 00:00:00 ', 1314766800, 1.3499000000000001, 1.3542000000000001, 1.3398000000000001, 1.3422000000000001);
INSERT INTO "OHLCData" VALUES (521, 37, '2011-09-01 00:00:00 ', 1314853200, 1.3423, 1.3431, 1.3258000000000001, 1.3317000000000001);
INSERT INTO "OHLCData" VALUES (522, 37, '2011-09-02 00:00:00 ', 1314939600, 1.3318000000000001, 1.3353999999999999, 1.329, 1.3340000000000001);
INSERT INTO "OHLCData" VALUES (523, 37, '2011-09-04 17:01:00 ', 1315173660, 1.3348, 1.3382000000000001, 1.3331, 1.3355999999999999);
INSERT INTO "OHLCData" VALUES (524, 37, '2011-09-05 00:00:00 ', 1315198800, 1.3357000000000001, 1.3394999999999999, 1.3327, 1.3376999999999999);
INSERT INTO "OHLCData" VALUES (525, 37, '2011-09-06 00:00:00 ', 1315285200, 1.3378000000000001, 1.3435999999999999, 1.3250999999999999, 1.3262);
INSERT INTO "OHLCData" VALUES (526, 37, '2011-09-07 00:00:00 ', 1315371600, 1.3263, 1.331, 1.3202, 1.3280000000000001);
INSERT INTO "OHLCData" VALUES (527, 37, '2011-09-08 00:00:00 ', 1315458000, 1.3281000000000001, 1.3293999999999999, 1.3090999999999999, 1.3105);
INSERT INTO "OHLCData" VALUES (528, 37, '2011-09-09 00:00:00 ', 1315544400, 1.3104, 1.3141, 1.3028999999999999, 1.3039000000000001);
INSERT INTO "OHLCData" VALUES (529, 37, '2011-09-11 17:00:00 ', 1315778400, 1.3021, 1.3100000000000001, 1.2987, 1.3085);
INSERT INTO "OHLCData" VALUES (530, 37, '2011-09-12 00:00:00 ', 1315803600, 1.3086, 1.3234999999999999, 1.3049999999999999, 1.3199000000000001);
INSERT INTO "OHLCData" VALUES (531, 37, '2011-09-13 00:00:00 ', 1315890000, 1.3200000000000001, 1.3334999999999999, 1.3177000000000001, 1.3325);
INSERT INTO "OHLCData" VALUES (532, 37, '2011-09-14 00:00:00 ', 1315976400, 1.3326, 1.3446, 1.3312999999999999, 1.3440000000000001);
INSERT INTO "OHLCData" VALUES (533, 37, '2011-09-15 00:00:00 ', 1316062800, 1.3439000000000001, 1.3476999999999999, 1.3400000000000001, 1.3402000000000001);
INSERT INTO "OHLCData" VALUES (534, 37, '2011-09-16 00:00:00 ', 1316149200, 1.3403, 1.3411, 1.3266, 1.3311999999999999);
INSERT INTO "OHLCData" VALUES (535, 37, '2011-09-18 17:00:00 ', 1316383200, 1.3287, 1.3349, 1.3259000000000001, 1.3338000000000001);
INSERT INTO "OHLCData" VALUES (536, 37, '2011-09-19 00:00:00 ', 1316408400, 1.3337000000000001, 1.3426, 1.3313999999999999, 1.3347);
INSERT INTO "OHLCData" VALUES (537, 37, '2011-09-20 00:00:00 ', 1316494800, 1.3346, 1.3366, 1.3280000000000001, 1.333);
INSERT INTO "OHLCData" VALUES (538, 37, '2011-09-21 00:00:00 ', 1316581200, 1.3329, 1.3554999999999999, 1.3300000000000001, 1.3515999999999999);
INSERT INTO "OHLCData" VALUES (539, 37, '2011-09-22 00:00:00 ', 1316667600, 1.3514999999999999, 1.3863000000000001, 1.3495999999999999, 1.3792);
INSERT INTO "OHLCData" VALUES (540, 37, '2011-09-23 00:00:00 ', 1316754000, 1.3794, 1.3879999999999999, 1.3715999999999999, 1.3794999999999999);
INSERT INTO "OHLCData" VALUES (541, 37, '2011-09-25 17:01:00 ', 1316988060, 1.3775999999999999, 1.3829, 1.3712, 1.3763000000000001);
INSERT INTO "OHLCData" VALUES (542, 37, '2011-09-26 00:00:00 ', 1317013200, 1.3762000000000001, 1.3899999999999999, 1.3716999999999999, 1.3725000000000001);
INSERT INTO "OHLCData" VALUES (543, 37, '2011-09-27 00:00:00 ', 1317099600, 1.3726, 1.3758999999999999, 1.3642000000000001, 1.3745000000000001);
INSERT INTO "OHLCData" VALUES (544, 37, '2011-09-28 00:00:00 ', 1317186000, 1.3746, 1.3934, 1.3705000000000001, 1.3895);
INSERT INTO "OHLCData" VALUES (545, 37, '2011-09-29 00:00:00 ', 1317272400, 1.3895999999999999, 1.3960999999999999, 1.3803000000000001, 1.3879999999999999);
INSERT INTO "OHLCData" VALUES (546, 37, '2011-09-30 00:00:00 ', 1317358800, 1.3880999999999999, 1.3913, 1.3774999999999999, 1.3852);
INSERT INTO "OHLCData" VALUES (547, 37, '2011-10-02 17:00:00 ', 1317592800, 1.3813, 1.3877999999999999, 1.3775999999999999, 1.3872);
INSERT INTO "OHLCData" VALUES (548, 37, '2011-10-03 00:00:00 ', 1317618000, 1.3871, 1.3940999999999999, 1.375, 1.3914);
INSERT INTO "OHLCData" VALUES (549, 37, '2011-10-04 00:00:00 ', 1317704400, 1.3913, 1.4083000000000001, 1.3861000000000001, 1.3935);
INSERT INTO "OHLCData" VALUES (550, 37, '2011-10-05 00:00:00 ', 1317790800, 1.3934, 1.3954, 1.3795999999999999, 1.3835);
INSERT INTO "OHLCData" VALUES (551, 37, '2011-10-06 00:00:00 ', 1317877200, 1.3834, 1.3852, 1.3653, 1.3713);
INSERT INTO "OHLCData" VALUES (552, 37, '2011-10-07 00:00:00 ', 1317963600, 1.3712, 1.3754, 1.3644000000000001, 1.3688);
INSERT INTO "OHLCData" VALUES (553, 37, '2011-10-09 17:00:00 ', 1318197600, 1.3721000000000001, 1.3734999999999999, 1.3652, 1.3696999999999999);
INSERT INTO "OHLCData" VALUES (554, 37, '2011-10-10 00:00:00 ', 1318222800, 1.3695999999999999, 1.371, 1.3627, 1.3673);
INSERT INTO "OHLCData" VALUES (555, 37, '2011-10-11 00:00:00 ', 1318309200, 1.3673999999999999, 1.3772, 1.3657999999999999, 1.3737999999999999);
INSERT INTO "OHLCData" VALUES (556, 37, '2011-10-12 00:00:00 ', 1318395600, 1.3738999999999999, 1.3748, 1.3459000000000001, 1.3520000000000001);
INSERT INTO "OHLCData" VALUES (557, 37, '2011-10-13 00:00:00 ', 1318482000, 1.3521000000000001, 1.3553999999999999, 1.3499000000000001, 1.3519000000000001);
INSERT INTO "OHLCData" VALUES (558, 37, '2011-10-14 00:00:00 ', 1318568400, 1.3517999999999999, 1.3519000000000001, 1.341, 1.3419000000000001);
INSERT INTO "OHLCData" VALUES (559, 37, '2011-10-16 17:00:00 ', 1318802400, 1.3424, 1.345, 1.3411, 1.3435999999999999);
INSERT INTO "OHLCData" VALUES (560, 37, '2011-10-17 00:00:00 ', 1318827600, 1.3436999999999999, 1.3532, 1.3389, 1.3485);
INSERT INTO "OHLCData" VALUES (561, 37, '2011-10-18 00:00:00 ', 1318914000, 1.3487, 1.3539000000000001, 1.3366, 1.3419000000000001);
INSERT INTO "OHLCData" VALUES (562, 37, '2011-10-19 00:00:00 ', 1319000400, 1.3418000000000001, 1.3480000000000001, 1.3364, 1.3460000000000001);
INSERT INTO "OHLCData" VALUES (563, 37, '2011-10-20 00:00:00 ', 1319086800, 1.3461000000000001, 1.3493999999999999, 1.3385, 1.3492);
INSERT INTO "OHLCData" VALUES (564, 37, '2011-10-21 00:00:00 ', 1319173200, 1.349, 1.3492999999999999, 1.3381000000000001, 1.3386);
INSERT INTO "OHLCData" VALUES (565, 37, '2011-10-23 17:00:00 ', 1319407200, 1.3391, 1.3429, 1.3331999999999999, 1.3331999999999999);
INSERT INTO "OHLCData" VALUES (566, 37, '2011-10-24 00:00:00 ', 1319432400, 1.3331, 1.3389, 1.3265, 1.3275999999999999);
INSERT INTO "OHLCData" VALUES (567, 37, '2011-10-25 00:00:00 ', 1319518800, 1.3277000000000001, 1.3434999999999999, 1.3268, 1.3427);
INSERT INTO "OHLCData" VALUES (568, 37, '2011-10-26 00:00:00 ', 1319605200, 1.3426, 1.3465, 1.3312999999999999, 1.3319000000000001);
INSERT INTO "OHLCData" VALUES (569, 37, '2011-10-27 00:00:00 ', 1319691600, 1.3320000000000001, 1.3331, 1.3177000000000001, 1.3263);
INSERT INTO "OHLCData" VALUES (570, 37, '2011-10-28 00:00:00 ', 1319778000, 1.3262, 1.3292999999999999, 1.3199000000000001, 1.3217000000000001);
INSERT INTO "OHLCData" VALUES (571, 37, '2011-10-30 17:01:00 ', 1320012060, 1.321, 1.3319000000000001, 1.3196000000000001, 1.3305);
INSERT INTO "OHLCData" VALUES (572, 37, '2011-10-31 00:00:00 ', 1320037200, 1.3304, 1.3314999999999999, 1.3107, 1.3194999999999999);
INSERT INTO "OHLCData" VALUES (573, 37, '2011-11-01 00:00:00 ', 1320123600, 1.3193999999999999, 1.3294999999999999, 1.3179000000000001, 1.3247);
INSERT INTO "OHLCData" VALUES (574, 37, '2011-11-02 00:00:00 ', 1320210000, 1.3248, 1.3387, 1.3190999999999999, 1.3351999999999999);
INSERT INTO "OHLCData" VALUES (575, 37, '2011-11-03 00:00:00 ', 1320296400, 1.3351, 1.3385, 1.3169, 1.3303);
INSERT INTO "OHLCData" VALUES (576, 37, '2011-11-04 00:00:00 ', 1320382800, 1.3302, 1.3347, 1.3240000000000001, 1.3289);
INSERT INTO "OHLCData" VALUES (577, 37, '2011-11-06 17:01:00 ', 1320620460, 1.3277000000000001, 1.3293999999999999, 1.3237000000000001, 1.3281000000000001);
INSERT INTO "OHLCData" VALUES (578, 37, '2011-11-07 00:00:00 ', 1320645600, 1.3280000000000001, 1.3334999999999999, 1.3249, 1.3311999999999999);
INSERT INTO "OHLCData" VALUES (579, 37, '2011-11-08 00:00:00 ', 1320732000, 1.3310999999999999, 1.3364, 1.3294999999999999, 1.3349);
INSERT INTO "OHLCData" VALUES (580, 37, '2011-11-09 00:00:00 ', 1320818400, 1.3348, 1.3384, 1.3295999999999999, 1.3339000000000001);
INSERT INTO "OHLCData" VALUES (581, 37, '2011-11-10 00:00:00 ', 1320904800, 1.3338000000000001, 1.3451, 1.3331999999999999, 1.3407);
INSERT INTO "OHLCData" VALUES (582, 37, '2011-11-11 00:00:00 ', 1320991200, 1.3408, 1.3461000000000001, 1.3358000000000001, 1.3376999999999999);
INSERT INTO "OHLCData" VALUES (583, 37, '2011-11-13 17:00:00 ', 1321225200, 1.3347, 1.3368, 1.3325, 1.3367);
INSERT INTO "OHLCData" VALUES (584, 37, '2011-11-14 00:00:00 ', 1321250400, 1.3368, 1.3388, 1.3326, 1.3371);
INSERT INTO "OHLCData" VALUES (585, 37, '2011-11-15 00:00:00 ', 1321336800, 1.337, 1.3372999999999999, 1.3279000000000001, 1.3347);
INSERT INTO "OHLCData" VALUES (586, 37, '2011-11-16 00:00:00 ', 1321423200, 1.3346, 1.3398000000000001, 1.3298000000000001, 1.335);
INSERT INTO "OHLCData" VALUES (587, 37, '2011-11-17 00:00:00 ', 1321509600, 1.3349, 1.349, 1.3339000000000001, 1.3475999999999999);
INSERT INTO "OHLCData" VALUES (588, 37, '2011-11-18 00:00:00 ', 1321596000, 1.3476999999999999, 1.3528, 1.3436999999999999, 1.3508);
INSERT INTO "OHLCData" VALUES (589, 37, '2011-11-20 17:00:00 ', 1321830000, 1.3512999999999999, 1.3587, 1.3496999999999999, 1.3549);
INSERT INTO "OHLCData" VALUES (590, 37, '2011-11-21 00:00:00 ', 1321855200, 1.3548, 1.3747, 1.3536999999999999, 1.3689);
INSERT INTO "OHLCData" VALUES (591, 37, '2011-11-22 00:00:00 ', 1321941600, 1.3688, 1.3787, 1.367, 1.3774999999999999);
INSERT INTO "OHLCData" VALUES (592, 37, '2011-11-23 00:00:00 ', 1322028000, 1.3775999999999999, 1.3805000000000001, 1.3721000000000001, 1.3740000000000001);
INSERT INTO "OHLCData" VALUES (593, 37, '2011-11-24 00:00:00 ', 1322114400, 1.3738999999999999, 1.3762000000000001, 1.3682000000000001, 1.3720000000000001);
INSERT INTO "OHLCData" VALUES (594, 37, '2011-11-25 00:00:00 ', 1322200800, 1.3717999999999999, 1.3724000000000001, 1.3579000000000001, 1.3628);
INSERT INTO "OHLCData" VALUES (595, 37, '2011-11-27 17:00:00 ', 1322434800, 1.3556999999999999, 1.3586, 1.3480000000000001, 1.3504);
INSERT INTO "OHLCData" VALUES (596, 37, '2011-11-28 00:00:00 ', 1322460000, 1.3505, 1.3513999999999999, 1.3411999999999999, 1.3433999999999999);
INSERT INTO "OHLCData" VALUES (597, 37, '2011-11-29 00:00:00 ', 1322546400, 1.3432999999999999, 1.3433999999999999, 1.3234999999999999, 1.3301000000000001);
INSERT INTO "OHLCData" VALUES (598, 37, '2011-11-30 00:00:00 ', 1322632800, 1.3300000000000001, 1.3351999999999999, 1.3057000000000001, 1.3128);
INSERT INTO "OHLCData" VALUES (599, 37, '2011-12-01 00:00:00 ', 1322719200, 1.3127, 1.3227, 1.3125, 1.3158000000000001);
INSERT INTO "OHLCData" VALUES (600, 37, '2011-12-02 00:00:00 ', 1322805600, 1.3159000000000001, 1.3185, 1.3065, 1.3105);
INSERT INTO "OHLCData" VALUES (601, 37, '2011-12-04 17:01:00 ', 1323039660, 1.30742, 1.3127599999999999, 1.3073999999999999, 1.3122499999999999);
INSERT INTO "OHLCData" VALUES (602, 37, '2011-12-05 00:00:00 ', 1323064800, 1.3122199999999999, 1.3145800000000001, 1.3024, 1.31392);
INSERT INTO "OHLCData" VALUES (603, 37, '2011-12-06 00:00:00 ', 1323151200, 1.31393, 1.3149999999999999, 1.30461, 1.3071699999999999);
INSERT INTO "OHLCData" VALUES (604, 37, '2011-12-07 00:00:00 ', 1323237600, 1.3071600000000001, 1.3088900000000001, 1.30185, 1.3053300000000001);
INSERT INTO "OHLCData" VALUES (605, 37, '2011-12-08 00:00:00 ', 1323324000, 1.3053399999999999, 1.3193299999999999, 1.2960499999999999, 1.3161700000000001);
INSERT INTO "OHLCData" VALUES (606, 37, '2011-12-09 00:00:00 ', 1323410400, 1.3161499999999999, 1.3224899999999999, 1.3076300000000001, 1.3101799999999999);
INSERT INTO "OHLCData" VALUES (607, 37, '2011-12-11 17:00:00 ', 1323644400, 1.3105500000000001, 1.3129900000000001, 1.30884, 1.3115600000000001);
INSERT INTO "OHLCData" VALUES (608, 37, '2011-12-12 00:00:00 ', 1323669600, 1.3115399999999999, 1.3154399999999999, 1.3072900000000001, 1.3078099999999999);
INSERT INTO "OHLCData" VALUES (609, 37, '2011-12-13 00:00:00 ', 1323756000, 1.30782, 1.3088200000000001, 1.2964100000000001, 1.3010299999999999);
INSERT INTO "OHLCData" VALUES (610, 37, '2011-12-14 00:00:00 ', 1323842400, 1.30105, 1.31419, 1.29979, 1.3124100000000001);
INSERT INTO "OHLCData" VALUES (611, 37, '2011-12-15 00:00:00 ', 1323928800, 1.3124400000000001, 1.3163499999999999, 1.3048599999999999, 1.3054600000000001);
INSERT INTO "OHLCData" VALUES (612, 37, '2011-12-16 00:00:00 ', 1324015200, 1.3054699999999999, 1.3086100000000001, 1.3010999999999999, 1.3065100000000001);
INSERT INTO "OHLCData" VALUES (613, 37, '2011-12-18 17:00:00 ', 1324249200, 1.3056099999999999, 1.3130200000000001, 1.30508, 1.31131);
INSERT INTO "OHLCData" VALUES (614, 37, '2011-12-19 00:00:00 ', 1324274400, 1.31132, 1.3149599999999999, 1.3069900000000001, 1.30844);
INSERT INTO "OHLCData" VALUES (615, 37, '2011-12-20 00:00:00 ', 1324360800, 1.30843, 1.3104199999999999, 1.2927599999999999, 1.29328);
INSERT INTO "OHLCData" VALUES (616, 37, '2011-12-21 00:00:00 ', 1324447200, 1.2932900000000001, 1.29735, 1.2862199999999999, 1.29359);
INSERT INTO "OHLCData" VALUES (617, 37, '2011-12-22 00:00:00 ', 1324533600, 1.2936099999999999, 1.29515, 1.28366, 1.2848599999999999);
INSERT INTO "OHLCData" VALUES (618, 37, '2011-12-23 00:00:00 ', 1324620000, 1.28487, 1.28928, 1.2835399999999999, 1.2853699999999999);
INSERT INTO "OHLCData" VALUES (619, 37, '2011-12-26 02:01:00 ', 1324886460, 1.2844, 1.2891900000000001, 1.28305, 1.28739);
INSERT INTO "OHLCData" VALUES (620, 37, '2011-12-27 00:00:00 ', 1324965600, 1.28738, 1.2885800000000001, 1.28406, 1.2861499999999999);
INSERT INTO "OHLCData" VALUES (621, 37, '2011-12-28 00:00:00 ', 1325052000, 1.28616, 1.28708, 1.2769600000000001, 1.2798700000000001);
INSERT INTO "OHLCData" VALUES (622, 37, '2011-12-29 00:00:00 ', 1325138400, 1.27986, 1.2824899999999999, 1.2731399999999999, 1.27417);
INSERT INTO "OHLCData" VALUES (623, 37, '2011-12-30 00:00:00 ', 1325224800, 1.2742, 1.2750900000000001, 1.26301, 1.26938);
INSERT INTO "OHLCData" VALUES (624, 37, '2012-01-02 02:00:00 ', 1325491200, 1.26597, 1.2705, 1.2592000000000001, 1.26067);
INSERT INTO "OHLCData" VALUES (625, 37, '2012-01-03 00:00:00 ', 1325570400, 1.26068, 1.2629999999999999, 1.25665, 1.25888);
INSERT INTO "OHLCData" VALUES (626, 37, '2012-01-04 00:00:00 ', 1325656800, 1.2588600000000001, 1.26108, 1.24743, 1.2517499999999999);
INSERT INTO "OHLCData" VALUES (627, 37, '2012-01-05 00:00:00 ', 1325743200, 1.25173, 1.2544500000000001, 1.24444, 1.2497);
INSERT INTO "OHLCData" VALUES (628, 37, '2012-01-06 00:00:00 ', 1325829600, 1.24976, 1.2506299999999999, 1.2418800000000001, 1.2433700000000001);
INSERT INTO "OHLCData" VALUES (629, 37, '2012-01-08 17:00:00 ', 1326063600, 1.24394, 1.25041, 1.24231, 1.2480800000000001);
INSERT INTO "OHLCData" VALUES (630, 37, '2012-01-09 00:00:00 ', 1326088800, 1.24807, 1.25023, 1.2392099999999999, 1.2397499999999999);
INSERT INTO "OHLCData" VALUES (631, 37, '2012-01-10 00:00:00 ', 1326175200, 1.2397400000000001, 1.2411399999999999, 1.2360100000000001, 1.2387600000000001);
INSERT INTO "OHLCData" VALUES (632, 37, '2012-01-11 00:00:00 ', 1326261600, 1.23875, 1.2393799999999999, 1.2313000000000001, 1.2349600000000001);
INSERT INTO "OHLCData" VALUES (633, 37, '2012-01-12 00:00:00 ', 1326348000, 1.23495, 1.24386, 1.22977, 1.24309);
INSERT INTO "OHLCData" VALUES (634, 37, '2012-01-13 00:00:00 ', 1326434400, 1.24315, 1.2445900000000001, 1.22638, 1.22827);
INSERT INTO "OHLCData" VALUES (635, 37, '2012-01-15 17:00:00 ', 1326668400, 1.22851, 1.2325299999999999, 1.2263999999999999, 1.2301800000000001);
INSERT INTO "OHLCData" VALUES (636, 37, '2012-01-16 00:00:00 ', 1326693600, 1.2301899999999999, 1.2302599999999999, 1.2245999999999999, 1.2257100000000001);
INSERT INTO "OHLCData" VALUES (637, 37, '2012-01-17 00:00:00 ', 1326780000, 1.2257, 1.23142, 1.2226300000000001, 1.2289600000000001);
INSERT INTO "OHLCData" VALUES (638, 37, '2012-01-18 00:00:00 ', 1326866400, 1.22895, 1.23851, 1.22767, 1.23672);
INSERT INTO "OHLCData" VALUES (639, 37, '2012-01-19 00:00:00 ', 1326952800, 1.2367600000000001, 1.24624, 1.23644, 1.2461500000000001);
INSERT INTO "OHLCData" VALUES (640, 37, '2012-01-20 00:00:00 ', 1327039200, 1.2461599999999999, 1.2462299999999999, 1.2327999999999999, 1.2331000000000001);
INSERT INTO "OHLCData" VALUES (641, 37, '2012-01-22 17:00:00 ', 1327273200, 1.2290000000000001, 1.2327399999999999, 1.22715, 1.22916);
INSERT INTO "OHLCData" VALUES (642, 37, '2012-01-23 00:00:00 ', 1327298400, 1.2291700000000001, 1.23909, 1.2278100000000001, 1.2384299999999999);
INSERT INTO "OHLCData" VALUES (643, 37, '2012-01-24 00:00:00 ', 1327384800, 1.23841, 1.24776, 1.23661, 1.2382899999999999);
INSERT INTO "OHLCData" VALUES (644, 37, '2012-01-25 00:00:00 ', 1327471200, 1.2383200000000001, 1.24085, 1.23414, 1.2348399999999999);
INSERT INTO "OHLCData" VALUES (645, 37, '2012-01-26 00:00:00 ', 1327557600, 1.23488, 1.23648, 1.23122, 1.23421);
INSERT INTO "OHLCData" VALUES (646, 37, '2012-01-27 00:00:00 ', 1327644000, 1.2341899999999999, 1.2426999999999999, 1.22932, 1.2401899999999999);
INSERT INTO "OHLCData" VALUES (647, 37, '2012-01-29 17:00:00 ', 1327878000, 1.24298, 1.24587, 1.24054, 1.2443900000000001);
INSERT INTO "OHLCData" VALUES (648, 37, '2012-01-30 00:00:00 ', 1327903200, 1.24438, 1.2475700000000001, 1.2377100000000001, 1.24);
INSERT INTO "OHLCData" VALUES (649, 37, '2012-01-31 00:00:00 ', 1327989600, 1.23997, 1.24108, 1.22845, 1.2313400000000001);
INSERT INTO "OHLCData" VALUES (650, 37, '2012-02-01 00:00:00 ', 1328076000, 1.23136, 1.2324299999999999, 1.2264900000000001, 1.2287300000000001);
INSERT INTO "OHLCData" VALUES (651, 37, '2012-02-02 00:00:00 ', 1328162400, 1.22864, 1.2298100000000001, 1.22329, 1.2291399999999999);
INSERT INTO "OHLCData" VALUES (652, 37, '2012-02-03 00:00:00 ', 1328248800, 1.22915, 1.2318199999999999, 1.2166300000000001, 1.22146);
INSERT INTO "OHLCData" VALUES (653, 37, '2012-02-05 17:01:00 ', 1328482860, 1.2195400000000001, 1.2219899999999999, 1.2185299999999999, 1.2208600000000001);
INSERT INTO "OHLCData" VALUES (654, 37, '2012-02-06 00:00:00 ', 1328508000, 1.22088, 1.22546, 1.21377, 1.21536);
INSERT INTO "OHLCData" VALUES (655, 37, '2012-02-07 00:00:00 ', 1328594400, 1.2153700000000001, 1.22864, 1.2131099999999999, 1.22706);
INSERT INTO "OHLCData" VALUES (656, 37, '2012-02-08 00:00:00 ', 1328680800, 1.22705, 1.23217, 1.22295, 1.2291300000000001);
INSERT INTO "OHLCData" VALUES (657, 37, '2012-02-09 00:00:00 ', 1328767200, 1.22905, 1.2379199999999999, 1.2271700000000001, 1.23773);
INSERT INTO "OHLCData" VALUES (658, 37, '2012-02-10 00:00:00 ', 1328853600, 1.2377, 1.2417899999999999, 1.23393, 1.2363200000000001);
INSERT INTO "OHLCData" VALUES (659, 37, '2012-02-12 17:00:00 ', 1329087600, 1.2354499999999999, 1.2375799999999999, 1.2328699999999999, 1.2337100000000001);
INSERT INTO "OHLCData" VALUES (660, 37, '2012-02-13 00:00:00 ', 1329112800, 1.23373, 1.23472, 1.2276800000000001, 1.2320800000000001);
INSERT INTO "OHLCData" VALUES (661, 37, '2012-02-14 00:00:00 ', 1329199200, 1.2320899999999999, 1.23308, 1.2250000000000001, 1.2261299999999999);
INSERT INTO "OHLCData" VALUES (662, 37, '2012-02-15 00:00:00 ', 1329285600, 1.2261500000000001, 1.22662, 1.2147399999999999, 1.21848);
INSERT INTO "OHLCData" VALUES (663, 37, '2012-02-16 00:00:00 ', 1329372000, 1.2184600000000001, 1.2225699999999999, 1.2149000000000001, 1.21882);
INSERT INTO "OHLCData" VALUES (664, 37, '2012-02-17 00:00:00 ', 1329458400, 1.2188099999999999, 1.2302599999999999, 1.21794, 1.2270799999999999);
INSERT INTO "OHLCData" VALUES (665, 37, '2012-02-19 17:00:00 ', 1329692400, 1.2232000000000001, 1.2263200000000001, 1.2228300000000001, 1.2254799999999999);
INSERT INTO "OHLCData" VALUES (666, 37, '2012-02-20 00:00:00 ', 1329717600, 1.2254700000000001, 1.23793, 1.22516, 1.2372399999999999);
INSERT INTO "OHLCData" VALUES (667, 37, '2012-02-21 00:00:00 ', 1329804000, 1.2372799999999999, 1.2450000000000001, 1.23532, 1.24152);
INSERT INTO "OHLCData" VALUES (668, 37, '2012-02-22 00:00:00 ', 1329890400, 1.2415400000000001, 1.2484200000000001, 1.2390300000000001, 1.2452000000000001);
INSERT INTO "OHLCData" VALUES (669, 37, '2012-02-23 00:00:00 ', 1329976800, 1.24519, 1.2498100000000001, 1.24105, 1.24492);
INSERT INTO "OHLCData" VALUES (670, 37, '2012-02-24 00:00:00 ', 1330063200, 1.24491, 1.2590699999999999, 1.2441199999999999, 1.2572700000000001);
INSERT INTO "OHLCData" VALUES (671, 37, '2012-02-26 17:00:00 ', 1330297200, 1.25745, 1.26169, 1.2563, 1.25817);
INSERT INTO "OHLCData" VALUES (672, 37, '2012-02-27 00:00:00 ', 1330322400, 1.2581599999999999, 1.2612000000000001, 1.24261, 1.2466600000000001);
INSERT INTO "OHLCData" VALUES (673, 37, '2012-02-28 00:00:00 ', 1330408800, 1.24664, 1.25231, 1.24539, 1.2465200000000001);
INSERT INTO "OHLCData" VALUES (674, 37, '2012-02-29 00:00:00 ', 1330495200, 1.2465299999999999, 1.24695, 1.23695, 1.23994);
INSERT INTO "OHLCData" VALUES (675, 37, '2012-03-01 00:00:00 ', 1330581600, 1.23993, 1.2424999999999999, 1.2310000000000001, 1.232);
INSERT INTO "OHLCData" VALUES (676, 37, '2012-03-02 00:00:00 ', 1330668000, 1.2320500000000001, 1.2334000000000001, 1.2259899999999999, 1.22953);
INSERT INTO "OHLCData" VALUES (677, 37, '2012-03-04 17:00:00 ', 1330902000, 1.228, 1.23228, 1.2279599999999999, 1.2316100000000001);
INSERT INTO "OHLCData" VALUES (678, 37, '2012-03-05 00:00:00 ', 1330927200, 1.23163, 1.2439499999999999, 1.2306299999999999, 1.2433000000000001);
INSERT INTO "OHLCData" VALUES (679, 37, '2012-03-06 00:00:00 ', 1331013600, 1.2432099999999999, 1.24841, 1.2387699999999999, 1.24647);
INSERT INTO "OHLCData" VALUES (680, 37, '2012-03-07 00:00:00 ', 1331100000, 1.2464500000000001, 1.24705, 1.24092, 1.2421199999999999);
INSERT INTO "OHLCData" VALUES (681, 37, '2012-03-08 00:00:00 ', 1331186400, 1.24213, 1.25187, 1.23895, 1.24468);
INSERT INTO "OHLCData" VALUES (682, 37, '2012-03-09 00:00:00 ', 1331272800, 1.24465, 1.24577, 1.2347900000000001, 1.24068);
INSERT INTO "OHLCData" VALUES (683, 37, '2012-03-11 17:00:00 ', 1331503200, 1.2411099999999999, 1.2440500000000001, 1.2403599999999999, 1.24265);
INSERT INTO "OHLCData" VALUES (684, 37, '2012-03-12 00:00:00 ', 1331528400, 1.24264, 1.25447, 1.2419899999999999, 1.24871);
INSERT INTO "OHLCData" VALUES (685, 37, '2012-03-13 00:00:00 ', 1331614800, 1.2486900000000001, 1.2492799999999999, 1.2392300000000001, 1.2400199999999999);
INSERT INTO "OHLCData" VALUES (686, 37, '2012-03-14 00:00:00 ', 1331701200, 1.2399899999999999, 1.24861, 1.23858, 1.2455700000000001);
INSERT INTO "OHLCData" VALUES (687, 37, '2012-03-15 00:00:00 ', 1331787600, 1.2455799999999999, 1.2466299999999999, 1.2399199999999999, 1.2416199999999999);
INSERT INTO "OHLCData" VALUES (688, 37, '2012-03-16 00:00:00 ', 1331874000, 1.2416400000000001, 1.2455099999999999, 1.2390399999999999, 1.2439499999999999);
INSERT INTO "OHLCData" VALUES (689, 37, '2012-03-18 17:00:00 ', 1332108000, 1.2435, 1.2448900000000001, 1.24156, 1.24186);
INSERT INTO "OHLCData" VALUES (690, 37, '2012-03-19 00:00:00 ', 1332133200, 1.2418800000000001, 1.25325, 1.2403200000000001, 1.2508600000000001);
INSERT INTO "OHLCData" VALUES (691, 37, '2012-03-20 00:00:00 ', 1332219600, 1.2508699999999999, 1.2641800000000001, 1.25038, 1.2638199999999999);
INSERT INTO "OHLCData" VALUES (692, 37, '2012-03-21 00:00:00 ', 1332306000, 1.26387, 1.2738499999999999, 1.2610399999999999, 1.27302);
INSERT INTO "OHLCData" VALUES (693, 37, '2012-03-22 00:00:00 ', 1332392400, 1.2730300000000001, 1.2739100000000001, 1.2672399999999999, 1.2688900000000001);
INSERT INTO "OHLCData" VALUES (694, 37, '2012-03-23 00:00:00 ', 1332478800, 1.26891, 1.2754799999999999, 1.2653300000000001, 1.26762);
INSERT INTO "OHLCData" VALUES (695, 37, '2012-03-25 17:00:00 ', 1332712800, 1.2681500000000001, 1.2695799999999999, 1.26522, 1.26786);
INSERT INTO "OHLCData" VALUES (696, 37, '2012-03-26 00:00:00 ', 1332738000, 1.2678799999999999, 1.2709600000000001, 1.26217, 1.2701);
INSERT INTO "OHLCData" VALUES (697, 37, '2012-03-27 00:00:00 ', 1332824400, 1.2700899999999999, 1.2786999999999999, 1.2658700000000001, 1.2779100000000001);
INSERT INTO "OHLCData" VALUES (698, 37, '2012-03-28 00:00:00 ', 1332910800, 1.2779, 1.28694, 1.27685, 1.2855000000000001);
INSERT INTO "OHLCData" VALUES (699, 37, '2012-03-29 00:00:00 ', 1332997200, 1.2855099999999999, 1.2866899999999999, 1.2799100000000001, 1.28348);
INSERT INTO "OHLCData" VALUES (700, 37, '2012-03-30 00:00:00 ', 1333083600, 1.2835099999999999, 1.29094, 1.28172, 1.28949);
INSERT INTO "OHLCData" VALUES (701, 37, '2012-04-01 17:00:00 ', 1333317600, 1.27833, 1.28363, 1.27786, 1.2834700000000001);
INSERT INTO "OHLCData" VALUES (702, 37, '2012-04-02 00:00:00 ', 1333342800, 1.28348, 1.2863800000000001, 1.27597, 1.2776000000000001);
INSERT INTO "OHLCData" VALUES (703, 37, '2012-04-03 00:00:00 ', 1333429200, 1.2775300000000001, 1.2876700000000001, 1.2742500000000001, 1.2840400000000001);
INSERT INTO "OHLCData" VALUES (704, 37, '2012-04-04 00:00:00 ', 1333515600, 1.28407, 1.2850900000000001, 1.2756099999999999, 1.2759499999999999);
INSERT INTO "OHLCData" VALUES (705, 37, '2012-04-05 00:00:00 ', 1333602000, 1.2759400000000001, 1.27782, 1.2658700000000001, 1.26769);
INSERT INTO "OHLCData" VALUES (706, 37, '2012-04-06 00:00:00 ', 1333688400, 1.2676799999999999, 1.2743, 1.2648999999999999, 1.2700199999999999);
INSERT INTO "OHLCData" VALUES (707, 37, '2012-04-08 17:01:00 ', 1333922460, 1.27216, 1.2726900000000001, 1.26857, 1.2694399999999999);
INSERT INTO "OHLCData" VALUES (708, 37, '2012-04-09 00:00:00 ', 1333947600, 1.26945, 1.27349, 1.2664599999999999, 1.2725599999999999);
INSERT INTO "OHLCData" VALUES (709, 37, '2012-04-10 00:00:00 ', 1334034000, 1.2725200000000001, 1.2782, 1.2703, 1.27261);
INSERT INTO "OHLCData" VALUES (710, 37, '2012-04-11 00:00:00 ', 1334120400, 1.2726, 1.2760499999999999, 1.26481, 1.2657799999999999);
INSERT INTO "OHLCData" VALUES (711, 37, '2012-04-12 00:00:00 ', 1334206800, 1.26576, 1.2680400000000001, 1.2610699999999999, 1.26755);
INSERT INTO "OHLCData" VALUES (712, 37, '2012-04-13 00:00:00 ', 1334293200, 1.2675399999999999, 1.26854, 1.25895, 1.26095);
INSERT INTO "OHLCData" VALUES (713, 37, '2012-04-15 17:00:00 ', 1334527200, 1.25945, 1.26214, 1.25874, 1.2618400000000001);
INSERT INTO "OHLCData" VALUES (714, 37, '2012-04-16 00:00:00 ', 1334552400, 1.26183, 1.2695099999999999, 1.2569999999999999, 1.26911);
INSERT INTO "OHLCData" VALUES (715, 37, '2012-04-17 00:00:00 ', 1334638800, 1.2690399999999999, 1.2716400000000001, 1.2599100000000001, 1.26108);
INSERT INTO "OHLCData" VALUES (716, 37, '2012-04-18 00:00:00 ', 1334725200, 1.26109, 1.2676000000000001, 1.25986, 1.2657099999999999);
INSERT INTO "OHLCData" VALUES (717, 37, '2012-04-19 00:00:00 ', 1334811600, 1.26573, 1.2736499999999999, 1.2642, 1.27233);
INSERT INTO "OHLCData" VALUES (718, 37, '2012-04-20 00:00:00 ', 1334898000, 1.2723199999999999, 1.2764, 1.2711699999999999, 1.27345);
INSERT INTO "OHLCData" VALUES (719, 37, '2012-04-22 17:00:00 ', 1335132000, 1.2712699999999999, 1.27671, 1.2708600000000001, 1.2748299999999999);
INSERT INTO "OHLCData" VALUES (720, 37, '2012-04-23 00:00:00 ', 1335157200, 1.27484, 1.28288, 1.2737099999999999, 1.2822199999999999);
INSERT INTO "OHLCData" VALUES (721, 37, '2012-04-24 00:00:00 ', 1335243600, 1.28217, 1.28348, 1.27641, 1.2793600000000001);
INSERT INTO "OHLCData" VALUES (722, 37, '2012-04-25 00:00:00 ', 1335330000, 1.2793699999999999, 1.2800400000000001, 1.2742599999999999, 1.27545);
INSERT INTO "OHLCData" VALUES (723, 37, '2012-04-26 00:00:00 ', 1335416400, 1.2754000000000001, 1.2763, 1.2707999999999999, 1.2716099999999999);
INSERT INTO "OHLCData" VALUES (724, 37, '2012-04-27 00:00:00 ', 1335502800, 1.2716000000000001, 1.2723599999999999, 1.2645900000000001, 1.26573);
INSERT INTO "OHLCData" VALUES (725, 37, '2012-04-29 17:00:00 ', 1335736800, 1.26566, 1.2681100000000001, 1.26467, 1.2673399999999999);
INSERT INTO "OHLCData" VALUES (726, 37, '2012-04-30 00:00:00 ', 1335762000, 1.2673300000000001, 1.27346, 1.2667200000000001, 1.2730900000000001);
INSERT INTO "OHLCData" VALUES (727, 37, '2012-05-01 00:00:00 ', 1335848400, 1.2730999999999999, 1.2865899999999999, 1.2712399999999999, 1.2786999999999999);
INSERT INTO "OHLCData" VALUES (728, 37, '2012-05-02 00:00:00 ', 1335934800, 1.27871, 1.2794000000000001, 1.2712399999999999, 1.2760499999999999);
INSERT INTO "OHLCData" VALUES (729, 37, '2012-05-03 00:00:00 ', 1336021200, 1.2759799999999999, 1.28338, 1.27413, 1.28189);
INSERT INTO "OHLCData" VALUES (730, 37, '2012-05-04 00:00:00 ', 1336107600, 1.2819, 1.2919099999999999, 1.2799499999999999, 1.28481);
INSERT INTO "OHLCData" VALUES (731, 37, '2012-05-06 17:00:00 ', 1336341600, 1.2813399999999999, 1.28352, 1.27963, 1.28043);
INSERT INTO "OHLCData" VALUES (732, 37, '2012-05-07 00:00:00 ', 1336366800, 1.2804500000000001, 1.2817700000000001, 1.2771399999999999, 1.28027);
INSERT INTO "OHLCData" VALUES (733, 37, '2012-05-08 00:00:00 ', 1336453200, 1.2802500000000001, 1.2893600000000001, 1.27857, 1.2893399999999999);
INSERT INTO "OHLCData" VALUES (734, 37, '2012-05-09 00:00:00 ', 1336539600, 1.28935, 1.2902, 1.2796700000000001, 1.2835099999999999);
INSERT INTO "OHLCData" VALUES (735, 37, '2012-05-10 00:00:00 ', 1336626000, 1.28348, 1.28685, 1.2781100000000001, 1.28369);
INSERT INTO "OHLCData" VALUES (736, 37, '2012-05-11 00:00:00 ', 1336712400, 1.2836700000000001, 1.2898700000000001, 1.28328, 1.28894);
INSERT INTO "OHLCData" VALUES (737, 37, '2012-05-13 17:00:00 ', 1336946400, 1.2883199999999999, 1.28854, 1.28548, 1.2866599999999999);
INSERT INTO "OHLCData" VALUES (738, 37, '2012-05-14 00:00:00 ', 1336971600, 1.2866899999999999, 1.2914099999999999, 1.2843899999999999, 1.28664);
INSERT INTO "OHLCData" VALUES (739, 37, '2012-05-15 00:00:00 ', 1337058000, 1.2866200000000001, 1.2866200000000001, 1.27833, 1.2829699999999999);
INSERT INTO "OHLCData" VALUES (740, 37, '2012-05-16 00:00:00 ', 1337144400, 1.28295, 1.2855700000000001, 1.2784599999999999, 1.2818700000000001);
INSERT INTO "OHLCData" VALUES (741, 37, '2012-05-17 00:00:00 ', 1337230800, 1.28186, 1.2888900000000001, 1.2770699999999999, 1.2888299999999999);
INSERT INTO "OHLCData" VALUES (742, 37, '2012-05-18 00:00:00 ', 1337317200, 1.28878, 1.30284, 1.2858099999999999, 1.29799);
INSERT INTO "OHLCData" VALUES (743, 37, '2012-05-20 17:00:00 ', 1337551200, 1.2972600000000001, 1.3007, 1.2962400000000001, 1.29792);
INSERT INTO "OHLCData" VALUES (744, 37, '2012-05-21 00:00:00 ', 1337576400, 1.2979099999999999, 1.29922, 1.2907, 1.2919799999999999);
INSERT INTO "OHLCData" VALUES (745, 37, '2012-05-22 00:00:00 ', 1337662800, 1.29199, 1.2991299999999999, 1.2880499999999999, 1.2976799999999999);
INSERT INTO "OHLCData" VALUES (746, 37, '2012-05-23 00:00:00 ', 1337749200, 1.2977000000000001, 1.2988999999999999, 1.2878099999999999, 1.2903100000000001);
INSERT INTO "OHLCData" VALUES (747, 37, '2012-05-24 00:00:00 ', 1337835600, 1.2903, 1.2908599999999999, 1.2820199999999999, 1.2864599999999999);
INSERT INTO "OHLCData" VALUES (748, 37, '2012-05-25 00:00:00 ', 1337922000, 1.28647, 1.2870600000000001, 1.2793300000000001, 1.2825200000000001);
INSERT INTO "OHLCData" VALUES (749, 37, '2012-05-27 17:02:00 ', 1338156120, 1.2802500000000001, 1.2827900000000001, 1.2767999999999999, 1.27708);
INSERT INTO "OHLCData" VALUES (750, 37, '2012-05-28 00:00:00 ', 1338181200, 1.2770900000000001, 1.2781199999999999, 1.2719199999999999, 1.27223);
INSERT INTO "OHLCData" VALUES (751, 37, '2012-05-29 00:00:00 ', 1338267600, 1.2722199999999999, 1.27511, 1.26824, 1.2730999999999999);
INSERT INTO "OHLCData" VALUES (752, 37, '2012-05-30 00:00:00 ', 1338354000, 1.2730900000000001, 1.2776400000000001, 1.2718100000000001, 1.2757400000000001);
INSERT INTO "OHLCData" VALUES (753, 37, '2012-05-31 00:00:00 ', 1338440400, 1.27576, 1.2770699999999999, 1.26658, 1.27484);
INSERT INTO "OHLCData" VALUES (754, 37, '2012-06-01 00:00:00 ', 1338526800, 1.27485, 1.28423, 1.27339, 1.2820499999999999);
INSERT INTO "OHLCData" VALUES (755, 37, '2012-06-03 17:00:00 ', 1338760800, 1.2800199999999999, 1.28647, 1.2798799999999999, 1.28532);
INSERT INTO "OHLCData" VALUES (756, 37, '2012-06-04 00:00:00 ', 1338786000, 1.28529, 1.2870699999999999, 1.27919, 1.2835099999999999);
INSERT INTO "OHLCData" VALUES (757, 37, '2012-06-05 00:00:00 ', 1338872400, 1.28349, 1.2873600000000001, 1.26692, 1.2686299999999999);
INSERT INTO "OHLCData" VALUES (758, 37, '2012-06-06 00:00:00 ', 1338958800, 1.2685900000000001, 1.2715399999999999, 1.26152, 1.26278);
INSERT INTO "OHLCData" VALUES (759, 37, '2012-06-07 00:00:00 ', 1339045200, 1.2627900000000001, 1.2718499999999999, 1.2594700000000001, 1.26993);
INSERT INTO "OHLCData" VALUES (760, 37, '2012-06-08 00:00:00 ', 1339131600, 1.2699499999999999, 1.27098, 1.2585200000000001, 1.2619499999999999);
INSERT INTO "OHLCData" VALUES (761, 37, '2012-06-10 17:00:00 ', 1339365600, 1.2655099999999999, 1.2679800000000001, 1.2636499999999999, 1.2657);
INSERT INTO "OHLCData" VALUES (762, 37, '2012-06-11 00:00:00 ', 1339390800, 1.2657099999999999, 1.2665299999999999, 1.2586200000000001, 1.2617100000000001);
INSERT INTO "OHLCData" VALUES (763, 37, '2012-06-12 00:00:00 ', 1339477200, 1.26173, 1.26295, 1.2547699999999999, 1.2552300000000001);
INSERT INTO "OHLCData" VALUES (764, 37, '2012-06-13 00:00:00 ', 1339563600, 1.2552399999999999, 1.2648999999999999, 1.2551300000000001, 1.26186);
INSERT INTO "OHLCData" VALUES (765, 37, '2012-06-14 00:00:00 ', 1339650000, 1.26187, 1.26535, 1.25909, 1.2604900000000001);
INSERT INTO "OHLCData" VALUES (766, 37, '2012-06-15 00:00:00 ', 1339736400, 1.26048, 1.26189, 1.2525200000000001, 1.2532000000000001);
INSERT INTO "OHLCData" VALUES (767, 37, '2012-06-17 17:00:00 ', 1339970400, 1.2549399999999999, 1.2594399999999999, 1.25424, 1.2554399999999999);
INSERT INTO "OHLCData" VALUES (768, 37, '2012-06-18 00:00:00 ', 1339995600, 1.25543, 1.2571099999999999, 1.23943, 1.24474);
INSERT INTO "OHLCData" VALUES (769, 37, '2012-06-19 00:00:00 ', 1340082000, 1.2446900000000001, 1.24807, 1.2404900000000001, 1.24475);
INSERT INTO "OHLCData" VALUES (770, 37, '2012-06-20 00:00:00 ', 1340168400, 1.24472, 1.2487999999999999, 1.24302, 1.24708);
INSERT INTO "OHLCData" VALUES (771, 37, '2012-06-21 00:00:00 ', 1340254800, 1.2471300000000001, 1.2510600000000001, 1.2433700000000001, 1.2483299999999999);
INSERT INTO "OHLCData" VALUES (772, 37, '2012-06-22 00:00:00 ', 1340341200, 1.2483200000000001, 1.25261, 1.24624, 1.24884);
INSERT INTO "OHLCData" VALUES (773, 37, '2012-06-24 17:00:00 ', 1340575200, 1.2487600000000001, 1.2505999999999999, 1.24814, 1.2490399999999999);
INSERT INTO "OHLCData" VALUES (774, 37, '2012-06-25 00:00:00 ', 1340600400, 1.2490699999999999, 1.25153, 1.2466900000000001, 1.24817);
INSERT INTO "OHLCData" VALUES (775, 37, '2012-06-26 00:00:00 ', 1340686800, 1.2481800000000001, 1.24824, 1.2393400000000001, 1.24231);
INSERT INTO "OHLCData" VALUES (776, 37, '2012-06-27 00:00:00 ', 1340773200, 1.2423299999999999, 1.24346, 1.2337800000000001, 1.23672);
INSERT INTO "OHLCData" VALUES (777, 37, '2012-06-28 00:00:00 ', 1340859600, 1.23671, 1.2438899999999999, 1.2325699999999999, 1.24047);
INSERT INTO "OHLCData" VALUES (778, 37, '2012-06-29 00:00:00 ', 1340946000, 1.2404500000000001, 1.24065, 1.2335100000000001, 1.23542);
INSERT INTO "OHLCData" VALUES (779, 37, '2012-07-01 17:00:00 ', 1341180000, 1.23491, 1.2362, 1.23387, 1.23447);
INSERT INTO "OHLCData" VALUES (780, 37, '2012-07-02 00:00:00 ', 1341205200, 1.2344999999999999, 1.2346999999999999, 1.2245600000000001, 1.2265299999999999);
INSERT INTO "OHLCData" VALUES (781, 37, '2012-07-03 00:00:00 ', 1341291600, 1.2265200000000001, 1.2284900000000001, 1.22024, 1.2236899999999999);
INSERT INTO "OHLCData" VALUES (782, 37, '2012-07-04 00:00:00 ', 1341378000, 1.2236800000000001, 1.22559, 1.2166699999999999, 1.2211700000000001);
INSERT INTO "OHLCData" VALUES (783, 37, '2012-07-05 00:00:00 ', 1341464400, 1.22115, 1.2215199999999999, 1.202, 1.2070399999999999);
INSERT INTO "OHLCData" VALUES (784, 37, '2012-07-06 00:00:00 ', 1341550800, 1.20699, 1.20838, 1.2007699999999999, 1.20336);
INSERT INTO "OHLCData" VALUES (785, 37, '2012-07-08 17:00:00 ', 1341784800, 1.20241, 1.2061999999999999, 1.2009700000000001, 1.2059);
INSERT INTO "OHLCData" VALUES (786, 37, '2012-07-09 00:00:00 ', 1341810000, 1.2058500000000001, 1.2095800000000001, 1.2051700000000001, 1.20858);
INSERT INTO "OHLCData" VALUES (787, 37, '2012-07-10 00:00:00 ', 1341896400, 1.2085900000000001, 1.2087300000000001, 1.19859, 1.2015800000000001);
INSERT INTO "OHLCData" VALUES (788, 37, '2012-07-11 00:00:00 ', 1341982800, 1.20157, 1.2017199999999999, 1.1933499999999999, 1.20126);
INSERT INTO "OHLCData" VALUES (789, 37, '2012-07-12 00:00:00 ', 1342069200, 1.2012400000000001, 1.2059299999999999, 1.2001200000000001, 1.2003200000000001);
INSERT INTO "OHLCData" VALUES (790, 37, '2012-07-13 00:00:00 ', 1342155600, 1.20031, 1.2010099999999999, 1.19581, 1.19763);
INSERT INTO "OHLCData" VALUES (791, 37, '2012-07-15 17:00:00 ', 1342389600, 1.1968300000000001, 1.1982200000000001, 1.1953400000000001, 1.19722);
INSERT INTO "OHLCData" VALUES (792, 37, '2012-07-16 00:00:00 ', 1342414800, 1.19723, 1.19929, 1.1923600000000001, 1.1933800000000001);
INSERT INTO "OHLCData" VALUES (793, 37, '2012-07-17 00:00:00 ', 1342501200, 1.19337, 1.19618, 1.1891099999999999, 1.1925399999999999);
INSERT INTO "OHLCData" VALUES (794, 37, '2012-07-18 00:00:00 ', 1342587600, 1.19255, 1.19255, 1.1819200000000001, 1.1819200000000001);
INSERT INTO "OHLCData" VALUES (795, 37, '2012-07-19 00:00:00 ', 1342674000, 1.1819299999999999, 1.1832400000000001, 1.17414, 1.17814);
INSERT INTO "OHLCData" VALUES (796, 37, '2012-07-20 00:00:00 ', 1342760400, 1.1781299999999999, 1.17855, 1.1702900000000001, 1.1712499999999999);
INSERT INTO "OHLCData" VALUES (797, 37, '2012-07-22 17:00:00 ', 1342994400, 1.16988, 1.1754800000000001, 1.1696200000000001, 1.1745099999999999);
INSERT INTO "OHLCData" VALUES (798, 37, '2012-07-23 00:00:00 ', 1343019600, 1.1745000000000001, 1.1822900000000001, 1.1730100000000001, 1.17767);
INSERT INTO "OHLCData" VALUES (799, 37, '2012-07-24 00:00:00 ', 1343106000, 1.1776800000000001, 1.18492, 1.1735800000000001, 1.17988);
INSERT INTO "OHLCData" VALUES (800, 37, '2012-07-25 00:00:00 ', 1343192400, 1.1798599999999999, 1.18215, 1.1756899999999999, 1.17597);
INSERT INTO "OHLCData" VALUES (801, 37, '2012-07-26 00:00:00 ', 1343278800, 1.1759900000000001, 1.1842900000000001, 1.1738299999999999, 1.1797);
INSERT INTO "OHLCData" VALUES (802, 37, '2012-07-27 00:00:00 ', 1343365200, 1.1796899999999999, 1.1855100000000001, 1.1732, 1.1749499999999999);
INSERT INTO "OHLCData" VALUES (803, 37, '2012-07-29 17:00:00 ', 1343599200, 1.17414, 1.1765000000000001, 1.1733899999999999, 1.1740200000000001);
INSERT INTO "OHLCData" VALUES (804, 37, '2012-07-30 00:00:00 ', 1343624400, 1.1739999999999999, 1.1748099999999999, 1.1651100000000001, 1.1669400000000001);
INSERT INTO "OHLCData" VALUES (805, 37, '2012-07-31 00:00:00 ', 1343710800, 1.1669099999999999, 1.1734899999999999, 1.16438, 1.1716500000000001);
INSERT INTO "OHLCData" VALUES (806, 37, '2012-08-01 00:00:00 ', 1343797200, 1.1716599999999999, 1.17266, 1.16774, 1.1687099999999999);
INSERT INTO "OHLCData" VALUES (807, 37, '2012-08-02 00:00:00 ', 1343883600, 1.1687000000000001, 1.1726000000000001, 1.16038, 1.16198);
INSERT INTO "OHLCData" VALUES (808, 37, '2012-08-03 00:00:00 ', 1343970000, 1.16195, 1.1732800000000001, 1.1609, 1.1718299999999999);
INSERT INTO "OHLCData" VALUES (809, 37, '2012-08-05 17:00:00 ', 1344204000, 1.1725300000000001, 1.1773899999999999, 1.1712400000000001, 1.17299);
INSERT INTO "OHLCData" VALUES (810, 37, '2012-08-06 00:00:00 ', 1344229200, 1.1729799999999999, 1.1746300000000001, 1.17035, 1.17171);
INSERT INTO "OHLCData" VALUES (811, 37, '2012-08-07 00:00:00 ', 1344315600, 1.1717, 1.1768000000000001, 1.1694800000000001, 1.17509);
INSERT INTO "OHLCData" VALUES (812, 37, '2012-08-08 00:00:00 ', 1344402000, 1.17506, 1.17581, 1.1673800000000001, 1.1673800000000001);
INSERT INTO "OHLCData" VALUES (813, 37, '2012-08-09 00:00:00 ', 1344488400, 1.16736, 1.1685099999999999, 1.161, 1.1672899999999999);
INSERT INTO "OHLCData" VALUES (814, 37, '2012-08-10 00:00:00 ', 1344574800, 1.1672800000000001, 1.169, 1.16133, 1.16181);
INSERT INTO "OHLCData" VALUES (815, 37, '2012-08-12 17:00:00 ', 1344808800, 1.1642399999999999, 1.16456, 1.1625000000000001, 1.16353);
INSERT INTO "OHLCData" VALUES (816, 37, '2012-08-13 00:00:00 ', 1344834000, 1.16351, 1.1753899999999999, 1.1635, 1.17404);
INSERT INTO "OHLCData" VALUES (817, 37, '2012-08-14 00:00:00 ', 1344920400, 1.1740299999999999, 1.1773800000000001, 1.17214, 1.1758599999999999);
INSERT INTO "OHLCData" VALUES (818, 37, '2012-08-15 00:00:00 ', 1345006800, 1.1758500000000001, 1.1789799999999999, 1.1678999999999999, 1.1715800000000001);
INSERT INTO "OHLCData" VALUES (819, 37, '2012-08-16 00:00:00 ', 1345093200, 1.17154, 1.1778299999999999, 1.1687700000000001, 1.17618);
INSERT INTO "OHLCData" VALUES (820, 37, '2012-08-17 00:00:00 ', 1345179600, 1.17611, 1.18485, 1.17611, 1.1834899999999999);
INSERT INTO "OHLCData" VALUES (821, 37, '2012-08-19 17:00:00 ', 1345413600, 1.1836500000000001, 1.1839, 1.1803900000000001, 1.1807300000000001);
INSERT INTO "OHLCData" VALUES (822, 37, '2012-08-20 00:00:00 ', 1345438800, 1.18072, 1.1833899999999999, 1.17743, 1.17883);
INSERT INTO "OHLCData" VALUES (823, 37, '2012-08-21 00:00:00 ', 1345525200, 1.17879, 1.1937199999999999, 1.1775899999999999, 1.1920599999999999);
INSERT INTO "OHLCData" VALUES (824, 37, '2012-08-22 00:00:00 ', 1345611600, 1.1920299999999999, 1.1958800000000001, 1.1900299999999999, 1.1922600000000001);
INSERT INTO "OHLCData" VALUES (825, 37, '2012-08-23 00:00:00 ', 1345698000, 1.19225, 1.2045999999999999, 1.1913499999999999, 1.2037599999999999);
INSERT INTO "OHLCData" VALUES (826, 37, '2012-08-24 00:00:00 ', 1345784400, 1.2037899999999999, 1.20692, 1.2011799999999999, 1.20248);
INSERT INTO "OHLCData" VALUES (827, 37, '2012-08-26 17:00:00 ', 1346018400, 1.2001599999999999, 1.2048000000000001, 1.19973, 1.2040599999999999);
INSERT INTO "OHLCData" VALUES (828, 37, '2012-08-27 00:00:00 ', 1346043600, 1.2040500000000001, 1.2067600000000001, 1.20295, 1.20519);
INSERT INTO "OHLCData" VALUES (829, 37, '2012-08-28 00:00:00 ', 1346130000, 1.2051700000000001, 1.2123999999999999, 1.2029300000000001, 1.2113100000000001);
INSERT INTO "OHLCData" VALUES (830, 37, '2012-08-29 00:00:00 ', 1346216400, 1.21133, 1.21461, 1.2069300000000001, 1.2144999999999999);
INSERT INTO "OHLCData" VALUES (831, 37, '2012-08-30 00:00:00 ', 1346302800, 1.21451, 1.2170099999999999, 1.2116499999999999, 1.21512);
INSERT INTO "OHLCData" VALUES (832, 37, '2012-08-31 00:00:00 ', 1346389200, 1.21512, 1.22289, 1.21292, 1.21807);
INSERT INTO "OHLCData" VALUES (833, 37, '2012-09-02 17:00:00 ', 1346623200, 1.22187, 1.2266900000000001, 1.2211000000000001, 1.22533);
INSERT INTO "OHLCData" VALUES (834, 37, '2012-09-03 00:00:00 ', 1346648400, 1.2253499999999999, 1.2324600000000001, 1.2238800000000001, 1.2319599999999999);
INSERT INTO "OHLCData" VALUES (835, 37, '2012-09-04 00:00:00 ', 1346734800, 1.232, 1.23272, 1.22603, 1.2276);
INSERT INTO "OHLCData" VALUES (836, 37, '2012-09-05 00:00:00 ', 1346821200, 1.2276100000000001, 1.2389600000000001, 1.2273799999999999, 1.2332000000000001);
INSERT INTO "OHLCData" VALUES (837, 37, '2012-09-06 00:00:00 ', 1346907600, 1.23315, 1.23584, 1.22529, 1.22559);
INSERT INTO "OHLCData" VALUES (838, 37, '2012-09-07 00:00:00 ', 1346994000, 1.22557, 1.2343299999999999, 1.22306, 1.23394);
INSERT INTO "OHLCData" VALUES (839, 37, '2012-09-09 17:00:00 ', 1347228000, 1.23475, 1.23569, 1.2315400000000001, 1.2334000000000001);
INSERT INTO "OHLCData" VALUES (840, 37, '2012-09-10 00:00:00 ', 1347253200, 1.2334099999999999, 1.2363200000000001, 1.2333799999999999, 1.23553);
INSERT INTO "OHLCData" VALUES (841, 37, '2012-09-11 00:00:00 ', 1347339600, 1.2355100000000001, 1.2378899999999999, 1.22753, 1.2286699999999999);
INSERT INTO "OHLCData" VALUES (842, 37, '2012-09-12 00:00:00 ', 1347426000, 1.2286600000000001, 1.2339199999999999, 1.22533, 1.23316);
INSERT INTO "OHLCData" VALUES (843, 37, '2012-09-13 00:00:00 ', 1347512400, 1.23315, 1.2377100000000001, 1.22902, 1.23027);
INSERT INTO "OHLCData" VALUES (844, 37, '2012-09-14 00:00:00 ', 1347598800, 1.2303200000000001, 1.2449399999999999, 1.2300500000000001, 1.2443);
INSERT INTO "OHLCData" VALUES (845, 37, '2012-09-16 17:00:00 ', 1347832800, 1.24288, 1.2484200000000001, 1.24268, 1.2465599999999999);
INSERT INTO "OHLCData" VALUES (846, 37, '2012-09-17 00:00:00 ', 1347858000, 1.24657, 1.2540100000000001, 1.2433399999999999, 1.2517499999999999);
INSERT INTO "OHLCData" VALUES (847, 37, '2012-09-18 00:00:00 ', 1347944400, 1.25173, 1.2551000000000001, 1.2471399999999999, 1.24983);
INSERT INTO "OHLCData" VALUES (848, 37, '2012-09-19 00:00:00 ', 1348030800, 1.2498499999999999, 1.2503200000000001, 1.2441, 1.2488699999999999);
INSERT INTO "OHLCData" VALUES (849, 37, '2012-09-20 00:00:00 ', 1348117200, 1.2488600000000001, 1.2508900000000001, 1.23837, 1.23986);
INSERT INTO "OHLCData" VALUES (850, 37, '2012-09-21 00:00:00 ', 1348203600, 1.2398499999999999, 1.2435499999999999, 1.23536, 1.24126);
INSERT INTO "OHLCData" VALUES (851, 37, '2012-09-23 17:00:00 ', 1348437600, 1.24214, 1.2444900000000001, 1.24089, 1.2417);
INSERT INTO "OHLCData" VALUES (852, 37, '2012-09-24 00:00:00 ', 1348462800, 1.2417100000000001, 1.2443200000000001, 1.2384599999999999, 1.2393400000000001);
INSERT INTO "OHLCData" VALUES (853, 37, '2012-09-25 00:00:00 ', 1348549200, 1.23933, 1.2458499999999999, 1.23641, 1.2440100000000001);
INSERT INTO "OHLCData" VALUES (854, 37, '2012-09-26 00:00:00 ', 1348635600, 1.2439899999999999, 1.2441599999999999, 1.2381500000000001, 1.2392799999999999);
INSERT INTO "OHLCData" VALUES (855, 37, '2012-09-27 00:00:00 ', 1348722000, 1.2392700000000001, 1.2393400000000001, 1.23272, 1.2357800000000001);
INSERT INTO "OHLCData" VALUES (856, 37, '2012-09-28 00:00:00 ', 1348808400, 1.2357899999999999, 1.24213, 1.2352300000000001, 1.2389699999999999);
INSERT INTO "OHLCData" VALUES (857, 37, '2012-09-30 17:00:00 ', 1349042400, 1.2391799999999999, 1.2409300000000001, 1.2363999999999999, 1.2398199999999999);
INSERT INTO "OHLCData" VALUES (858, 37, '2012-10-01 00:00:00 ', 1349067600, 1.23983, 1.2452000000000001, 1.2392399999999999, 1.2436700000000001);
INSERT INTO "OHLCData" VALUES (859, 37, '2012-10-02 00:00:00 ', 1349154000, 1.2436799999999999, 1.2624899999999999, 1.24272, 1.2615700000000001);
INSERT INTO "OHLCData" VALUES (860, 37, '2012-10-03 00:00:00 ', 1349240400, 1.2615000000000001, 1.26773, 1.2613099999999999, 1.26518);
INSERT INTO "OHLCData" VALUES (861, 37, '2012-10-04 00:00:00 ', 1349326800, 1.2652000000000001, 1.27166, 1.2626200000000001, 1.26746);
INSERT INTO "OHLCData" VALUES (862, 37, '2012-10-05 00:00:00 ', 1349413200, 1.2674700000000001, 1.28227, 1.26675, 1.2796400000000001);
INSERT INTO "OHLCData" VALUES (863, 37, '2012-10-07 17:00:00 ', 1349647200, 1.28224, 1.2823800000000001, 1.2774099999999999, 1.27824);
INSERT INTO "OHLCData" VALUES (864, 37, '2012-10-08 00:00:00 ', 1349672400, 1.27823, 1.27871, 1.2669299999999999, 1.2679199999999999);
INSERT INTO "OHLCData" VALUES (865, 37, '2012-10-09 00:00:00 ', 1349758800, 1.2679400000000001, 1.27044, 1.2576400000000001, 1.2581);
INSERT INTO "OHLCData" VALUES (866, 37, '2012-10-10 00:00:00 ', 1349845200, 1.2581199999999999, 1.26101, 1.25074, 1.2509300000000001);
INSERT INTO "OHLCData" VALUES (867, 37, '2012-10-11 00:00:00 ', 1349931600, 1.2509399999999999, 1.26135, 1.2505999999999999, 1.25854);
INSERT INTO "OHLCData" VALUES (868, 37, '2012-10-12 00:00:00 ', 1350018000, 1.2585299999999999, 1.2678, 1.2577199999999999, 1.2653300000000001);
INSERT INTO "OHLCData" VALUES (869, 37, '2012-10-14 17:00:00 ', 1350252000, 1.2628699999999999, 1.2665, 1.2621500000000001, 1.2629999999999999);
INSERT INTO "OHLCData" VALUES (870, 37, '2012-10-15 00:00:00 ', 1350277200, 1.2629900000000001, 1.2670699999999999, 1.2614399999999999, 1.26264);
INSERT INTO "OHLCData" VALUES (871, 37, '2012-10-16 00:00:00 ', 1350363600, 1.2625999999999999, 1.27298, 1.26189, 1.26939);
INSERT INTO "OHLCData" VALUES (872, 37, '2012-10-17 00:00:00 ', 1350450000, 1.26938, 1.27102, 1.26014, 1.26031);
INSERT INTO "OHLCData" VALUES (873, 37, '2012-10-18 00:00:00 ', 1350536400, 1.26024, 1.26362, 1.25885, 1.26088);
INSERT INTO "OHLCData" VALUES (874, 37, '2012-10-19 00:00:00 ', 1350622800, 1.2608600000000001, 1.2624899999999999, 1.258, 1.2605299999999999);
INSERT INTO "OHLCData" VALUES (875, 37, '2012-10-21 17:00:00 ', 1350856800, 1.2620100000000001, 1.2645900000000001, 1.2614799999999999, 1.26383);
INSERT INTO "OHLCData" VALUES (876, 37, '2012-10-22 00:00:00 ', 1350882000, 1.2638, 1.2667999999999999, 1.26294, 1.26522);
INSERT INTO "OHLCData" VALUES (877, 37, '2012-10-23 00:00:00 ', 1350968400, 1.2652300000000001, 1.26701, 1.2584, 1.2589300000000001);
INSERT INTO "OHLCData" VALUES (878, 37, '2012-10-24 00:00:00 ', 1351054800, 1.25888, 1.26058, 1.25021, 1.2522599999999999);
INSERT INTO "OHLCData" VALUES (879, 37, '2012-10-25 00:00:00 ', 1351141200, 1.2522500000000001, 1.25403, 1.24848, 1.25356);
INSERT INTO "OHLCData" VALUES (880, 37, '2012-10-26 00:00:00 ', 1351227600, 1.2535700000000001, 1.2547600000000001, 1.24563, 1.24718);
INSERT INTO "OHLCData" VALUES (881, 37, '2012-10-28 17:00:00 ', 1351461600, 1.2484200000000001, 1.2493099999999999, 1.24716, 1.2476400000000001);
INSERT INTO "OHLCData" VALUES (882, 37, '2012-10-29 00:00:00 ', 1351486800, 1.2476499999999999, 1.24953, 1.24498, 1.2484999999999999);
INSERT INTO "OHLCData" VALUES (883, 37, '2012-10-30 00:00:00 ', 1351573200, 1.2484200000000001, 1.2520500000000001, 1.24525, 1.24851);
INSERT INTO "OHLCData" VALUES (884, 37, '2012-10-31 00:00:00 ', 1351659600, 1.2484999999999999, 1.2532700000000001, 1.2475000000000001, 1.2492799999999999);
INSERT INTO "OHLCData" VALUES (885, 37, '2012-11-01 00:00:00 ', 1351746000, 1.2492700000000001, 1.2506600000000001, 1.2423299999999999, 1.24369);
INSERT INTO "OHLCData" VALUES (886, 37, '2012-11-02 00:00:00 ', 1351832400, 1.2437400000000001, 1.2441500000000001, 1.23576, 1.2413799999999999);
INSERT INTO "OHLCData" VALUES (887, 37, '2012-11-04 17:00:00 ', 1352070000, 1.23943, 1.24071, 1.23706, 1.23746);
INSERT INTO "OHLCData" VALUES (888, 37, '2012-11-05 00:00:00 ', 1352095200, 1.23742, 1.23885, 1.22533, 1.22583);
INSERT INTO "OHLCData" VALUES (889, 37, '2012-11-06 00:00:00 ', 1352181600, 1.2257899999999999, 1.2317199999999999, 1.2240899999999999, 1.2301299999999999);
INSERT INTO "OHLCData" VALUES (890, 37, '2012-11-07 00:00:00 ', 1352268000, 1.2301, 1.23061, 1.22146, 1.22471);
INSERT INTO "OHLCData" VALUES (891, 37, '2012-11-08 00:00:00 ', 1352354400, 1.22472, 1.2267699999999999, 1.2194, 1.2256400000000001);
INSERT INTO "OHLCData" VALUES (892, 37, '2012-11-09 00:00:00 ', 1352440800, 1.2256199999999999, 1.2260500000000001, 1.22207, 1.22377);
INSERT INTO "OHLCData" VALUES (893, 37, '2012-11-11 17:00:00 ', 1352674800, 1.22227, 1.2251399999999999, 1.2207300000000001, 1.2215);
INSERT INTO "OHLCData" VALUES (894, 37, '2012-11-12 00:00:00 ', 1352700000, 1.2215400000000001, 1.2224699999999999, 1.2171700000000001, 1.2183900000000001);
INSERT INTO "OHLCData" VALUES (895, 37, '2012-11-13 00:00:00 ', 1352786400, 1.2183200000000001, 1.2212499999999999, 1.2157, 1.2173099999999999);
INSERT INTO "OHLCData" VALUES (896, 37, '2012-11-14 00:00:00 ', 1352872800, 1.21739, 1.2298, 1.2163600000000001, 1.22811);
INSERT INTO "OHLCData" VALUES (897, 37, '2012-11-15 00:00:00 ', 1352959200, 1.2281200000000001, 1.2396799999999999, 1.22803, 1.2365299999999999);
INSERT INTO "OHLCData" VALUES (898, 37, '2012-11-16 00:00:00 ', 1353045600, 1.23651, 1.23766, 1.23071, 1.23221);
INSERT INTO "OHLCData" VALUES (899, 37, '2012-11-18 17:00:00 ', 1353279600, 1.2313700000000001, 1.2318100000000001, 1.2295799999999999, 1.2297499999999999);
INSERT INTO "OHLCData" VALUES (900, 37, '2012-11-19 00:00:00 ', 1353304800, 1.2298100000000001, 1.2315799999999999, 1.2257199999999999, 1.22905);
INSERT INTO "OHLCData" VALUES (901, 37, '2012-11-20 00:00:00 ', 1353391200, 1.2290399999999999, 1.2355799999999999, 1.2276199999999999, 1.2314799999999999);
INSERT INTO "OHLCData" VALUES (902, 37, '2012-11-21 00:00:00 ', 1353477600, 1.2314700000000001, 1.2399, 1.2300199999999999, 1.23671);
INSERT INTO "OHLCData" VALUES (903, 37, '2012-11-22 00:00:00 ', 1353564000, 1.23672, 1.2425299999999999, 1.2363, 1.23943);
INSERT INTO "OHLCData" VALUES (904, 37, '2012-11-23 00:00:00 ', 1353650400, 1.23942, 1.24204, 1.2376, 1.2401599999999999);
INSERT INTO "OHLCData" VALUES (905, 37, '2012-11-25 17:00:00 ', 1353884400, 1.2398100000000001, 1.24068, 1.2383599999999999, 1.23925);
INSERT INTO "OHLCData" VALUES (906, 37, '2012-11-26 00:00:00 ', 1353909600, 1.23929, 1.24177, 1.2380100000000001, 1.23831);
INSERT INTO "OHLCData" VALUES (907, 37, '2012-11-27 00:00:00 ', 1353996000, 1.2383599999999999, 1.2405999999999999, 1.2346900000000001, 1.23695);
INSERT INTO "OHLCData" VALUES (908, 37, '2012-11-28 00:00:00 ', 1354082400, 1.23698, 1.2383299999999999, 1.2333499999999999, 1.2372099999999999);
INSERT INTO "OHLCData" VALUES (909, 37, '2012-11-29 00:00:00 ', 1354168800, 1.2372300000000001, 1.2476400000000001, 1.2360899999999999, 1.24586);
INSERT INTO "OHLCData" VALUES (910, 37, '2012-11-30 00:00:00 ', 1354255200, 1.2458800000000001, 1.2491300000000001, 1.2446299999999999, 1.24519);
INSERT INTO "OHLCData" VALUES (911, 37, '2012-12-02 17:00:00 ', 1354489200, 1.24481, 1.2527200000000001, 1.24475, 1.2519100000000001);
INSERT INTO "OHLCData" VALUES (912, 37, '2012-12-03 00:00:00 ', 1354514400, 1.25179, 1.2543, 1.2483299999999999, 1.2504999999999999);
INSERT INTO "OHLCData" VALUES (913, 37, '2012-12-04 00:00:00 ', 1354600800, 1.25047, 1.2518199999999999, 1.24712, 1.2517);
INSERT INTO "OHLCData" VALUES (914, 37, '2012-12-05 00:00:00 ', 1354687200, 1.2516700000000001, 1.2527900000000001, 1.2455799999999999, 1.2476);
INSERT INTO "OHLCData" VALUES (915, 37, '2012-12-06 00:00:00 ', 1354773600, 1.2475499999999999, 1.2484999999999999, 1.2345600000000001, 1.23736);
INSERT INTO "OHLCData" VALUES (916, 37, '2012-12-07 00:00:00 ', 1354860000, 1.2373400000000001, 1.2378199999999999, 1.2299899999999999, 1.23237);
INSERT INTO "OHLCData" VALUES (917, 37, '2012-12-09 17:00:00 ', 1355094000, 1.2287300000000001, 1.23275, 1.2285200000000001, 1.23139);
INSERT INTO "OHLCData" VALUES (918, 37, '2012-12-10 00:00:00 ', 1355119200, 1.23142, 1.23675, 1.22939, 1.2352700000000001);
INSERT INTO "OHLCData" VALUES (919, 37, '2012-12-11 00:00:00 ', 1355205600, 1.2352799999999999, 1.2386999999999999, 1.2338100000000001, 1.23489);
INSERT INTO "OHLCData" VALUES (920, 37, '2012-12-12 00:00:00 ', 1355292000, 1.23488, 1.2407300000000001, 1.23308, 1.23997);
INSERT INTO "OHLCData" VALUES (921, 37, '2012-12-13 00:00:00 ', 1355378400, 1.2399800000000001, 1.2438800000000001, 1.2368699999999999, 1.24159);
INSERT INTO "OHLCData" VALUES (922, 37, '2012-12-14 00:00:00 ', 1355464800, 1.2415499999999999, 1.2462800000000001, 1.2400899999999999, 1.2455099999999999);
INSERT INTO "OHLCData" VALUES (923, 37, '2012-12-16 17:01:00 ', 1355698860, 1.2485599999999999, 1.2506600000000001, 1.24658, 1.2486699999999999);
INSERT INTO "OHLCData" VALUES (924, 37, '2012-12-17 00:00:00 ', 1355724000, 1.2486600000000001, 1.2500100000000001, 1.2467699999999999, 1.2496);
INSERT INTO "OHLCData" VALUES (925, 37, '2012-12-18 00:00:00 ', 1355810400, 1.2495799999999999, 1.2602599999999999, 1.24855, 1.25963);
INSERT INTO "OHLCData" VALUES (926, 37, '2012-12-19 00:00:00 ', 1355896800, 1.2596499999999999, 1.2679400000000001, 1.2567299999999999, 1.2613300000000001);
INSERT INTO "OHLCData" VALUES (927, 37, '2012-12-20 00:00:00 ', 1355983200, 1.26132, 1.26813, 1.2588900000000001, 1.2623);
INSERT INTO "OHLCData" VALUES (928, 37, '2012-12-21 00:00:00 ', 1356069600, 1.2622899999999999, 1.2698400000000001, 1.26196, 1.2683);
INSERT INTO "OHLCData" VALUES (929, 37, '2012-12-23 17:00:00 ', 1356303600, 1.26684, 1.26824, 1.2660499999999999, 1.26701);
INSERT INTO "OHLCData" VALUES (930, 37, '2012-12-24 00:00:00 ', 1356328800, 1.26702, 1.2735399999999999, 1.2657799999999999, 1.2724599999999999);
INSERT INTO "OHLCData" VALUES (931, 37, '2012-12-26 06:01:00 ', 1356523260, 1.2745500000000001, 1.2782, 1.27214, 1.2773600000000001);
INSERT INTO "OHLCData" VALUES (932, 37, '2012-12-27 00:00:00 ', 1356588000, 1.2774000000000001, 1.2804800000000001, 1.274, 1.27562);
INSERT INTO "OHLCData" VALUES (933, 37, '2012-12-28 00:00:00 ', 1356674400, 1.2756000000000001, 1.2764200000000001, 1.26749, 1.2739);
INSERT INTO "OHLCData" VALUES (934, 37, '2012-12-30 17:00:00 ', 1356908400, 1.27424, 1.2752699999999999, 1.2696400000000001, 1.2707599999999999);
INSERT INTO "OHLCData" VALUES (935, 37, '2012-12-31 00:00:00 ', 1356933600, 1.27077, 1.27515, 1.26786, 1.26891);
INSERT INTO "OHLCData" VALUES (936, 37, '2013-01-01 17:00:00 ', 1357081200, 1.2700499999999999, 1.27261, 1.2656000000000001, 1.26661);
INSERT INTO "OHLCData" VALUES (937, 37, '2013-01-02 00:00:00 ', 1357106400, 1.2665900000000001, 1.26854, 1.2516499999999999, 1.2521);
INSERT INTO "OHLCData" VALUES (938, 37, '2013-01-03 00:00:00 ', 1357192800, 1.2521199999999999, 1.2535400000000001, 1.2441, 1.2489699999999999);
INSERT INTO "OHLCData" VALUES (939, 37, '2013-01-04 00:00:00 ', 1357279200, 1.24891, 1.25146, 1.2460800000000001, 1.2467999999999999);
INSERT INTO "OHLCData" VALUES (940, 37, '2013-01-06 17:00:00 ', 1357513200, 1.24753, 1.2476499999999999, 1.24387, 1.24491);
INSERT INTO "OHLCData" VALUES (941, 37, '2013-01-07 00:00:00 ', 1357538400, 1.2448900000000001, 1.25278, 1.2404900000000001, 1.2517100000000001);
INSERT INTO "OHLCData" VALUES (942, 37, '2013-01-08 00:00:00 ', 1357624800, 1.2517199999999999, 1.25261, 1.2435700000000001, 1.2446900000000001);
INSERT INTO "OHLCData" VALUES (943, 37, '2013-01-09 00:00:00 ', 1357711200, 1.2446699999999999, 1.2458499999999999, 1.23614, 1.23647);
INSERT INTO "OHLCData" VALUES (944, 37, '2013-01-10 00:00:00 ', 1357797600, 1.23648, 1.2547699999999999, 1.2355700000000001, 1.25271);
INSERT INTO "OHLCData" VALUES (945, 37, '2013-01-11 00:00:00 ', 1357884000, 1.2526999999999999, 1.26739, 1.2524999999999999, 1.2662800000000001);
INSERT INTO "OHLCData" VALUES (946, 37, '2013-01-13 17:00:00 ', 1358118000, 1.26614, 1.2708600000000001, 1.2656499999999999, 1.2680199999999999);
INSERT INTO "OHLCData" VALUES (947, 37, '2013-01-14 00:00:00 ', 1358143200, 1.2680100000000001, 1.2696499999999999, 1.26224, 1.26637);
INSERT INTO "OHLCData" VALUES (948, 37, '2013-01-15 00:00:00 ', 1358229600, 1.2663500000000001, 1.2680199999999999, 1.2564299999999999, 1.2579400000000001);
INSERT INTO "OHLCData" VALUES (949, 37, '2013-01-16 00:00:00 ', 1358316000, 1.25793, 1.26495, 1.2558400000000001, 1.2639400000000001);
INSERT INTO "OHLCData" VALUES (950, 37, '2013-01-17 00:00:00 ', 1358402400, 1.26397, 1.27338, 1.2634000000000001, 1.2725599999999999);
INSERT INTO "OHLCData" VALUES (951, 37, '2013-01-18 00:00:00 ', 1358488800, 1.27258, 1.2737099999999999, 1.2648999999999999, 1.26709);
INSERT INTO "OHLCData" VALUES (952, 37, '2013-01-20 17:00:00 ', 1358722800, 1.2664899999999999, 1.26806, 1.26593, 1.26661);
INSERT INTO "OHLCData" VALUES (953, 37, '2013-01-21 00:00:00 ', 1358748000, 1.2666200000000001, 1.2683, 1.26247, 1.2645999999999999);
INSERT INTO "OHLCData" VALUES (954, 37, '2013-01-22 00:00:00 ', 1358834400, 1.26454, 1.26681, 1.25671, 1.2632300000000001);
INSERT INTO "OHLCData" VALUES (955, 37, '2013-01-23 00:00:00 ', 1358920800, 1.26322, 1.26661, 1.2584200000000001, 1.26606);
INSERT INTO "OHLCData" VALUES (956, 37, '2013-01-24 00:00:00 ', 1359007200, 1.2660400000000001, 1.2806599999999999, 1.26413, 1.2785500000000001);
INSERT INTO "OHLCData" VALUES (957, 37, '2013-01-25 00:00:00 ', 1359093600, 1.2785299999999999, 1.29399, 1.27824, 1.2912999999999999);
INSERT INTO "OHLCData" VALUES (958, 37, '2013-01-27 17:00:00 ', 1359327600, 1.2926800000000001, 1.29356, 1.2896099999999999, 1.2917400000000001);
INSERT INTO "OHLCData" VALUES (959, 37, '2013-01-28 00:00:00 ', 1359352800, 1.2916700000000001, 1.29572, 1.2868200000000001, 1.28823);
INSERT INTO "OHLCData" VALUES (960, 37, '2013-01-29 00:00:00 ', 1359439200, 1.28826, 1.2900799999999999, 1.28359, 1.2875399999999999);
INSERT INTO "OHLCData" VALUES (961, 37, '2013-01-30 00:00:00 ', 1359525600, 1.2875300000000001, 1.3072900000000001, 1.2871699999999999, 1.30552);
INSERT INTO "OHLCData" VALUES (962, 37, '2013-01-31 00:00:00 ', 1359612000, 1.30549, 1.3123199999999999, 1.29878, 1.3109999999999999);
INSERT INTO "OHLCData" VALUES (963, 37, '2013-02-01 00:00:00 ', 1359698400, 1.3110200000000001, 1.3188599999999999, 1.30566, 1.31044);
INSERT INTO "OHLCData" VALUES (964, 37, '2013-02-03 17:00:00 ', 1359932400, 1.3090900000000001, 1.31115, 1.30599, 1.30609);
INSERT INTO "OHLCData" VALUES (965, 37, '2013-02-04 00:00:00 ', 1359957600, 1.3060799999999999, 1.3084199999999999, 1.2901100000000001, 1.2966599999999999);
INSERT INTO "OHLCData" VALUES (966, 37, '2013-02-05 00:00:00 ', 1360044000, 1.2966500000000001, 1.31301, 1.2918400000000001, 1.3111900000000001);
INSERT INTO "OHLCData" VALUES (967, 37, '2013-02-06 00:00:00 ', 1360130400, 1.31118, 1.31524, 1.3083400000000001, 1.3093399999999999);
INSERT INTO "OHLCData" VALUES (968, 37, '2013-02-07 00:00:00 ', 1360216800, 1.30932, 1.3157000000000001, 1.29576, 1.3034699999999999);
INSERT INTO "OHLCData" VALUES (969, 37, '2013-02-08 00:00:00 ', 1360303200, 1.30342, 1.3035699999999999, 1.2931299999999999, 1.29481);
INSERT INTO "OHLCData" VALUES (970, 37, '2013-02-10 17:00:00 ', 1360537200, 1.2961400000000001, 1.2989299999999999, 1.29447, 1.298);
INSERT INTO "OHLCData" VALUES (971, 37, '2013-02-11 00:00:00 ', 1360562400, 1.29802, 1.3075399999999999, 1.2979799999999999, 1.3060700000000001);
INSERT INTO "OHLCData" VALUES (972, 37, '2013-02-12 00:00:00 ', 1360648800, 1.3060799999999999, 1.3144, 1.29721, 1.29793);
INSERT INTO "OHLCData" VALUES (973, 37, '2013-02-13 00:00:00 ', 1360735200, 1.2979400000000001, 1.3089200000000001, 1.29664, 1.2981499999999999);
INSERT INTO "OHLCData" VALUES (974, 37, '2013-02-14 00:00:00 ', 1360821600, 1.29817, 1.29905, 1.2853600000000001, 1.2882100000000001);
INSERT INTO "OHLCData" VALUES (975, 37, '2013-02-15 00:00:00 ', 1360908000, 1.2882, 1.2981199999999999, 1.2845899999999999, 1.29623);
INSERT INTO "OHLCData" VALUES (976, 37, '2013-02-17 17:00:00 ', 1361142000, 1.29694, 1.2986, 1.29497, 1.29559);
INSERT INTO "OHLCData" VALUES (977, 37, '2013-02-18 00:00:00 ', 1361167200, 1.2955700000000001, 1.2992999999999999, 1.29139, 1.2923899999999999);
INSERT INTO "OHLCData" VALUES (978, 37, '2013-02-19 00:00:00 ', 1361253600, 1.2923800000000001, 1.29833, 1.2878400000000001, 1.29457);
INSERT INTO "OHLCData" VALUES (979, 37, '2013-02-20 00:00:00 ', 1361340000, 1.29454, 1.30165, 1.2932999999999999, 1.29521);
INSERT INTO "OHLCData" VALUES (980, 37, '2013-02-21 00:00:00 ', 1361426400, 1.2951999999999999, 1.29545, 1.2790900000000001, 1.2808999999999999);
INSERT INTO "OHLCData" VALUES (981, 37, '2013-02-22 00:00:00 ', 1361512800, 1.2808900000000001, 1.2849999999999999, 1.2742, 1.2784599999999999);
INSERT INTO "OHLCData" VALUES (982, 37, '2013-02-24 17:00:00 ', 1361746800, 1.28241, 1.28468, 1.27952, 1.2827299999999999);
INSERT INTO "OHLCData" VALUES (983, 37, '2013-02-25 00:00:00 ', 1361772000, 1.2827500000000001, 1.2912600000000001, 1.2674799999999999, 1.2703500000000001);
INSERT INTO "OHLCData" VALUES (984, 37, '2013-02-26 00:00:00 ', 1361858400, 1.2703599999999999, 1.2808600000000001, 1.26915, 1.27887);
INSERT INTO "OHLCData" VALUES (985, 37, '2013-02-27 00:00:00 ', 1361944800, 1.27885, 1.2892399999999999, 1.2773000000000001, 1.2788200000000001);
INSERT INTO "OHLCData" VALUES (986, 37, '2013-02-28 00:00:00 ', 1362031200, 1.2787599999999999, 1.28142, 1.2761499999999999, 1.27769);
INSERT INTO "OHLCData" VALUES (987, 37, '2013-03-01 00:00:00 ', 1362117600, 1.2777400000000001, 1.2804599999999999, 1.27098, 1.2759499999999999);
INSERT INTO "OHLCData" VALUES (988, 37, '2013-03-03 17:00:00 ', 1362351600, 1.2754099999999999, 1.28644, 1.2749900000000001, 1.28548);
INSERT INTO "OHLCData" VALUES (989, 37, '2013-03-04 00:00:00 ', 1362376800, 1.28549, 1.28606, 1.27207, 1.27261);
INSERT INTO "OHLCData" VALUES (990, 37, '2013-03-05 00:00:00 ', 1362463200, 1.2726200000000001, 1.2769200000000001, 1.26823, 1.2704200000000001);
INSERT INTO "OHLCData" VALUES (991, 37, '2013-03-06 00:00:00 ', 1362549600, 1.2704299999999999, 1.2717000000000001, 1.26501, 1.26738);
INSERT INTO "OHLCData" VALUES (992, 37, '2013-03-07 00:00:00 ', 1362636000, 1.26735, 1.2788900000000001, 1.26684, 1.2780899999999999);
INSERT INTO "OHLCData" VALUES (993, 37, '2013-03-08 00:00:00 ', 1362722400, 1.2781100000000001, 1.2793300000000001, 1.26559, 1.2704800000000001);
INSERT INTO "OHLCData" VALUES (994, 37, '2013-03-10 17:00:00 ', 1362952800, 1.2724200000000001, 1.2732300000000001, 1.2703899999999999, 1.2717099999999999);
INSERT INTO "OHLCData" VALUES (995, 37, '2013-03-11 00:00:00 ', 1362978000, 1.2717000000000001, 1.2728900000000001, 1.26386, 1.2667900000000001);
INSERT INTO "OHLCData" VALUES (996, 37, '2013-03-12 00:00:00 ', 1363064400, 1.2668200000000001, 1.26769, 1.2605, 1.2636499999999999);
INSERT INTO "OHLCData" VALUES (997, 37, '2013-03-13 00:00:00 ', 1363150800, 1.26366, 1.2650699999999999, 1.24895, 1.2490600000000001);
INSERT INTO "OHLCData" VALUES (998, 37, '2013-03-14 00:00:00 ', 1363237200, 1.2490300000000001, 1.2555799999999999, 1.2467999999999999, 1.2546900000000001);
INSERT INTO "OHLCData" VALUES (999, 37, '2013-03-15 00:00:00 ', 1363323600, 1.2546999999999999, 1.26214, 1.2538800000000001, 1.2559800000000001);
INSERT INTO "OHLCData" VALUES (1000, 37, '2013-03-17 17:00:00 ', 1363557600, 1.2463200000000001, 1.24949, 1.2434400000000001, 1.24603);
INSERT INTO "OHLCData" VALUES (1001, 37, '2013-03-18 00:00:00 ', 1363582800, 1.2459800000000001, 1.25065, 1.24251, 1.24712);
INSERT INTO "OHLCData" VALUES (1002, 37, '2013-03-19 00:00:00 ', 1363669200, 1.2471300000000001, 1.24902, 1.23946, 1.2407600000000001);
INSERT INTO "OHLCData" VALUES (1003, 37, '2013-03-20 00:00:00 ', 1363755600, 1.2407900000000001, 1.2489699999999999, 1.2397100000000001, 1.24794);
INSERT INTO "OHLCData" VALUES (1004, 37, '2013-03-21 00:00:00 ', 1363842000, 1.2479499999999999, 1.2482, 1.2340100000000001, 1.23851);
INSERT INTO "OHLCData" VALUES (1005, 37, '2013-03-22 00:00:00 ', 1363928400, 1.2385299999999999, 1.24614, 1.23475, 1.24349);
INSERT INTO "OHLCData" VALUES (1006, 37, '2013-03-24 17:00:00 ', 1364162400, 1.2397100000000001, 1.2492799999999999, 1.2391700000000001, 1.24726);
INSERT INTO "OHLCData" VALUES (1007, 37, '2013-03-25 00:00:00 ', 1364187600, 1.2472700000000001, 1.248, 1.2275100000000001, 1.2307300000000001);
INSERT INTO "OHLCData" VALUES (1008, 37, '2013-03-26 00:00:00 ', 1364274000, 1.2307399999999999, 1.23102, 1.2231000000000001, 1.22706);
INSERT INTO "OHLCData" VALUES (1009, 37, '2013-03-27 00:00:00 ', 1364360400, 1.2270700000000001, 1.22742, 1.22197, 1.2254799999999999);
INSERT INTO "OHLCData" VALUES (1010, 37, '2013-03-28 00:00:00 ', 1364446800, 1.22549, 1.2329699999999999, 1.2223299999999999, 1.23109);
INSERT INTO "OHLCData" VALUES (1011, 37, '2013-03-29 00:00:00 ', 1364533200, 1.2310700000000001, 1.2320199999999999, 1.22719, 1.23007);
INSERT INTO "OHLCData" VALUES (1012, 37, '2013-03-31 17:00:00 ', 1364767200, 1.2287699999999999, 1.2310099999999999, 1.2283500000000001, 1.22902);
INSERT INTO "OHLCData" VALUES (1013, 37, '2013-04-01 00:00:00 ', 1364792400, 1.2290099999999999, 1.2342299999999999, 1.22841, 1.2292000000000001);
INSERT INTO "OHLCData" VALUES (1014, 37, '2013-04-02 00:00:00 ', 1364878800, 1.22919, 1.23058, 1.2233400000000001, 1.22485);
INSERT INTO "OHLCData" VALUES (1015, 37, '2013-04-03 00:00:00 ', 1364965200, 1.2248600000000001, 1.22942, 1.22173, 1.2263599999999999);
INSERT INTO "OHLCData" VALUES (1016, 37, '2013-04-04 00:00:00 ', 1365051600, 1.2263900000000001, 1.2423299999999999, 1.22326, 1.2419500000000001);
INSERT INTO "OHLCData" VALUES (1017, 37, '2013-04-05 00:00:00 ', 1365138000, 1.2419899999999999, 1.2562500000000001, 1.2370000000000001, 1.25092);
INSERT INTO "OHLCData" VALUES (1018, 37, '2013-04-07 17:00:00 ', 1365372000, 1.25109, 1.2553000000000001, 1.2510300000000001, 1.2521899999999999);
INSERT INTO "OHLCData" VALUES (1019, 37, '2013-04-08 00:00:00 ', 1365397200, 1.2522, 1.2544599999999999, 1.24821, 1.2505200000000001);
INSERT INTO "OHLCData" VALUES (1020, 37, '2013-04-09 00:00:00 ', 1365483600, 1.25051, 1.25102, 1.2430099999999999, 1.24539);
INSERT INTO "OHLCData" VALUES (1021, 37, '2013-04-10 00:00:00 ', 1365570000, 1.2453799999999999, 1.2468300000000001, 1.2370000000000001, 1.24183);
INSERT INTO "OHLCData" VALUES (1022, 37, '2013-04-11 00:00:00 ', 1365656400, 1.2418499999999999, 1.24468, 1.23638, 1.24248);
INSERT INTO "OHLCData" VALUES (1023, 37, '2013-04-12 00:00:00 ', 1365742800, 1.2424999999999999, 1.24901, 1.2385600000000001, 1.24773);
INSERT INTO "OHLCData" VALUES (1024, 37, '2013-04-14 17:00:00 ', 1365976800, 1.2481500000000001, 1.2547999999999999, 1.2448399999999999, 1.25427);
INSERT INTO "OHLCData" VALUES (1025, 37, '2013-04-15 00:00:00 ', 1366002000, 1.2542899999999999, 1.26701, 1.2511000000000001, 1.2606999999999999);
INSERT INTO "OHLCData" VALUES (1026, 37, '2013-04-16 00:00:00 ', 1366088400, 1.2606900000000001, 1.27247, 1.2593099999999999, 1.2722899999999999);
INSERT INTO "OHLCData" VALUES (1027, 37, '2013-04-17 00:00:00 ', 1366174800, 1.2723, 1.2737700000000001, 1.26214, 1.26576);
INSERT INTO "OHLCData" VALUES (1028, 37, '2013-04-18 00:00:00 ', 1366261200, 1.26566, 1.27084, 1.2619, 1.2663500000000001);
INSERT INTO "OHLCData" VALUES (1029, 37, '2013-04-19 00:00:00 ', 1366347600, 1.2663, 1.2727599999999999, 1.2619199999999999, 1.2698100000000001);
INSERT INTO "OHLCData" VALUES (1030, 37, '2013-04-21 17:00:00 ', 1366581600, 1.2721199999999999, 1.27216, 1.2684899999999999, 1.2690699999999999);
INSERT INTO "OHLCData" VALUES (1031, 37, '2013-04-22 00:00:00 ', 1366606800, 1.2690900000000001, 1.27624, 1.26831, 1.27451);
INSERT INTO "OHLCData" VALUES (1032, 37, '2013-04-23 00:00:00 ', 1366693200, 1.27457, 1.27742, 1.2648200000000001, 1.26807);
INSERT INTO "OHLCData" VALUES (1033, 37, '2013-04-24 00:00:00 ', 1366779600, 1.2680800000000001, 1.26945, 1.2621599999999999, 1.264);
INSERT INTO "OHLCData" VALUES (1034, 37, '2013-04-25 00:00:00 ', 1366866000, 1.26397, 1.2677499999999999, 1.25983, 1.2644);
INSERT INTO "OHLCData" VALUES (1035, 37, '2013-04-26 00:00:00 ', 1366952400, 1.2644200000000001, 1.26858, 1.26173, 1.2671600000000001);
INSERT INTO "OHLCData" VALUES (1036, 37, '2013-04-28 17:00:00 ', 1367186400, 1.2692399999999999, 1.27003, 1.2641100000000001, 1.2644500000000001);
INSERT INTO "OHLCData" VALUES (1037, 37, '2013-04-29 00:00:00 ', 1367211600, 1.2644599999999999, 1.26736, 1.2639, 1.2649600000000001);
INSERT INTO "OHLCData" VALUES (1038, 37, '2013-04-30 00:00:00 ', 1367298000, 1.2649900000000001, 1.27349, 1.2610300000000001, 1.2690900000000001);
INSERT INTO "OHLCData" VALUES (1039, 37, '2013-05-01 00:00:00 ', 1367384400, 1.26912, 1.2865, 1.2690399999999999, 1.28505);
INSERT INTO "OHLCData" VALUES (1040, 37, '2013-05-02 00:00:00 ', 1367470800, 1.2850600000000001, 1.2887500000000001, 1.2717700000000001, 1.2732399999999999);
INSERT INTO "OHLCData" VALUES (1041, 37, '2013-05-03 00:00:00 ', 1367557200, 1.27319, 1.2818700000000001, 1.26877, 1.27074);
INSERT INTO "OHLCData" VALUES (1042, 37, '2013-05-05 17:00:00 ', 1367791200, 1.2729200000000001, 1.2778799999999999, 1.2720499999999999, 1.2760400000000001);
INSERT INTO "OHLCData" VALUES (1043, 37, '2013-05-06 00:00:00 ', 1367816400, 1.27603, 1.2812699999999999, 1.2746200000000001, 1.2773399999999999);
INSERT INTO "OHLCData" VALUES (1044, 37, '2013-05-07 00:00:00 ', 1367902800, 1.27738, 1.29087, 1.2767999999999999, 1.28521);
INSERT INTO "OHLCData" VALUES (1045, 37, '2013-05-08 00:00:00 ', 1367989200, 1.2851999999999999, 1.2946800000000001, 1.2836000000000001, 1.2841199999999999);
INSERT INTO "OHLCData" VALUES (1046, 37, '2013-05-09 00:00:00 ', 1368075600, 1.2841, 1.2977099999999999, 1.2834300000000001, 1.29261);
INSERT INTO "OHLCData" VALUES (1047, 37, '2013-05-10 00:00:00 ', 1368162000, 1.29264, 1.3017000000000001, 1.2926299999999999, 1.29562);
INSERT INTO "OHLCData" VALUES (1048, 37, '2013-05-12 17:00:00 ', 1368396000, 1.2965199999999999, 1.30087, 1.29528, 1.3001499999999999);
INSERT INTO "OHLCData" VALUES (1049, 37, '2013-05-13 00:00:00 ', 1368421200, 1.3001400000000001, 1.3050200000000001, 1.29667, 1.30453);
INSERT INTO "OHLCData" VALUES (1050, 37, '2013-05-14 00:00:00 ', 1368507600, 1.30454, 1.3117700000000001, 1.29928, 1.30674);
INSERT INTO "OHLCData" VALUES (1051, 37, '2013-05-15 00:00:00 ', 1368594000, 1.3067299999999999, 1.3083800000000001, 1.298, 1.30263);
INSERT INTO "OHLCData" VALUES (1052, 37, '2013-05-16 00:00:00 ', 1368680400, 1.30257, 1.3197700000000001, 1.30199, 1.3194399999999999);
INSERT INTO "OHLCData" VALUES (1053, 37, '2013-05-17 00:00:00 ', 1368766800, 1.3194999999999999, 1.32233, 1.3156300000000001, 1.31935);
INSERT INTO "OHLCData" VALUES (1054, 37, '2013-05-19 17:00:00 ', 1369000800, 1.3162, 1.3181, 1.31209, 1.31209);
INSERT INTO "OHLCData" VALUES (1055, 37, '2013-05-20 00:00:00 ', 1369026000, 1.3120799999999999, 1.32029, 1.3113600000000001, 1.3143899999999999);
INSERT INTO "OHLCData" VALUES (1056, 37, '2013-05-21 00:00:00 ', 1369112400, 1.3143800000000001, 1.3210999999999999, 1.3102799999999999, 1.3198799999999999);
INSERT INTO "OHLCData" VALUES (1057, 37, '2013-05-22 00:00:00 ', 1369198800, 1.3198700000000001, 1.33413, 1.31901, 1.3340000000000001);
INSERT INTO "OHLCData" VALUES (1058, 37, '2013-05-23 00:00:00 ', 1369285200, 1.33396, 1.33782, 1.3238399999999999, 1.3367100000000001);
INSERT INTO "OHLCData" VALUES (1059, 37, '2013-05-24 00:00:00 ', 1369371600, 1.3366899999999999, 1.3431900000000001, 1.33172, 1.33951);
INSERT INTO "OHLCData" VALUES (1060, 37, '2013-05-26 17:00:00 ', 1369605600, 1.3413600000000001, 1.34429, 1.3396399999999999, 1.3415299999999999);
INSERT INTO "OHLCData" VALUES (1061, 37, '2013-05-27 00:00:00 ', 1369630800, 1.3415699999999999, 1.34507, 1.3383499999999999, 1.3392999999999999);
INSERT INTO "OHLCData" VALUES (1062, 37, '2013-05-28 00:00:00 ', 1369717200, 1.3393600000000001, 1.3460000000000001, 1.33264, 1.34409);
INSERT INTO "OHLCData" VALUES (1063, 37, '2013-05-29 00:00:00 ', 1369803600, 1.3440399999999999, 1.35154, 1.33741, 1.3385400000000001);
INSERT INTO "OHLCData" VALUES (1064, 37, '2013-05-30 00:00:00 ', 1369890000, 1.3385, 1.3537999999999999, 1.33768, 1.3509899999999999);
INSERT INTO "OHLCData" VALUES (1065, 37, '2013-05-31 00:00:00 ', 1369976400, 1.3509800000000001, 1.3589800000000001, 1.3490899999999999, 1.3578600000000001);
INSERT INTO "OHLCData" VALUES (1066, 37, '2013-06-02 17:00:00 ', 1370210400, 1.3501399999999999, 1.35412, 1.3494999999999999, 1.3518399999999999);
INSERT INTO "OHLCData" VALUES (1067, 37, '2013-06-03 00:00:00 ', 1370235600, 1.35182, 1.3529500000000001, 1.33684, 1.3442799999999999);
INSERT INTO "OHLCData" VALUES (1068, 37, '2013-06-04 00:00:00 ', 1370322000, 1.34423, 1.3605400000000001, 1.3413600000000001, 1.3569);
INSERT INTO "OHLCData" VALUES (1069, 37, '2013-06-05 00:00:00 ', 1370408400, 1.3569100000000001, 1.38622, 1.3555299999999999, 1.3843700000000001);
INSERT INTO "OHLCData" VALUES (1070, 37, '2013-06-06 00:00:00 ', 1370494800, 1.3843799999999999, 1.3993599999999999, 1.3747499999999999, 1.3970800000000001);
INSERT INTO "OHLCData" VALUES (1071, 37, '2013-06-07 00:00:00 ', 1370581200, 1.39707, 1.40161, 1.38724, 1.3916599999999999);
INSERT INTO "OHLCData" VALUES (1072, 37, '2013-06-09 17:00:00 ', 1370815200, 1.40273, 1.4044700000000001, 1.3975, 1.40266);
INSERT INTO "OHLCData" VALUES (1073, 37, '2013-06-10 00:00:00 ', 1370840400, 1.4026799999999999, 1.41212, 1.3958600000000001, 1.4077999999999999);
INSERT INTO "OHLCData" VALUES (1074, 37, '2013-06-11 00:00:00 ', 1370926800, 1.4077900000000001, 1.4235599999999999, 1.4016900000000001, 1.40587);
INSERT INTO "OHLCData" VALUES (1075, 37, '2013-06-12 00:00:00 ', 1371013200, 1.40585, 1.4166799999999999, 1.38781, 1.4126300000000001);
INSERT INTO "OHLCData" VALUES (1076, 37, '2013-06-13 00:00:00 ', 1371099600, 1.4126099999999999, 1.4147799999999999, 1.3832599999999999, 1.393);
INSERT INTO "OHLCData" VALUES (1077, 37, '2013-06-14 00:00:00 ', 1371186000, 1.3929800000000001, 1.3949199999999999, 1.3810100000000001, 1.3941600000000001);
INSERT INTO "OHLCData" VALUES (1078, 37, '2013-06-16 17:00:00 ', 1371420000, 1.3955500000000001, 1.3960300000000001, 1.3850899999999999, 1.38514);
INSERT INTO "OHLCData" VALUES (1079, 37, '2013-06-17 00:00:00 ', 1371445200, 1.3851500000000001, 1.4055500000000001, 1.38236, 1.4031199999999999);
INSERT INTO "OHLCData" VALUES (1080, 37, '2013-06-18 00:00:00 ', 1371531600, 1.40313, 1.4193100000000001, 1.4015299999999999, 1.4126000000000001);
INSERT INTO "OHLCData" VALUES (1081, 37, '2013-06-19 00:00:00 ', 1371618000, 1.4126099999999999, 1.43571, 1.4008799999999999, 1.43313);
INSERT INTO "OHLCData" VALUES (1082, 37, '2013-06-20 00:00:00 ', 1371704400, 1.43316, 1.4413899999999999, 1.43085, 1.4344399999999999);
INSERT INTO "OHLCData" VALUES (1083, 37, '2013-06-21 00:00:00 ', 1371790800, 1.4344300000000001, 1.43635, 1.4198299999999999, 1.4234);
INSERT INTO "OHLCData" VALUES (1084, 37, '2013-06-23 17:00:00 ', 1372024800, 1.42133, 1.42401, 1.4168400000000001, 1.4215100000000001);
INSERT INTO "OHLCData" VALUES (1085, 37, '2013-06-24 00:00:00 ', 1372050000, 1.4216599999999999, 1.43144, 1.41225, 1.42374);
INSERT INTO "OHLCData" VALUES (1086, 37, '2013-06-25 00:00:00 ', 1372136400, 1.4237299999999999, 1.42543, 1.4100999999999999, 1.41276);
INSERT INTO "OHLCData" VALUES (1087, 37, '2013-06-26 00:00:00 ', 1372222800, 1.4127099999999999, 1.4131899999999999, 1.3935900000000001, 1.3980399999999999);
INSERT INTO "OHLCData" VALUES (1088, 37, '2013-06-27 00:00:00 ', 1372309200, 1.39805, 1.4149700000000001, 1.39724, 1.41194);
INSERT INTO "OHLCData" VALUES (1089, 37, '2013-06-28 00:00:00 ', 1372395600, 1.41191, 1.4267399999999999, 1.4075, 1.42326);
INSERT INTO "OHLCData" VALUES (1090, 37, '2013-06-30 17:00:00 ', 1372629600, 1.4276199999999999, 1.4276199999999999, 1.4174199999999999, 1.4188799999999999);
INSERT INTO "OHLCData" VALUES (1091, 37, '2013-07-01 00:00:00 ', 1372654800, 1.4188400000000001, 1.4248700000000001, 1.4114, 1.4164699999999999);
INSERT INTO "OHLCData" VALUES (1092, 37, '2013-07-02 00:00:00 ', 1372741200, 1.4164600000000001, 1.4270799999999999, 1.41221, 1.4253);
INSERT INTO "OHLCData" VALUES (1093, 37, '2013-07-03 00:00:00 ', 1372827600, 1.4252800000000001, 1.4395199999999999, 1.42306, 1.42608);
INSERT INTO "OHLCData" VALUES (1094, 37, '2013-07-04 00:00:00 ', 1372914000, 1.4260900000000001, 1.4292899999999999, 1.40632, 1.41303);
INSERT INTO "OHLCData" VALUES (1095, 37, '2013-07-05 00:00:00 ', 1373000400, 1.41306, 1.4178599999999999, 1.4025799999999999, 1.415);
INSERT INTO "OHLCData" VALUES (1096, 37, '2013-07-07 17:00:00 ', 1373234400, 1.41482, 1.4178900000000001, 1.4145000000000001, 1.41577);
INSERT INTO "OHLCData" VALUES (1097, 37, '2013-07-08 00:00:00 ', 1373259600, 1.41574, 1.4175, 1.4073500000000001, 1.4093100000000001);
INSERT INTO "OHLCData" VALUES (1098, 37, '2013-07-09 00:00:00 ', 1373346000, 1.4092800000000001, 1.4107400000000001, 1.3903700000000001, 1.39432);
INSERT INTO "OHLCData" VALUES (1099, 37, '2013-07-10 00:00:00 ', 1373432400, 1.3943000000000001, 1.42283, 1.38608, 1.41557);
INSERT INTO "OHLCData" VALUES (1100, 37, '2013-07-11 00:00:00 ', 1373518800, 1.41554, 1.4332400000000001, 1.4074199999999999, 1.4255800000000001);
INSERT INTO "OHLCData" VALUES (1101, 37, '2013-07-12 00:00:00 ', 1373605200, 1.4255899999999999, 1.44764, 1.42336, 1.4435899999999999);
INSERT INTO "OHLCData" VALUES (1102, 37, '2013-07-14 17:00:00 ', 1373839200, 1.4417899999999999, 1.4419299999999999, 1.43408, 1.4370700000000001);
INSERT INTO "OHLCData" VALUES (1103, 37, '2013-07-15 00:00:00 ', 1373864400, 1.43706, 1.4395899999999999, 1.4246300000000001, 1.4274);
INSERT INTO "OHLCData" VALUES (1104, 37, '2013-07-16 00:00:00 ', 1373950800, 1.42736, 1.4274100000000001, 1.41838, 1.4230799999999999);
INSERT INTO "OHLCData" VALUES (1105, 37, '2013-07-17 00:00:00 ', 1374037200, 1.4230700000000001, 1.4294899999999999, 1.4164300000000001, 1.42804);
INSERT INTO "OHLCData" VALUES (1106, 37, '2013-07-18 00:00:00 ', 1374123600, 1.4280299999999999, 1.4329700000000001, 1.42604, 1.4305600000000001);
INSERT INTO "OHLCData" VALUES (1107, 37, '2013-07-19 00:00:00 ', 1374210000, 1.4305699999999999, 1.43316, 1.4209799999999999, 1.43268);
INSERT INTO "OHLCData" VALUES (1108, 37, '2013-07-21 17:00:00 ', 1374444000, 1.43126, 1.4323999999999999, 1.4263699999999999, 1.42761);
INSERT INTO "OHLCData" VALUES (1109, 37, '2013-07-22 00:00:00 ', 1374469200, 1.42763, 1.43432, 1.42109, 1.4233800000000001);
INSERT INTO "OHLCData" VALUES (1110, 37, '2013-07-23 00:00:00 ', 1374555600, 1.42334, 1.4294199999999999, 1.4185399999999999, 1.4259299999999999);
INSERT INTO "OHLCData" VALUES (1111, 37, '2013-07-24 00:00:00 ', 1374642000, 1.4259500000000001, 1.4447000000000001, 1.4251499999999999, 1.44258);
INSERT INTO "OHLCData" VALUES (1112, 37, '2013-07-25 00:00:00 ', 1374728400, 1.4425699999999999, 1.4454199999999999, 1.4317299999999999, 1.43279);
INSERT INTO "OHLCData" VALUES (1113, 37, '2013-07-26 00:00:00 ', 1374814800, 1.4327700000000001, 1.4371799999999999, 1.429, 1.4327799999999999);
INSERT INTO "OHLCData" VALUES (1114, 37, '2013-07-28 17:00:00 ', 1375048800, 1.4355800000000001, 1.4361900000000001, 1.43096, 1.4325000000000001);
INSERT INTO "OHLCData" VALUES (1115, 37, '2013-07-29 00:00:00 ', 1375074000, 1.4325399999999999, 1.4612099999999999, 1.43191, 1.45878);
INSERT INTO "OHLCData" VALUES (1116, 37, '2013-07-30 00:00:00 ', 1375160400, 1.45882, 1.4712499999999999, 1.4585399999999999, 1.46912);
INSERT INTO "OHLCData" VALUES (1117, 37, '2013-07-31 00:00:00 ', 1375246800, 1.46912, 1.4904999999999999, 1.46492, 1.4816400000000001);
INSERT INTO "OHLCData" VALUES (1118, 37, '2013-08-01 00:00:00 ', 1375333200, 1.48163, 1.4847399999999999, 1.4709700000000001, 1.4823299999999999);
INSERT INTO "OHLCData" VALUES (1119, 37, '2013-08-02 00:00:00 ', 1375419600, 1.4823500000000001, 1.4938, 1.4793400000000001, 1.49135);
INSERT INTO "OHLCData" VALUES (1120, 37, '2013-08-04 17:00:00 ', 1375653600, 1.48899, 1.49926, 1.4885299999999999, 1.4970699999999999);
INSERT INTO "OHLCData" VALUES (1121, 37, '2013-08-05 00:00:00 ', 1375678800, 1.4971099999999999, 1.4972399999999999, 1.4828399999999999, 1.4848300000000001);
INSERT INTO "OHLCData" VALUES (1122, 37, '2013-08-06 00:00:00 ', 1375765200, 1.4848699999999999, 1.4861800000000001, 1.47357, 1.4831700000000001);
INSERT INTO "OHLCData" VALUES (1123, 37, '2013-08-07 00:00:00 ', 1375851600, 1.4831799999999999, 1.48977, 1.4698500000000001, 1.47271);
INSERT INTO "OHLCData" VALUES (1124, 37, '2013-08-08 00:00:00 ', 1375938000, 1.4726900000000001, 1.4758100000000001, 1.4655899999999999, 1.4690700000000001);
INSERT INTO "OHLCData" VALUES (1125, 37, '2013-08-09 00:00:00 ', 1376024400, 1.46909, 1.47011, 1.4477100000000001, 1.4508399999999999);
INSERT INTO "OHLCData" VALUES (1126, 37, '2013-08-11 17:00:00 ', 1376258400, 1.4493100000000001, 1.4539299999999999, 1.4448300000000001, 1.4480200000000001);
INSERT INTO "OHLCData" VALUES (1127, 37, '2013-08-12 00:00:00 ', 1376283600, 1.4480299999999999, 1.4604900000000001, 1.446, 1.4578899999999999);
INSERT INTO "OHLCData" VALUES (1128, 37, '2013-08-13 00:00:00 ', 1376370000, 1.45787, 1.4599, 1.4530700000000001, 1.4566699999999999);
INSERT INTO "OHLCData" VALUES (1129, 37, '2013-08-14 00:00:00 ', 1376456400, 1.4566600000000001, 1.4597, 1.44709, 1.4490000000000001);
INSERT INTO "OHLCData" VALUES (1130, 37, '2013-08-15 00:00:00 ', 1376542800, 1.4489799999999999, 1.4627300000000001, 1.4459599999999999, 1.45547);
INSERT INTO "OHLCData" VALUES (1131, 37, '2013-08-16 00:00:00 ', 1376629200, 1.4554499999999999, 1.4589300000000001, 1.4473400000000001, 1.4510000000000001);
INSERT INTO "OHLCData" VALUES (1132, 37, '2013-08-18 17:00:00 ', 1376863200, 1.4511400000000001, 1.4521599999999999, 1.4441600000000001, 1.4464699999999999);
INSERT INTO "OHLCData" VALUES (1133, 37, '2013-08-19 00:00:00 ', 1376888400, 1.4464900000000001, 1.4736400000000001, 1.4451499999999999, 1.4722500000000001);
INSERT INTO "OHLCData" VALUES (1134, 37, '2013-08-20 00:00:00 ', 1376974800, 1.47224, 1.48817, 1.47184, 1.48587);
INSERT INTO "OHLCData" VALUES (1135, 37, '2013-08-21 00:00:00 ', 1377061200, 1.4858800000000001, 1.49274, 1.4787399999999999, 1.4838);
INSERT INTO "OHLCData" VALUES (1136, 37, '2013-08-22 00:00:00 ', 1377147600, 1.4837899999999999, 1.48641, 1.4751799999999999, 1.4794799999999999);
INSERT INTO "OHLCData" VALUES (1137, 37, '2013-08-23 00:00:00 ', 1377234000, 1.47953, 1.4883299999999999, 1.47868, 1.4822);
INSERT INTO "OHLCData" VALUES (1138, 37, '2013-08-25 17:00:00 ', 1377468000, 1.4812099999999999, 1.48532, 1.4798, 1.4799800000000001);
INSERT INTO "OHLCData" VALUES (1139, 37, '2013-08-26 00:00:00 ', 1377493200, 1.4799899999999999, 1.4912300000000001, 1.4759199999999999, 1.48783);
INSERT INTO "OHLCData" VALUES (1140, 37, '2013-08-27 00:00:00 ', 1377579600, 1.4878199999999999, 1.50119, 1.4866299999999999, 1.49895);
INSERT INTO "OHLCData" VALUES (1141, 37, '2013-08-28 00:00:00 ', 1377666000, 1.49891, 1.5028999999999999, 1.48478, 1.4870300000000001);
INSERT INTO "OHLCData" VALUES (1142, 37, '2013-08-29 00:00:00 ', 1377752400, 1.4870000000000001, 1.4870000000000001, 1.4787999999999999, 1.47959);
INSERT INTO "OHLCData" VALUES (1143, 37, '2013-08-30 00:00:00 ', 1377838800, 1.4796, 1.4856, 1.47645, 1.48532);
INSERT INTO "OHLCData" VALUES (1144, 37, '2013-09-01 17:00:00 ', 1378072800, 1.47716, 1.4803299999999999, 1.47166, 1.4729300000000001);
INSERT INTO "OHLCData" VALUES (1145, 37, '2013-09-02 00:00:00 ', 1378098000, 1.4728300000000001, 1.47376, 1.4611499999999999, 1.4672400000000001);
INSERT INTO "OHLCData" VALUES (1146, 37, '2013-09-03 00:00:00 ', 1378184400, 1.4673, 1.46845, 1.44601, 1.44702);
INSERT INTO "OHLCData" VALUES (1147, 37, '2013-09-04 00:00:00 ', 1378270800, 1.4469799999999999, 1.44851, 1.4344699999999999, 1.4390799999999999);
INSERT INTO "OHLCData" VALUES (1148, 37, '2013-09-05 00:00:00 ', 1378357200, 1.4390700000000001, 1.4467399999999999, 1.4353400000000001, 1.43791);
INSERT INTO "OHLCData" VALUES (1149, 37, '2013-09-06 00:00:00 ', 1378443600, 1.4378899999999999, 1.4388399999999999, 1.4259299999999999, 1.43482);
INSERT INTO "OHLCData" VALUES (1150, 37, '2013-09-08 17:00:00 ', 1378677600, 1.43025, 1.43672, 1.4296199999999999, 1.4311199999999999);
INSERT INTO "OHLCData" VALUES (1151, 37, '2013-09-09 00:00:00 ', 1378702800, 1.43113, 1.4384699999999999, 1.4300200000000001, 1.4303900000000001);
INSERT INTO "OHLCData" VALUES (1152, 37, '2013-09-10 00:00:00 ', 1378789200, 1.4303999999999999, 1.43387, 1.42363, 1.4267099999999999);
INSERT INTO "OHLCData" VALUES (1153, 37, '2013-09-11 00:00:00 ', 1378875600, 1.4267300000000001, 1.43919, 1.4234599999999999, 1.43852);
INSERT INTO "OHLCData" VALUES (1154, 37, '2013-09-12 00:00:00 ', 1378962000, 1.43851, 1.4399999999999999, 1.43265, 1.43666);
INSERT INTO "OHLCData" VALUES (1155, 37, '2013-09-13 00:00:00 ', 1379048400, 1.43665, 1.4391400000000001, 1.4319900000000001, 1.4378);
INSERT INTO "OHLCData" VALUES (1156, 37, '2013-09-15 17:00:00 ', 1379282400, 1.4317500000000001, 1.43424, 1.42293, 1.4325699999999999);
INSERT INTO "OHLCData" VALUES (1157, 37, '2013-09-16 00:00:00 ', 1379307600, 1.4325600000000001, 1.4355899999999999, 1.4217299999999999, 1.4327099999999999);
INSERT INTO "OHLCData" VALUES (1158, 37, '2013-09-17 00:00:00 ', 1379394000, 1.43272, 1.4343300000000001, 1.42577, 1.42882);
INSERT INTO "OHLCData" VALUES (1159, 37, '2013-09-18 00:00:00 ', 1379480400, 1.42883, 1.4292100000000001, 1.4191499999999999, 1.4252);
INSERT INTO "OHLCData" VALUES (1160, 37, '2013-09-19 00:00:00 ', 1379566800, 1.4252199999999999, 1.4344699999999999, 1.4217200000000001, 1.4320299999999999);
INSERT INTO "OHLCData" VALUES (1161, 37, '2013-09-20 00:00:00 ', 1379653200, 1.43204, 1.4396899999999999, 1.43031, 1.43947);
INSERT INTO "OHLCData" VALUES (1162, 37, '2013-09-22 17:00:00 ', 1379887200, 1.44591, 1.44591, 1.43329, 1.4361200000000001);
INSERT INTO "OHLCData" VALUES (1163, 37, '2013-09-23 00:00:00 ', 1379912400, 1.4360999999999999, 1.4373, 1.42717, 1.43302);
INSERT INTO "OHLCData" VALUES (1164, 37, '2013-09-24 00:00:00 ', 1379998800, 1.4330099999999999, 1.43912, 1.4327000000000001, 1.4374);
INSERT INTO "OHLCData" VALUES (1165, 37, '2013-09-25 00:00:00 ', 1380085200, 1.4373899999999999, 1.4455499999999999, 1.43577, 1.44303);
INSERT INTO "OHLCData" VALUES (1166, 37, '2013-09-26 00:00:00 ', 1380171600, 1.4430400000000001, 1.44387, 1.43635, 1.44248);
INSERT INTO "OHLCData" VALUES (1167, 37, '2013-09-27 00:00:00 ', 1380258000, 1.4424699999999999, 1.4558599999999999, 1.4406099999999999, 1.45123);
INSERT INTO "OHLCData" VALUES (1168, 37, '2013-09-29 17:00:00 ', 1380492000, 1.4489399999999999, 1.4537800000000001, 1.4474199999999999, 1.4498899999999999);
INSERT INTO "OHLCData" VALUES (1169, 37, '2013-09-30 00:00:00 ', 1380517200, 1.44987, 1.4552499999999999, 1.44526, 1.44987);
INSERT INTO "OHLCData" VALUES (1170, 37, '2013-10-01 00:00:00 ', 1380603600, 1.4498899999999999, 1.45042, 1.43571, 1.44258);
INSERT INTO "OHLCData" VALUES (1171, 37, '2013-10-02 00:00:00 ', 1380690000, 1.4425600000000001, 1.4541900000000001, 1.44224, 1.4486300000000001);
INSERT INTO "OHLCData" VALUES (1172, 37, '2013-10-03 00:00:00 ', 1380776400, 1.4486399999999999, 1.4545399999999999, 1.4431700000000001, 1.4436500000000001);
INSERT INTO "OHLCData" VALUES (1173, 37, '2013-10-04 00:00:00 ', 1380862800, 1.4436100000000001, 1.44479, 1.43347, 1.4362600000000001);
INSERT INTO "OHLCData" VALUES (1174, 37, '2013-10-06 17:00:00 ', 1381096800, 1.4372499999999999, 1.44038, 1.4354199999999999, 1.44007);
INSERT INTO "OHLCData" VALUES (1175, 37, '2013-10-07 00:00:00 ', 1381122000, 1.4400299999999999, 1.44648, 1.43685, 1.4391799999999999);
INSERT INTO "OHLCData" VALUES (1176, 37, '2013-10-08 00:00:00 ', 1381208400, 1.4392100000000001, 1.4412700000000001, 1.43062, 1.43794);
INSERT INTO "OHLCData" VALUES (1177, 37, '2013-10-09 00:00:00 ', 1381294800, 1.4379299999999999, 1.43893, 1.42696, 1.4343600000000001);
INSERT INTO "OHLCData" VALUES (1178, 37, '2013-10-10 00:00:00 ', 1381381200, 1.43438, 1.43675, 1.42723, 1.4288400000000001);
INSERT INTO "OHLCData" VALUES (1179, 37, '2013-10-11 00:00:00 ', 1381467600, 1.4287700000000001, 1.4353400000000001, 1.4275500000000001, 1.42997);
INSERT INTO "OHLCData" VALUES (1180, 37, '2013-10-13 17:00:00 ', 1381701600, 1.43849, 1.4384999999999999, 1.4319599999999999, 1.4322299999999999);
INSERT INTO "OHLCData" VALUES (1181, 37, '2013-10-14 00:00:00 ', 1381726800, 1.43224, 1.4346099999999999, 1.4215500000000001, 1.4230799999999999);
INSERT INTO "OHLCData" VALUES (1182, 37, '2013-10-15 00:00:00 ', 1381813200, 1.42309, 1.4240200000000001, 1.4141300000000001, 1.4184600000000001);
INSERT INTO "OHLCData" VALUES (1183, 37, '2013-10-16 00:00:00 ', 1381899600, 1.4184699999999999, 1.4231400000000001, 1.41408, 1.4194899999999999);
INSERT INTO "OHLCData" VALUES (1184, 37, '2013-10-17 00:00:00 ', 1381986000, 1.4194800000000001, 1.4237500000000001, 1.41645, 1.41977);
INSERT INTO "OHLCData" VALUES (1185, 37, '2013-10-18 00:00:00 ', 1382072400, 1.41978, 1.42106, 1.4132400000000001, 1.41415);
INSERT INTO "OHLCData" VALUES (1186, 37, '2013-10-20 17:00:00 ', 1382306400, 1.41462, 1.41781, 1.41438, 1.41513);
INSERT INTO "OHLCData" VALUES (1187, 37, '2013-10-21 00:00:00 ', 1382331600, 1.41506, 1.41751, 1.41249, 1.41615);
INSERT INTO "OHLCData" VALUES (1188, 37, '2013-10-22 00:00:00 ', 1382418000, 1.41614, 1.4209700000000001, 1.4121999999999999, 1.4208400000000001);
INSERT INTO "OHLCData" VALUES (1189, 37, '2013-10-23 00:00:00 ', 1382504400, 1.42082, 1.43394, 1.42075, 1.4288799999999999);
INSERT INTO "OHLCData" VALUES (1190, 37, '2013-10-24 00:00:00 ', 1382590800, 1.4288700000000001, 1.4410700000000001, 1.42744, 1.4367799999999999);
INSERT INTO "OHLCData" VALUES (1191, 37, '2013-10-25 00:00:00 ', 1382677200, 1.43679, 1.4418200000000001, 1.43554, 1.43987);
INSERT INTO "OHLCData" VALUES (1192, 37, '2013-10-27 17:00:00 ', 1382911200, 1.4401600000000001, 1.44069, 1.4361200000000001, 1.43727);
INSERT INTO "OHLCData" VALUES (1193, 37, '2013-10-28 00:00:00 ', 1382936400, 1.43729, 1.4491799999999999, 1.43486, 1.4490000000000001);
INSERT INTO "OHLCData" VALUES (1194, 37, '2013-10-29 00:00:00 ', 1383022800, 1.4490700000000001, 1.4528399999999999, 1.4461599999999999, 1.4503299999999999);
INSERT INTO "OHLCData" VALUES (1195, 37, '2013-10-30 00:00:00 ', 1383109200, 1.4503600000000001, 1.45245, 1.4432499999999999, 1.44377);
INSERT INTO "OHLCData" VALUES (1196, 37, '2013-10-31 00:00:00 ', 1383195600, 1.4437599999999999, 1.4453199999999999, 1.42933, 1.4298299999999999);
INSERT INTO "OHLCData" VALUES (1197, 37, '2013-11-01 00:00:00 ', 1383282000, 1.42981, 1.43092, 1.4249700000000001, 1.4286099999999999);
INSERT INTO "OHLCData" VALUES (1198, 37, '2013-11-03 17:00:00 ', 1383519600, 1.42611, 1.42842, 1.4192, 1.42188);
INSERT INTO "OHLCData" VALUES (1199, 37, '2013-11-04 00:00:00 ', 1383544800, 1.4218599999999999, 1.42631, 1.4196299999999999, 1.4255899999999999);
INSERT INTO "OHLCData" VALUES (1200, 37, '2013-11-05 00:00:00 ', 1383631200, 1.42561, 1.4258500000000001, 1.41448, 1.4190499999999999);
INSERT INTO "OHLCData" VALUES (1201, 37, '2013-11-06 00:00:00 ', 1383717600, 1.41906, 1.4273199999999999, 1.4159900000000001, 1.4261900000000001);
INSERT INTO "OHLCData" VALUES (1202, 37, '2013-11-07 00:00:00 ', 1383804000, 1.42618, 1.4272899999999999, 1.4049100000000001, 1.41652);
INSERT INTO "OHLCData" VALUES (1203, 37, '2013-11-08 00:00:00 ', 1383890400, 1.41655, 1.4263300000000001, 1.41432, 1.4244600000000001);
INSERT INTO "OHLCData" VALUES (1204, 37, '2013-11-10 17:00:00 ', 1384124400, 1.4227799999999999, 1.4248700000000001, 1.42276, 1.4241600000000001);
INSERT INTO "OHLCData" VALUES (1205, 37, '2013-11-11 00:00:00 ', 1384149600, 1.42415, 1.43607, 1.42293, 1.43452);
INSERT INTO "OHLCData" VALUES (1206, 37, '2013-11-12 00:00:00 ', 1384236000, 1.43451, 1.4483200000000001, 1.43177, 1.4453100000000001);
INSERT INTO "OHLCData" VALUES (1207, 37, '2013-11-13 00:00:00 ', 1384322400, 1.44529, 1.4477899999999999, 1.4368000000000001, 1.44076);
INSERT INTO "OHLCData" VALUES (1208, 37, '2013-11-14 00:00:00 ', 1384408800, 1.44075, 1.4476500000000001, 1.43838, 1.4397899999999999);
INSERT INTO "OHLCData" VALUES (1209, 37, '2013-11-15 00:00:00 ', 1384495200, 1.4398, 1.4436899999999999, 1.4378500000000001, 1.4402699999999999);
INSERT INTO "OHLCData" VALUES (1210, 37, '2013-11-17 17:00:00 ', 1384729200, 1.4391, 1.44025, 1.43519, 1.4352499999999999);
INSERT INTO "OHLCData" VALUES (1211, 37, '2013-11-18 00:00:00 ', 1384754400, 1.43526, 1.44339, 1.43285, 1.43893);
INSERT INTO "OHLCData" VALUES (1212, 37, '2013-11-19 00:00:00 ', 1384840800, 1.43892, 1.4406099999999999, 1.4317, 1.4404600000000001);
INSERT INTO "OHLCData" VALUES (1213, 37, '2013-11-20 00:00:00 ', 1384927200, 1.44049, 1.44478, 1.43232, 1.4430000000000001);
INSERT INTO "OHLCData" VALUES (1214, 37, '2013-11-21 00:00:00 ', 1385013600, 1.44299, 1.4683600000000001, 1.4419599999999999, 1.46621);
INSERT INTO "OHLCData" VALUES (1215, 37, '2013-11-22 00:00:00 ', 1385100000, 1.4662200000000001, 1.4805299999999999, 1.46435, 1.47818);
INSERT INTO "OHLCData" VALUES (1216, 37, '2013-11-24 17:01:00 ', 1385334060, 1.47844, 1.4810099999999999, 1.4740200000000001, 1.4803599999999999);
INSERT INTO "OHLCData" VALUES (1217, 37, '2013-11-25 00:00:00 ', 1385359200, 1.48024, 1.4841299999999999, 1.47078, 1.4716800000000001);
INSERT INTO "OHLCData" VALUES (1218, 37, '2013-11-26 00:00:00 ', 1385445600, 1.47167, 1.4903299999999999, 1.4715800000000001, 1.49003);
INSERT INTO "OHLCData" VALUES (1219, 37, '2013-11-27 00:00:00 ', 1385532000, 1.49004, 1.4988300000000001, 1.4847699999999999, 1.48739);
INSERT INTO "OHLCData" VALUES (1220, 37, '2013-11-28 00:00:00 ', 1385618400, 1.4873799999999999, 1.5029699999999999, 1.4860899999999999, 1.4978199999999999);
INSERT INTO "OHLCData" VALUES (1221, 37, '2013-11-29 00:00:00 ', 1385704800, 1.49783, 1.498, 1.4892700000000001, 1.4920199999999999);
INSERT INTO "OHLCData" VALUES (1222, 37, '2013-12-01 17:00:00 ', 1385938800, 1.4882299999999999, 1.49146, 1.48458, 1.4861800000000001);
INSERT INTO "OHLCData" VALUES (1223, 37, '2013-12-02 00:00:00 ', 1385964000, 1.48621, 1.4942899999999999, 1.4797800000000001, 1.49237);
INSERT INTO "OHLCData" VALUES (1224, 37, '2013-12-03 00:00:00 ', 1386050400, 1.49238, 1.5022, 1.48566, 1.49871);
INSERT INTO "OHLCData" VALUES (1225, 37, '2013-12-04 00:00:00 ', 1386136800, 1.4986999999999999, 1.50867, 1.49803, 1.50454);
INSERT INTO "OHLCData" VALUES (1226, 37, '2013-12-05 00:00:00 ', 1386223200, 1.5045299999999999, 1.5145500000000001, 1.50048, 1.50831);
INSERT INTO "OHLCData" VALUES (1227, 37, '2013-12-06 00:00:00 ', 1386309600, 1.5082899999999999, 1.51614, 1.5015400000000001, 1.50566);
INSERT INTO "OHLCData" VALUES (1228, 37, '2013-12-08 17:00:00 ', 1386543600, 1.5031600000000001, 1.5062800000000001, 1.50149, 1.50526);
INSERT INTO "OHLCData" VALUES (1229, 37, '2013-12-09 00:00:00 ', 1386568800, 1.5052700000000001, 1.5132399999999999, 1.50471, 1.51098);
INSERT INTO "OHLCData" VALUES (1230, 37, '2013-12-10 00:00:00 ', 1386655200, 1.5109600000000001, 1.51373, 1.5018400000000001, 1.50621);
INSERT INTO "OHLCData" VALUES (1231, 37, '2013-12-11 00:00:00 ', 1386741600, 1.50623, 1.5304800000000001, 1.5059899999999999, 1.52837);
INSERT INTO "OHLCData" VALUES (1232, 37, '2013-12-12 00:00:00 ', 1386828000, 1.5283599999999999, 1.54305, 1.51874, 1.53871);
INSERT INTO "OHLCData" VALUES (1233, 37, '2013-12-13 00:00:00 ', 1386914400, 1.53881, 1.54122, 1.53105, 1.5330999999999999);
INSERT INTO "OHLCData" VALUES (1234, 37, '2013-12-15 17:00:00 ', 1387148400, 1.5319499999999999, 1.5412300000000001, 1.5318499999999999, 1.5358099999999999);
INSERT INTO "OHLCData" VALUES (1235, 37, '2013-12-16 00:00:00 ', 1387173600, 1.5357499999999999, 1.5440400000000001, 1.5331399999999999, 1.53986);
INSERT INTO "OHLCData" VALUES (1236, 37, '2013-12-17 00:00:00 ', 1387260000, 1.5398700000000001, 1.54809, 1.5382, 1.54695);
INSERT INTO "OHLCData" VALUES (1237, 37, '2013-12-18 00:00:00 ', 1387346400, 1.5468999999999999, 1.5576300000000001, 1.54175, 1.54545);
INSERT INTO "OHLCData" VALUES (1238, 37, '2013-12-19 00:00:00 ', 1387432800, 1.54549, 1.5475699999999999, 1.53504, 1.5369699999999999);
INSERT INTO "OHLCData" VALUES (1239, 37, '2013-12-20 00:00:00 ', 1387519200, 1.53695, 1.54094, 1.53044, 1.5324199999999999);
INSERT INTO "OHLCData" VALUES (1240, 37, '2013-12-22 17:00:00 ', 1387753200, 1.5322499999999999, 1.5340199999999999, 1.52898, 1.52905);
INSERT INTO "OHLCData" VALUES (1241, 37, '2013-12-23 00:00:00 ', 1387778400, 1.5290600000000001, 1.53609, 1.52857, 1.53312);
INSERT INTO "OHLCData" VALUES (1242, 37, '2013-12-24 00:00:00 ', 1387864800, 1.53315, 1.53633, 1.53087, 1.5325299999999999);
INSERT INTO "OHLCData" VALUES (1243, 37, '2013-12-26 06:00:00 ', 1388059200, 1.53956, 1.5464500000000001, 1.5374099999999999, 1.5424);
INSERT INTO "OHLCData" VALUES (1244, 37, '2013-12-27 00:00:00 ', 1388124000, 1.5424199999999999, 1.5595600000000001, 1.5412999999999999, 1.5500100000000001);
INSERT INTO "OHLCData" VALUES (1245, 37, '2013-12-29 17:00:00 ', 1388358000, 1.5520700000000001, 1.5556000000000001, 1.54986, 1.54986);
INSERT INTO "OHLCData" VALUES (1246, 37, '2013-12-30 00:00:00 ', 1388383200, 1.5499000000000001, 1.5548, 1.5418499999999999, 1.54189);
INSERT INTO "OHLCData" VALUES (1247, 37, '2013-12-31 00:00:00 ', 1388469600, 1.5419, 1.5462, 1.5380799999999999, 1.5405500000000001);
INSERT INTO "OHLCData" VALUES (1248, 37, '2014-01-01 17:00:00 ', 1388617200, 1.54792, 1.5487299999999999, 1.5410900000000001, 1.54253);
INSERT INTO "OHLCData" VALUES (1249, 37, '2014-01-02 00:00:00 ', 1388642400, 1.5425199999999999, 1.54871, 1.52135, 1.5221100000000001);
INSERT INTO "OHLCData" VALUES (1250, 37, '2014-01-03 00:00:00 ', 1388728800, 1.5220800000000001, 1.5230900000000001, 1.51146, 1.51888);
INSERT INTO "OHLCData" VALUES (1251, 37, '2014-01-05 17:00:00 ', 1388962800, 1.51691, 1.51969, 1.5126200000000001, 1.5177400000000001);
INSERT INTO "OHLCData" VALUES (1252, 37, '2014-01-06 00:00:00 ', 1388988000, 1.51773, 1.5271600000000001, 1.51281, 1.52694);
INSERT INTO "OHLCData" VALUES (1253, 37, '2014-01-07 00:00:00 ', 1389074400, 1.5269299999999999, 1.5308299999999999, 1.5243, 1.52658);
INSERT INTO "OHLCData" VALUES (1254, 37, '2014-01-08 00:00:00 ', 1389160800, 1.5265899999999999, 1.53085, 1.51963, 1.52874);
INSERT INTO "OHLCData" VALUES (1255, 37, '2014-01-09 00:00:00 ', 1389247200, 1.5287500000000001, 1.53538, 1.5231300000000001, 1.52841);
INSERT INTO "OHLCData" VALUES (1256, 37, '2014-01-10 00:00:00 ', 1389333600, 1.5284, 1.5322899999999999, 1.51719, 1.51938);
INSERT INTO "OHLCData" VALUES (1257, 37, '2014-01-12 17:00:00 ', 1389567600, 1.51989, 1.5211399999999999, 1.5130399999999999, 1.5136499999999999);
INSERT INTO "OHLCData" VALUES (1258, 37, '2014-01-13 00:00:00 ', 1389592800, 1.51366, 1.5152399999999999, 1.50288, 1.51251);
INSERT INTO "OHLCData" VALUES (1259, 37, '2014-01-14 00:00:00 ', 1389679200, 1.51254, 1.52966, 1.5105500000000001, 1.5295700000000001);
INSERT INTO "OHLCData" VALUES (1260, 37, '2014-01-15 00:00:00 ', 1389765600, 1.52956, 1.54745, 1.5214300000000001, 1.5451900000000001);
INSERT INTO "OHLCData" VALUES (1261, 37, '2014-01-16 00:00:00 ', 1389852000, 1.5451699999999999, 1.5506, 1.54196, 1.5431900000000001);
INSERT INTO "OHLCData" VALUES (1262, 37, '2014-01-17 00:00:00 ', 1389938400, 1.5433399999999999, 1.54819, 1.54095, 1.5417099999999999);
INSERT INTO "OHLCData" VALUES (1263, 37, '2014-01-19 17:00:00 ', 1390172400, 1.5429299999999999, 1.54328, 1.5371999999999999, 1.5407500000000001);
INSERT INTO "OHLCData" VALUES (1264, 37, '2014-01-20 00:00:00 ', 1390197600, 1.54074, 1.54148, 1.5335700000000001, 1.5355700000000001);
INSERT INTO "OHLCData" VALUES (1265, 37, '2014-01-21 00:00:00 ', 1390284000, 1.5355300000000001, 1.5426200000000001, 1.52901, 1.5294700000000001);
INSERT INTO "OHLCData" VALUES (1266, 37, '2014-01-22 00:00:00 ', 1390370400, 1.5294099999999999, 1.54098, 1.5235099999999999, 1.5392600000000001);
INSERT INTO "OHLCData" VALUES (1267, 37, '2014-01-23 00:00:00 ', 1390456800, 1.5392699999999999, 1.5719799999999999, 1.53698, 1.5698700000000001);
INSERT INTO "OHLCData" VALUES (1268, 37, '2014-01-24 00:00:00 ', 1390543200, 1.5698799999999999, 1.58301, 1.5681799999999999, 1.57483);
INSERT INTO "OHLCData" VALUES (1269, 37, '2014-01-26 17:00:00 ', 1390777200, 1.57317, 1.57708, 1.5659000000000001, 1.5688500000000001);
INSERT INTO "OHLCData" VALUES (1270, 37, '2014-01-27 00:00:00 ', 1390802400, 1.56887, 1.5736000000000001, 1.55514, 1.5564899999999999);
INSERT INTO "OHLCData" VALUES (1271, 37, '2014-01-28 00:00:00 ', 1390888800, 1.5565, 1.5601400000000001, 1.5473600000000001, 1.5500499999999999);
INSERT INTO "OHLCData" VALUES (1272, 37, '2014-01-29 00:00:00 ', 1390975200, 1.5500700000000001, 1.56724, 1.5500700000000001, 1.5640499999999999);
INSERT INTO "OHLCData" VALUES (1273, 37, '2014-01-30 00:00:00 ', 1391061600, 1.5640400000000001, 1.5651600000000001, 1.536, 1.54593);
INSERT INTO "OHLCData" VALUES (1274, 37, '2014-01-31 00:00:00 ', 1391148000, 1.5459499999999999, 1.5587599999999999, 1.5400700000000001, 1.54101);
INSERT INTO "OHLCData" VALUES (1275, 37, '2014-02-02 17:00:00 ', 1391382000, 1.53775, 1.5421499999999999, 1.53714, 1.5399799999999999);
INSERT INTO "OHLCData" VALUES (1276, 37, '2014-02-03 00:00:00 ', 1391407200, 1.53992, 1.54809, 1.51875, 1.52105);
INSERT INTO "OHLCData" VALUES (1277, 37, '2014-02-04 00:00:00 ', 1391493600, 1.5210399999999999, 1.5260800000000001, 1.5110600000000001, 1.5195099999999999);
INSERT INTO "OHLCData" VALUES (1278, 37, '2014-02-05 00:00:00 ', 1391580000, 1.51953, 1.5216499999999999, 1.50671, 1.50847);
INSERT INTO "OHLCData" VALUES (1279, 37, '2014-02-06 00:00:00 ', 1391666400, 1.5084500000000001, 1.5230999999999999, 1.5021, 1.5202100000000001);
INSERT INTO "OHLCData" VALUES (1280, 37, '2014-02-07 00:00:00 ', 1391752800, 1.5202, 1.52244, 1.5112399999999999, 1.5217000000000001);
INSERT INTO "OHLCData" VALUES (1281, 37, '2014-02-09 17:00:00 ', 1391986800, 1.5200899999999999, 1.5259199999999999, 1.5200899999999999, 1.5248600000000001);
INSERT INTO "OHLCData" VALUES (1282, 37, '2014-02-10 00:00:00 ', 1392012000, 1.52484, 1.5317799999999999, 1.5163899999999999, 1.5169900000000001);
INSERT INTO "OHLCData" VALUES (1283, 37, '2014-02-11 00:00:00 ', 1392098400, 1.5169999999999999, 1.5185599999999999, 1.50362, 1.5059);
INSERT INTO "OHLCData" VALUES (1284, 37, '2014-02-12 00:00:00 ', 1392184800, 1.5059100000000001, 1.5240800000000001, 1.4983500000000001, 1.5234099999999999);
INSERT INTO "OHLCData" VALUES (1285, 37, '2014-02-13 00:00:00 ', 1392271200, 1.52338, 1.5277700000000001, 1.5158700000000001, 1.52075);
INSERT INTO "OHLCData" VALUES (1286, 37, '2014-02-14 00:00:00 ', 1392357600, 1.5207299999999999, 1.5243199999999999, 1.51414, 1.51647);
INSERT INTO "OHLCData" VALUES (1287, 37, '2014-02-16 17:00:00 ', 1392591600, 1.5124899999999999, 1.51675, 1.5118499999999999, 1.5147900000000001);
INSERT INTO "OHLCData" VALUES (1288, 37, '2014-02-17 00:00:00 ', 1392616800, 1.51481, 1.51945, 1.5083899999999999, 1.5142500000000001);
INSERT INTO "OHLCData" VALUES (1289, 37, '2014-02-18 00:00:00 ', 1392703200, 1.51423, 1.5307500000000001, 1.5137700000000001, 1.5261499999999999);
INSERT INTO "OHLCData" VALUES (1290, 37, '2014-02-19 00:00:00 ', 1392789600, 1.52616, 1.53854, 1.5201199999999999, 1.53634);
INSERT INTO "OHLCData" VALUES (1291, 37, '2014-02-20 00:00:00 ', 1392876000, 1.5363500000000001, 1.5371699999999999, 1.5204200000000001, 1.52536);
INSERT INTO "OHLCData" VALUES (1292, 37, '2014-02-21 00:00:00 ', 1392962400, 1.5254000000000001, 1.53424, 1.5218100000000001, 1.53006);
INSERT INTO "OHLCData" VALUES (1293, 37, '2014-02-23 17:00:00 ', 1393196400, 1.52908, 1.5364100000000001, 1.52854, 1.5317799999999999);
INSERT INTO "OHLCData" VALUES (1294, 37, '2014-02-24 00:00:00 ', 1393221600, 1.5317000000000001, 1.53328, 1.5180199999999999, 1.5202);
INSERT INTO "OHLCData" VALUES (1295, 37, '2014-02-25 00:00:00 ', 1393308000, 1.5201899999999999, 1.5319700000000001, 1.5195099999999999, 1.5246);
INSERT INTO "OHLCData" VALUES (1296, 37, '2014-02-26 00:00:00 ', 1393394400, 1.52461, 1.53433, 1.5223599999999999, 1.53068);
INSERT INTO "OHLCData" VALUES (1297, 37, '2014-02-27 00:00:00 ', 1393480800, 1.5307299999999999, 1.5354699999999999, 1.5247599999999999, 1.5309999999999999);
INSERT INTO "OHLCData" VALUES (1298, 37, '2014-02-28 00:00:00 ', 1393567200, 1.5309900000000001, 1.54915, 1.52759, 1.5449299999999999);
INSERT INTO "OHLCData" VALUES (1299, 37, '2014-03-02 17:00:00 ', 1393801200, 1.5467599999999999, 1.5497700000000001, 1.54356, 1.5461400000000001);
INSERT INTO "OHLCData" VALUES (1300, 37, '2014-03-03 00:00:00 ', 1393826400, 1.54613, 1.5461800000000001, 1.53051, 1.53769);
INSERT INTO "OHLCData" VALUES (1301, 37, '2014-03-04 00:00:00 ', 1393912800, 1.5376700000000001, 1.54034, 1.52695, 1.5325200000000001);
INSERT INTO "OHLCData" VALUES (1302, 37, '2014-03-05 00:00:00 ', 1393999200, 1.5324899999999999, 1.5334399999999999, 1.51976, 1.52268);
INSERT INTO "OHLCData" VALUES (1303, 37, '2014-03-06 00:00:00 ', 1394085600, 1.5226900000000001, 1.5285500000000001, 1.51475, 1.52464);
INSERT INTO "OHLCData" VALUES (1304, 37, '2014-03-07 00:00:00 ', 1394172000, 1.52461, 1.53088, 1.5200800000000001, 1.5291399999999999);
INSERT INTO "OHLCData" VALUES (1305, 37, '2014-03-09 17:00:00 ', 1394402400, 1.53488, 1.5376700000000001, 1.5311999999999999, 1.5355000000000001);
INSERT INTO "OHLCData" VALUES (1306, 37, '2014-03-10 00:00:00 ', 1394427600, 1.53549, 1.53969, 1.5333000000000001, 1.53609);
INSERT INTO "OHLCData" VALUES (1307, 37, '2014-03-11 00:00:00 ', 1394514000, 1.5360499999999999, 1.5482400000000001, 1.53091, 1.5454300000000001);
INSERT INTO "OHLCData" VALUES (1308, 37, '2014-03-12 00:00:00 ', 1394600400, 1.54542, 1.5535600000000001, 1.53169, 1.53346);
INSERT INTO "OHLCData" VALUES (1309, 37, '2014-03-13 00:00:00 ', 1394686800, 1.53349, 1.54115, 1.53094, 1.53562);
INSERT INTO "OHLCData" VALUES (1310, 37, '2014-03-14 00:00:00 ', 1394773200, 1.5356300000000001, 1.5434099999999999, 1.53545, 1.54006);
INSERT INTO "OHLCData" VALUES (1311, 37, '2014-03-16 17:00:00 ', 1395007200, 1.5433399999999999, 1.54494, 1.5385200000000001, 1.53911);
INSERT INTO "OHLCData" VALUES (1312, 37, '2014-03-17 00:00:00 ', 1395032400, 1.5390900000000001, 1.5391699999999999, 1.5280199999999999, 1.5331600000000001);
INSERT INTO "OHLCData" VALUES (1313, 37, '2014-03-18 00:00:00 ', 1395118800, 1.53315, 1.53678, 1.52101, 1.52695);
INSERT INTO "OHLCData" VALUES (1314, 37, '2014-03-19 00:00:00 ', 1395205200, 1.5268999999999999, 1.5356300000000001, 1.52491, 1.53352);
INSERT INTO "OHLCData" VALUES (1315, 37, '2014-03-20 00:00:00 ', 1395291600, 1.5335000000000001, 1.5347200000000001, 1.52027, 1.52105);
INSERT INTO "OHLCData" VALUES (1316, 37, '2014-03-21 00:00:00 ', 1395378000, 1.5210600000000001, 1.52186, 1.5156499999999999, 1.51823);
INSERT INTO "OHLCData" VALUES (1317, 37, '2014-03-23 17:00:00 ', 1395612000, 1.51569, 1.5240800000000001, 1.5146900000000001, 1.5195700000000001);
INSERT INTO "OHLCData" VALUES (1318, 37, '2014-03-24 00:00:00 ', 1395637200, 1.51956, 1.5208999999999999, 1.5085200000000001, 1.51376);
INSERT INTO "OHLCData" VALUES (1319, 37, '2014-03-25 00:00:00 ', 1395723600, 1.5137700000000001, 1.5160199999999999, 1.5032799999999999, 1.50552);
INSERT INTO "OHLCData" VALUES (1320, 37, '2014-03-26 00:00:00 ', 1395810000, 1.50553, 1.50586, 1.4914099999999999, 1.4922200000000001);
INSERT INTO "OHLCData" VALUES (1321, 37, '2014-03-27 00:00:00 ', 1395896400, 1.49227, 1.4928900000000001, 1.47841, 1.4809699999999999);
INSERT INTO "OHLCData" VALUES (1322, 37, '2014-03-28 00:00:00 ', 1395982800, 1.48098, 1.4896499999999999, 1.4778100000000001, 1.48674);
INSERT INTO "OHLCData" VALUES (1323, 37, '2014-03-30 17:00:00 ', 1396216800, 1.48926, 1.4896100000000001, 1.4851000000000001, 1.48892);
INSERT INTO "OHLCData" VALUES (1324, 37, '2014-03-31 00:00:00 ', 1396242000, 1.48888, 1.4956199999999999, 1.4804299999999999, 1.4867600000000001);
INSERT INTO "OHLCData" VALUES (1325, 37, '2014-04-01 00:00:00 ', 1396328400, 1.4865999999999999, 1.4959499999999999, 1.4841200000000001, 1.4937199999999999);
INSERT INTO "OHLCData" VALUES (1326, 37, '2014-04-02 00:00:00 ', 1396414800, 1.49373, 1.4963200000000001, 1.4873099999999999, 1.49237);
INSERT INTO "OHLCData" VALUES (1327, 37, '2014-04-03 00:00:00 ', 1396501200, 1.4923900000000001, 1.4947999999999999, 1.4837400000000001, 1.4838100000000001);
INSERT INTO "OHLCData" VALUES (1328, 37, '2014-04-04 00:00:00 ', 1396587600, 1.4837899999999999, 1.4851300000000001, 1.4694, 1.47454);
INSERT INTO "OHLCData" VALUES (1329, 37, '2014-04-06 17:00:00 ', 1396821600, 1.47519, 1.4767399999999999, 1.47363, 1.47668);
INSERT INTO "OHLCData" VALUES (1330, 37, '2014-04-07 00:00:00 ', 1396846800, 1.4766699999999999, 1.48498, 1.4756499999999999, 1.4805200000000001);
INSERT INTO "OHLCData" VALUES (1331, 37, '2014-04-08 00:00:00 ', 1396933200, 1.48051, 1.4806299999999999, 1.4689000000000001, 1.47105);
INSERT INTO "OHLCData" VALUES (1332, 37, '2014-04-09 00:00:00 ', 1397019600, 1.4710700000000001, 1.4781899999999999, 1.46784, 1.4723200000000001);
INSERT INTO "OHLCData" VALUES (1333, 37, '2014-04-10 00:00:00 ', 1397106000, 1.4722999999999999, 1.48339, 1.46519, 1.4807900000000001);
INSERT INTO "OHLCData" VALUES (1334, 37, '2014-04-11 00:00:00 ', 1397192400, 1.48081, 1.4833799999999999, 1.4735100000000001, 1.47763);
INSERT INTO "OHLCData" VALUES (1335, 37, '2014-04-13 17:00:00 ', 1397426400, 1.4741500000000001, 1.4765999999999999, 1.4714400000000001, 1.4739100000000001);
INSERT INTO "OHLCData" VALUES (1336, 37, '2014-04-14 00:00:00 ', 1397451600, 1.4739199999999999, 1.4752099999999999, 1.4659199999999999, 1.47119);
INSERT INTO "OHLCData" VALUES (1337, 37, '2014-04-15 00:00:00 ', 1397538000, 1.4712099999999999, 1.4797800000000001, 1.4684299999999999, 1.4757100000000001);
INSERT INTO "OHLCData" VALUES (1338, 37, '2014-04-16 00:00:00 ', 1397624400, 1.4757, 1.4817899999999999, 1.47163, 1.47597);
INSERT INTO "OHLCData" VALUES (1339, 37, '2014-04-17 00:00:00 ', 1397710800, 1.47593, 1.48359, 1.47587, 1.4801899999999999);
INSERT INTO "OHLCData" VALUES (1340, 37, '2014-04-18 00:00:00 ', 1397797200, 1.4802, 1.48119, 1.47892, 1.4797199999999999);
INSERT INTO "OHLCData" VALUES (1341, 37, '2014-04-20 17:00:00 ', 1398031200, 1.47933, 1.4817800000000001, 1.4786600000000001, 1.48068);
INSERT INTO "OHLCData" VALUES (1342, 37, '2014-04-21 00:00:00 ', 1398056400, 1.4806900000000001, 1.4822500000000001, 1.4735499999999999, 1.47485);
INSERT INTO "OHLCData" VALUES (1343, 37, '2014-04-22 00:00:00 ', 1398142800, 1.4748399999999999, 1.4890399999999999, 1.4717100000000001, 1.48794);
INSERT INTO "OHLCData" VALUES (1344, 37, '2014-04-23 00:00:00 ', 1398229200, 1.48793, 1.49275, 1.4855499999999999, 1.48742);
INSERT INTO "OHLCData" VALUES (1345, 37, '2014-04-24 00:00:00 ', 1398315600, 1.4874000000000001, 1.4943, 1.48617, 1.4914000000000001);
INSERT INTO "OHLCData" VALUES (1346, 37, '2014-04-25 00:00:00 ', 1398402000, 1.49139, 1.49356, 1.48769, 1.49089);
INSERT INTO "OHLCData" VALUES (1347, 37, '2014-04-27 17:00:00 ', 1398636000, 1.4924500000000001, 1.4929300000000001, 1.4878800000000001, 1.4894799999999999);
INSERT INTO "OHLCData" VALUES (1348, 37, '2014-04-28 00:00:00 ', 1398661200, 1.4894700000000001, 1.5019800000000001, 1.4853400000000001, 1.49874);
INSERT INTO "OHLCData" VALUES (1349, 37, '2014-04-29 00:00:00 ', 1398747600, 1.4987299999999999, 1.50173, 1.4866299999999999, 1.4873499999999999);
INSERT INTO "OHLCData" VALUES (1350, 37, '2014-04-30 00:00:00 ', 1398834000, 1.48736, 1.49786, 1.48265, 1.4932399999999999);
INSERT INTO "OHLCData" VALUES (1351, 37, '2014-05-01 00:00:00 ', 1398920400, 1.4932399999999999, 1.4980199999999999, 1.4909600000000001, 1.49444);
INSERT INTO "OHLCData" VALUES (1352, 37, '2014-05-02 00:00:00 ', 1399006800, 1.4944299999999999, 1.50149, 1.49336, 1.49499);
INSERT INTO "OHLCData" VALUES (1353, 37, '2014-05-04 17:00:00 ', 1399240800, 1.4948699999999999, 1.49943, 1.4932799999999999, 1.4982899999999999);
INSERT INTO "OHLCData" VALUES (1354, 37, '2014-05-05 00:00:00 ', 1399266000, 1.4982800000000001, 1.49918, 1.4931700000000001, 1.49492);
INSERT INTO "OHLCData" VALUES (1355, 37, '2014-05-06 00:00:00 ', 1399352400, 1.49491, 1.49739, 1.4860800000000001, 1.4902500000000001);
INSERT INTO "OHLCData" VALUES (1356, 37, '2014-05-07 00:00:00 ', 1399438800, 1.4902299999999999, 1.49393, 1.4843299999999999, 1.48489);
INSERT INTO "OHLCData" VALUES (1357, 37, '2014-05-08 00:00:00 ', 1399525200, 1.48485, 1.49057, 1.47573, 1.47767);
INSERT INTO "OHLCData" VALUES (1358, 37, '2014-05-09 00:00:00 ', 1399611600, 1.4776800000000001, 1.4798199999999999, 1.46879, 1.46966);
INSERT INTO "OHLCData" VALUES (1359, 37, '2014-05-11 17:00:00 ', 1399845600, 1.4688699999999999, 1.4708699999999999, 1.4682999999999999, 1.46909);
INSERT INTO "OHLCData" VALUES (1360, 37, '2014-05-12 00:00:00 ', 1399870800, 1.46912, 1.4714799999999999, 1.46671, 1.4703599999999999);
INSERT INTO "OHLCData" VALUES (1361, 37, '2014-05-13 00:00:00 ', 1399957200, 1.47041, 1.4748399999999999, 1.45926, 1.4598199999999999);
INSERT INTO "OHLCData" VALUES (1362, 37, '2014-05-14 00:00:00 ', 1400043600, 1.45983, 1.46522, 1.4572499999999999, 1.46434);
INSERT INTO "OHLCData" VALUES (1363, 37, '2014-05-15 00:00:00 ', 1400130000, 1.4643999999999999, 1.46913, 1.4562999999999999, 1.46566);
INSERT INTO "OHLCData" VALUES (1364, 37, '2014-05-16 00:00:00 ', 1400216400, 1.46567, 1.47, 1.4615199999999999, 1.46244);
INSERT INTO "OHLCData" VALUES (1365, 37, '2014-05-18 17:00:00 ', 1400450400, 1.46065, 1.4641299999999999, 1.4605600000000001, 1.46346);
INSERT INTO "OHLCData" VALUES (1366, 37, '2014-05-19 00:00:00 ', 1400475600, 1.46347, 1.4748300000000001, 1.46309, 1.4740899999999999);
INSERT INTO "OHLCData" VALUES (1367, 37, '2014-05-20 00:00:00 ', 1400562000, 1.4741200000000001, 1.4867999999999999, 1.4735400000000001, 1.4837499999999999);
INSERT INTO "OHLCData" VALUES (1368, 37, '2014-05-21 00:00:00 ', 1400648400, 1.4837400000000001, 1.48719, 1.4751300000000001, 1.4751300000000001);
INSERT INTO "OHLCData" VALUES (1369, 37, '2014-05-22 00:00:00 ', 1400734800, 1.4751399999999999, 1.4812099999999999, 1.4736800000000001, 1.4764600000000001);
INSERT INTO "OHLCData" VALUES (1370, 37, '2014-05-23 00:00:00 ', 1400821200, 1.47645, 1.4789099999999999, 1.4743200000000001, 1.47631);
INSERT INTO "OHLCData" VALUES (1371, 37, '2014-05-25 17:00:00 ', 1401055200, 1.4748699999999999, 1.4757899999999999, 1.47387, 1.47441);
INSERT INTO "OHLCData" VALUES (1372, 37, '2014-05-26 00:00:00 ', 1401080400, 1.4743900000000001, 1.4774799999999999, 1.4738, 1.4749000000000001);
INSERT INTO "OHLCData" VALUES (1373, 37, '2014-05-27 00:00:00 ', 1401166800, 1.47492, 1.4756100000000001, 1.47106, 1.4724600000000001);
INSERT INTO "OHLCData" VALUES (1374, 37, '2014-05-28 00:00:00 ', 1401253200, 1.4724699999999999, 1.47604, 1.4650399999999999, 1.4666399999999999);
INSERT INTO "OHLCData" VALUES (1375, 37, '2014-05-29 00:00:00 ', 1401339600, 1.46665, 1.46715, 1.4591499999999999, 1.46001);
INSERT INTO "OHLCData" VALUES (1376, 37, '2014-05-30 00:00:00 ', 1401426000, 1.45997, 1.46756, 1.45807, 1.46377);
INSERT INTO "OHLCData" VALUES (1377, 37, '2014-06-02 15:02:00 ', 1401739320, 1.47028, 1.47356, 1.4690700000000001, 1.4704999999999999);
INSERT INTO "OHLCData" VALUES (1378, 37, '2014-06-03 00:00:00 ', 1401771600, 1.4704900000000001, 1.47431, 1.4640200000000001, 1.46885);
INSERT INTO "OHLCData" VALUES (1379, 37, '2014-06-04 00:00:00 ', 1401858000, 1.46889, 1.4706399999999999, 1.46452, 1.4646399999999999);
INSERT INTO "OHLCData" VALUES (1380, 37, '2014-06-05 00:00:00 ', 1401944400, 1.46465, 1.4674499999999999, 1.45103, 1.4632400000000001);
INSERT INTO "OHLCData" VALUES (1381, 37, '2014-06-06 00:00:00 ', 1402030800, 1.46323, 1.46414, 1.45618, 1.4615400000000001);
INSERT INTO "OHLCData" VALUES (1382, 37, '2014-06-08 17:00:00 ', 1402264800, 1.4608699999999999, 1.4618199999999999, 1.45828, 1.45878);
INSERT INTO "OHLCData" VALUES (1383, 37, '2014-06-09 00:00:00 ', 1402290000, 1.4588000000000001, 1.46072, 1.4513400000000001, 1.4520599999999999);
INSERT INTO "OHLCData" VALUES (1384, 37, '2014-06-10 00:00:00 ', 1402376400, 1.45198, 1.4525699999999999, 1.4407000000000001, 1.44143);
INSERT INTO "OHLCData" VALUES (1385, 37, '2014-06-11 00:00:00 ', 1402462800, 1.4414, 1.4455499999999999, 1.43781, 1.4445300000000001);
INSERT INTO "OHLCData" VALUES (1386, 37, '2014-06-12 00:00:00 ', 1402549200, 1.4444999999999999, 1.44496, 1.4357800000000001, 1.43981);
INSERT INTO "OHLCData" VALUES (1387, 37, '2014-06-13 00:00:00 ', 1402635600, 1.4398299999999999, 1.44617, 1.43862, 1.4401999999999999);
INSERT INTO "OHLCData" VALUES (1388, 37, '2014-06-15 17:00:00 ', 1402869600, 1.44116, 1.4428700000000001, 1.43916, 1.44015);
INSERT INTO "OHLCData" VALUES (1389, 37, '2014-06-16 00:00:00 ', 1402894800, 1.4400999999999999, 1.4499200000000001, 1.43841, 1.4490099999999999);
INSERT INTO "OHLCData" VALUES (1390, 37, '2014-06-17 00:00:00 ', 1402981200, 1.44902, 1.45242, 1.4482699999999999, 1.45075);
INSERT INTO "OHLCData" VALUES (1391, 37, '2014-06-18 00:00:00 ', 1403067600, 1.45079, 1.4535400000000001, 1.4442900000000001, 1.44526);
INSERT INTO "OHLCData" VALUES (1392, 37, '2014-06-19 00:00:00 ', 1403154000, 1.4452499999999999, 1.44933, 1.44442, 1.4471799999999999);
INSERT INTO "OHLCData" VALUES (1393, 37, '2014-06-20 00:00:00 ', 1403240400, 1.4471700000000001, 1.44913, 1.4446399999999999, 1.4482900000000001);
INSERT INTO "OHLCData" VALUES (1394, 37, '2014-06-22 17:00:00 ', 1403474400, 1.44906, 1.44983, 1.44011, 1.4412);
INSERT INTO "OHLCData" VALUES (1395, 37, '2014-06-23 00:00:00 ', 1403499600, 1.44119, 1.4446600000000001, 1.43801, 1.4423600000000001);
INSERT INTO "OHLCData" VALUES (1396, 37, '2014-06-24 00:00:00 ', 1403586000, 1.44235, 1.4541299999999999, 1.4418500000000001, 1.4530400000000001);
INSERT INTO "OHLCData" VALUES (1397, 37, '2014-06-25 00:00:00 ', 1403672400, 1.45303, 1.4550099999999999, 1.4474100000000001, 1.4499299999999999);
INSERT INTO "OHLCData" VALUES (1398, 37, '2014-06-26 00:00:00 ', 1403758800, 1.44994, 1.4505999999999999, 1.4434800000000001, 1.44364);
INSERT INTO "OHLCData" VALUES (1399, 37, '2014-06-27 00:00:00 ', 1403845200, 1.4436100000000001, 1.44943, 1.44319, 1.44783);
INSERT INTO "OHLCData" VALUES (1400, 37, '2014-06-29 17:00:00 ', 1404079200, 1.4478500000000001, 1.45007, 1.44743, 1.4483699999999999);
INSERT INTO "OHLCData" VALUES (1401, 37, '2014-06-30 00:00:00 ', 1404104400, 1.44841, 1.45461, 1.4470499999999999, 1.4529300000000001);
INSERT INTO "OHLCData" VALUES (1402, 37, '2014-07-01 00:00:00 ', 1404190800, 1.45292, 1.4535, 1.43977, 1.4452799999999999);
INSERT INTO "OHLCData" VALUES (1403, 37, '2014-07-02 00:00:00 ', 1404277200, 1.4452700000000001, 1.4560900000000001, 1.44336, 1.4554499999999999);
INSERT INTO "OHLCData" VALUES (1404, 37, '2014-07-03 00:00:00 ', 1404363600, 1.45549, 1.46008, 1.4532, 1.45373);
INSERT INTO "OHLCData" VALUES (1405, 37, '2014-07-04 00:00:00 ', 1404450000, 1.4537500000000001, 1.45444, 1.45058, 1.45147);
INSERT INTO "OHLCData" VALUES (1406, 37, '2014-07-06 17:00:00 ', 1404684000, 1.45164, 1.4536800000000001, 1.4511499999999999, 1.4516100000000001);
INSERT INTO "OHLCData" VALUES (1407, 37, '2014-07-07 00:00:00 ', 1404709200, 1.4516, 1.45262, 1.44807, 1.4494100000000001);
INSERT INTO "OHLCData" VALUES (1408, 37, '2014-07-08 00:00:00 ', 1404795600, 1.44939, 1.4499899999999999, 1.44468, 1.4484399999999999);
INSERT INTO "OHLCData" VALUES (1409, 37, '2014-07-09 00:00:00 ', 1404882000, 1.44845, 1.452, 1.44326, 1.4513799999999999);
INSERT INTO "OHLCData" VALUES (1410, 37, '2014-07-10 00:00:00 ', 1404968400, 1.45139, 1.4558, 1.44736, 1.4480999999999999);
INSERT INTO "OHLCData" VALUES (1411, 37, '2014-07-11 00:00:00 ', 1405054800, 1.4480900000000001, 1.45042, 1.4450400000000001, 1.44899);
INSERT INTO "OHLCData" VALUES (1412, 37, '2014-07-13 17:00:00 ', 1405288800, 1.4500299999999999, 1.45055, 1.4464300000000001, 1.4477599999999999);
INSERT INTO "OHLCData" VALUES (1413, 37, '2014-07-14 00:00:00 ', 1405314000, 1.44777, 1.4515899999999999, 1.4464399999999999, 1.44895);
INSERT INTO "OHLCData" VALUES (1414, 37, '2014-07-15 00:00:00 ', 1405400400, 1.4489700000000001, 1.45442, 1.44652, 1.4515800000000001);
INSERT INTO "OHLCData" VALUES (1415, 37, '2014-07-16 00:00:00 ', 1405486800, 1.45156, 1.4530000000000001, 1.4432700000000001, 1.44546);
INSERT INTO "OHLCData" VALUES (1416, 37, '2014-07-17 00:00:00 ', 1405573200, 1.44547, 1.4481900000000001, 1.4407799999999999, 1.44502);
INSERT INTO "OHLCData" VALUES (1417, 37, '2014-07-18 00:00:00 ', 1405659600, 1.4450000000000001, 1.4451499999999999, 1.4372499999999999, 1.4394899999999999);
INSERT INTO "OHLCData" VALUES (1418, 37, '2014-07-20 17:00:00 ', 1405893600, 1.4401200000000001, 1.4416, 1.4389700000000001, 1.4407399999999999);
INSERT INTO "OHLCData" VALUES (1419, 37, '2014-07-21 00:00:00 ', 1405918800, 1.44072, 1.4444699999999999, 1.43964, 1.44137);
INSERT INTO "OHLCData" VALUES (1420, 37, '2014-07-22 00:00:00 ', 1406005200, 1.4413800000000001, 1.44164, 1.4258500000000001, 1.4275100000000001);
INSERT INTO "OHLCData" VALUES (1421, 37, '2014-07-23 00:00:00 ', 1406091600, 1.4275199999999999, 1.42784, 1.4211100000000001, 1.4232);
INSERT INTO "OHLCData" VALUES (1422, 37, '2014-07-24 00:00:00 ', 1406178000, 1.4232100000000001, 1.43208, 1.4229000000000001, 1.43085);
INSERT INTO "OHLCData" VALUES (1423, 37, '2014-07-25 00:00:00 ', 1406264400, 1.4308399999999999, 1.4316800000000001, 1.42628, 1.42909);
INSERT INTO "OHLCData" VALUES (1424, 37, '2014-07-27 17:00:00 ', 1406498400, 1.4293800000000001, 1.4305300000000001, 1.42815, 1.4297);
INSERT INTO "OHLCData" VALUES (1425, 37, '2014-07-28 00:00:00 ', 1406523600, 1.4297200000000001, 1.43102, 1.427, 1.42974);
INSERT INTO "OHLCData" VALUES (1426, 37, '2014-07-29 00:00:00 ', 1406610000, 1.4297299999999999, 1.4312, 1.42825, 1.42909);
INSERT INTO "OHLCData" VALUES (1427, 37, '2014-07-30 00:00:00 ', 1406696400, 1.4291199999999999, 1.4392199999999999, 1.42835, 1.4368099999999999);
INSERT INTO "OHLCData" VALUES (1428, 37, '2014-07-31 00:00:00 ', 1406782800, 1.43682, 1.4418299999999999, 1.4362999999999999, 1.44021);
INSERT INTO "OHLCData" VALUES (1429, 37, '2014-08-01 00:00:00 ', 1406869200, 1.4402299999999999, 1.4444600000000001, 1.4395199999999999, 1.4414400000000001);
INSERT INTO "OHLCData" VALUES (1430, 37, '2014-08-03 17:00:00 ', 1407103200, 1.44241, 1.4426399999999999, 1.4382900000000001, 1.4397599999999999);
INSERT INTO "OHLCData" VALUES (1431, 37, '2014-08-04 00:00:00 ', 1407128400, 1.43977, 1.4416899999999999, 1.4370700000000001, 1.4392400000000001);
INSERT INTO "OHLCData" VALUES (1432, 37, '2014-08-05 00:00:00 ', 1407214800, 1.4392199999999999, 1.44015, 1.43364, 1.43689);
INSERT INTO "OHLCData" VALUES (1433, 37, '2014-08-06 00:00:00 ', 1407301200, 1.4368799999999999, 1.4422600000000001, 1.42703, 1.44129);
INSERT INTO "OHLCData" VALUES (1434, 37, '2014-08-07 00:00:00 ', 1407387600, 1.4412799999999999, 1.4452400000000001, 1.43845, 1.44411);
INSERT INTO "OHLCData" VALUES (1435, 37, '2014-08-08 00:00:00 ', 1407474000, 1.4440999999999999, 1.4476500000000001, 1.44234, 1.4452199999999999);
INSERT INTO "OHLCData" VALUES (1436, 37, '2014-08-10 17:00:00 ', 1407708000, 1.4456599999999999, 1.4457500000000001, 1.44285, 1.44353);
INSERT INTO "OHLCData" VALUES (1437, 37, '2014-08-11 00:00:00 ', 1407733200, 1.44354, 1.4461599999999999, 1.44259, 1.4431799999999999);
INSERT INTO "OHLCData" VALUES (1438, 37, '2014-08-12 00:00:00 ', 1407819600, 1.44319, 1.4447700000000001, 1.43896, 1.4399299999999999);
INSERT INTO "OHLCData" VALUES (1439, 37, '2014-08-13 00:00:00 ', 1407906000, 1.4399200000000001, 1.4402699999999999, 1.4353899999999999, 1.4370000000000001);
INSERT INTO "OHLCData" VALUES (1440, 37, '2014-08-14 00:00:00 ', 1407992400, 1.43699, 1.4381999999999999, 1.43279, 1.4331);
INSERT INTO "OHLCData" VALUES (1441, 37, '2014-08-15 00:00:00 ', 1408078800, 1.4331199999999999, 1.4403900000000001, 1.4318299999999999, 1.43726);
INSERT INTO "OHLCData" VALUES (1442, 37, '2014-08-17 17:00:00 ', 1408312800, 1.4375899999999999, 1.43858, 1.43618, 1.4370799999999999);
INSERT INTO "OHLCData" VALUES (1443, 37, '2014-08-18 00:00:00 ', 1408338000, 1.4370499999999999, 1.43727, 1.4294899999999999, 1.43035);
INSERT INTO "OHLCData" VALUES (1444, 37, '2014-08-19 00:00:00 ', 1408424400, 1.4303600000000001, 1.43408, 1.4269400000000001, 1.4324399999999999);
INSERT INTO "OHLCData" VALUES (1445, 37, '2014-08-20 00:00:00 ', 1408510800, 1.43238, 1.4335899999999999, 1.42588, 1.43163);
INSERT INTO "OHLCData" VALUES (1446, 37, '2014-08-21 00:00:00 ', 1408597200, 1.43164, 1.43248, 1.42475, 1.4259200000000001);
INSERT INTO "OHLCData" VALUES (1447, 37, '2014-08-22 00:00:00 ', 1408683600, 1.42591, 1.42632, 1.4197599999999999, 1.4211800000000001);


--
-- TOC entry 1951 (class 0 OID 106543)
-- Dependencies: 172
-- Data for Name: OHLCDataSets; Type: TABLE DATA; Schema: pm; Owner: PerlMongers
--

INSERT INTO "OHLCDataSets" VALUES (37, 'EURAUD_daily', 'EURAUD', 1440);


--
-- TOC entry 1963 (class 0 OID 0)
-- Dependencies: 171
-- Name: OHLCDataSets_OHLCDataSetID_seq; Type: SEQUENCE SET; Schema: pm; Owner: PerlMongers
--

SELECT pg_catalog.setval('"OHLCDataSets_OHLCDataSetID_seq"', 1, false);


--
-- TOC entry 1964 (class 0 OID 0)
-- Dependencies: 173
-- Name: OHLCData_ohlc_id_seq; Type: SEQUENCE SET; Schema: pm; Owner: PerlMongers
--

SELECT pg_catalog.setval('"OHLCData_ohlc_id_seq"', 1447, true);


--
-- TOC entry 1835 (class 2606 OID 106548)
-- Name: OHLCDataSets_pkey; Type: CONSTRAINT; Schema: pm; Owner: PerlMongers; Tablespace: 
--

ALTER TABLE ONLY "OHLCDataSets"
    ADD CONSTRAINT "OHLCDataSets_pkey" PRIMARY KEY ("OHLCDataSetID");


--
-- TOC entry 1839 (class 2606 OID 106560)
-- Name: OHLCData_OHLCDataSetID_Date; Type: CONSTRAINT; Schema: pm; Owner: PerlMongers; Tablespace: 
--

ALTER TABLE ONLY "OHLCData"
    ADD CONSTRAINT "OHLCData_OHLCDataSetID_Date" UNIQUE ("OHLCDataSetID", "Date");


--
-- TOC entry 1841 (class 2606 OID 106558)
-- Name: OHLCData_pkey; Type: CONSTRAINT; Schema: pm; Owner: PerlMongers; Tablespace: 
--

ALTER TABLE ONLY "OHLCData"
    ADD CONSTRAINT "OHLCData_pkey" PRIMARY KEY (ohlc_id);


--
-- TOC entry 1836 (class 1259 OID 106566)
-- Name: Date; Type: INDEX; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE INDEX "Date" ON "OHLCData" USING btree ("Date");


--
-- TOC entry 1837 (class 1259 OID 106567)
-- Name: EpochTime; Type: INDEX; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE INDEX "EpochTime" ON "OHLCData" USING btree ("EpochTime");


--
-- TOC entry 1832 (class 1259 OID 106549)
-- Name: Name; Type: INDEX; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE UNIQUE INDEX "Name" ON "OHLCDataSets" USING btree ("Name");


--
-- TOC entry 1833 (class 1259 OID 106550)
-- Name: OHLCDataSets_Pair_period; Type: INDEX; Schema: pm; Owner: PerlMongers; Tablespace: 
--

CREATE INDEX "OHLCDataSets_Pair_period" ON "OHLCDataSets" USING btree ("Pair", period);


--
-- TOC entry 1842 (class 2606 OID 106561)
-- Name: OHLCData_OHLCDataSetID_fkey; Type: FK CONSTRAINT; Schema: pm; Owner: PerlMongers
--

ALTER TABLE ONLY "OHLCData"
    ADD CONSTRAINT "OHLCData_OHLCDataSetID_fkey" FOREIGN KEY ("OHLCDataSetID") REFERENCES "OHLCDataSets"("OHLCDataSetID");


--
-- TOC entry 1958 (class 0 OID 0)
-- Dependencies: 7
-- Name: pm; Type: ACL; Schema: -; Owner: PerlMongers
--

REVOKE ALL ON SCHEMA pm FROM PUBLIC;
REVOKE ALL ON SCHEMA pm FROM "PerlMongers";
GRANT ALL ON SCHEMA pm TO "PerlMongers";
GRANT ALL ON SCHEMA pm TO PUBLIC;


--
-- TOC entry 1959 (class 0 OID 0)
-- Dependencies: 174
-- Name: OHLCData; Type: ACL; Schema: pm; Owner: PerlMongers
--

REVOKE ALL ON TABLE "OHLCData" FROM PUBLIC;


--
-- TOC entry 1960 (class 0 OID 0)
-- Dependencies: 172
-- Name: OHLCDataSets; Type: ACL; Schema: pm; Owner: PerlMongers
--

REVOKE ALL ON TABLE "OHLCDataSets" FROM PUBLIC;


-- Completed on 2014-11-01 14:12:27

--
-- PostgreSQL database dump complete
--

